// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/api/serviceusage/v1/serviceusage.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fapi_2fserviceusage_2fv1_2fserviceusage_2eproto__INCLUDED
#define GRPC_google_2fapi_2fserviceusage_2fv1_2fserviceusage_2eproto__INCLUDED

#include "google/api/serviceusage/v1/serviceusage.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace api {
namespace serviceusage {
namespace v1 {

// Enables services that service consumers want to use on Google Cloud Platform,
// lists the available or enabled services, or disables services that service
// consumers no longer use.
//
// See [Service Usage API](https://cloud.google.com/service-usage/docs/overview)
class ServiceUsage final {
 public:
  static constexpr char const* service_full_name() {
    return "google.api.serviceusage.v1.ServiceUsage";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Enable a service so that it can be used with a project.
    virtual ::grpc::Status EnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncEnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncEnableServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncEnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncEnableServiceRaw(context, request, cq));
    }
    // Disable a service so that it can no longer be used with a project.
    // This prevents unintended usage that may cause unexpected billing
    // charges or security leaks.
    //
    // It is not valid to call the disable method on a service that is not
    // currently enabled. Callers will receive a `FAILED_PRECONDITION` status if
    // the target service is not currently enabled.
    virtual ::grpc::Status DisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDisableServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDisableServiceRaw(context, request, cq));
    }
    // Returns the service configuration and enabled state for a given service.
    virtual ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::google::api::serviceusage::v1::Service* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::Service>> AsyncGetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::Service>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::Service>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::Service>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    // List all services available to the specified project, and the current
    // state of those services with respect to the project. The list includes
    // all public services, all services for which the calling user has the
    // `servicemanagement.services.bind` permission, and all services that have
    // already been enabled on the project. The list can be filtered to
    // only include services in a specific state, for example to only include
    // services enabled on the project.
    //
    // WARNING: If you need to query enabled services frequently or across
    // an organization, you should use
    // [Cloud Asset Inventory
    // API](https://cloud.google.com/asset-inventory/docs/apis), which provides
    // higher throughput and richer filtering capability.
    virtual ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::google::api::serviceusage::v1::ListServicesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    // Enable multiple services on a project. The operation is atomic: if enabling
    // any service fails, then the entire batch fails, and no state changes occur.
    // To enable a single service, use the `EnableService` method instead.
    virtual ::grpc::Status BatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchEnableServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchEnableServicesRaw(context, request, cq));
    }
    // Returns the service configurations and enabled states for a given list of
    // services.
    virtual ::grpc::Status BatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::BatchGetServicesResponse>> AsyncBatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::BatchGetServicesResponse>>(AsyncBatchGetServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::BatchGetServicesResponse>> PrepareAsyncBatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::BatchGetServicesResponse>>(PrepareAsyncBatchGetServicesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Enable a service so that it can be used with a project.
      virtual void EnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void EnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Disable a service so that it can no longer be used with a project.
      // This prevents unintended usage that may cause unexpected billing
      // charges or security leaks.
      //
      // It is not valid to call the disable method on a service that is not
      // currently enabled. Callers will receive a `FAILED_PRECONDITION` status if
      // the target service is not currently enabled.
      virtual void DisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the service configuration and enabled state for a given service.
      virtual void GetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest* request, ::google::api::serviceusage::v1::Service* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest* request, ::google::api::serviceusage::v1::Service* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // List all services available to the specified project, and the current
      // state of those services with respect to the project. The list includes
      // all public services, all services for which the calling user has the
      // `servicemanagement.services.bind` permission, and all services that have
      // already been enabled on the project. The list can be filtered to
      // only include services in a specific state, for example to only include
      // services enabled on the project.
      //
      // WARNING: If you need to query enabled services frequently or across
      // an organization, you should use
      // [Cloud Asset Inventory
      // API](https://cloud.google.com/asset-inventory/docs/apis), which provides
      // higher throughput and richer filtering capability.
      virtual void ListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest* request, ::google::api::serviceusage::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest* request, ::google::api::serviceusage::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Enable multiple services on a project. The operation is atomic: if enabling
      // any service fails, then the entire batch fails, and no state changes occur.
      // To enable a single service, use the `EnableService` method instead.
      virtual void BatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the service configurations and enabled states for a given list of
      // services.
      virtual void BatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest* request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest* request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncEnableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncEnableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDisableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDisableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::Service>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::Service>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchEnableServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchEnableServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::BatchGetServicesResponse>* AsyncBatchGetServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::serviceusage::v1::BatchGetServicesResponse>* PrepareAsyncBatchGetServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status EnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncEnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncEnableServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncEnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncEnableServiceRaw(context, request, cq));
    }
    ::grpc::Status DisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDisableServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDisableServiceRaw(context, request, cq));
    }
    ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::google::api::serviceusage::v1::Service* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::Service>> AsyncGetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::Service>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::Service>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::Service>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::google::api::serviceusage::v1::ListServicesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    ::grpc::Status BatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchEnableServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchEnableServicesRaw(context, request, cq));
    }
    ::grpc::Status BatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::BatchGetServicesResponse>> AsyncBatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::BatchGetServicesResponse>>(AsyncBatchGetServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::BatchGetServicesResponse>> PrepareAsyncBatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::BatchGetServicesResponse>>(PrepareAsyncBatchGetServicesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void EnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void EnableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DisableService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest* request, ::google::api::serviceusage::v1::Service* response, std::function<void(::grpc::Status)>) override;
      void GetService(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest* request, ::google::api::serviceusage::v1::Service* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest* request, ::google::api::serviceusage::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest* request, ::google::api::serviceusage::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchEnableServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest* request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchGetServices(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest* request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncEnableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncEnableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDisableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDisableServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::Service>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::Service>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchEnableServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchEnableServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::BatchGetServicesResponse>* AsyncBatchGetServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::serviceusage::v1::BatchGetServicesResponse>* PrepareAsyncBatchGetServicesRaw(::grpc::ClientContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_EnableService_;
    const ::grpc::internal::RpcMethod rpcmethod_DisableService_;
    const ::grpc::internal::RpcMethod rpcmethod_GetService_;
    const ::grpc::internal::RpcMethod rpcmethod_ListServices_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchEnableServices_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchGetServices_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Enable a service so that it can be used with a project.
    virtual ::grpc::Status EnableService(::grpc::ServerContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest* request, ::google::longrunning::Operation* response);
    // Disable a service so that it can no longer be used with a project.
    // This prevents unintended usage that may cause unexpected billing
    // charges or security leaks.
    //
    // It is not valid to call the disable method on a service that is not
    // currently enabled. Callers will receive a `FAILED_PRECONDITION` status if
    // the target service is not currently enabled.
    virtual ::grpc::Status DisableService(::grpc::ServerContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest* request, ::google::longrunning::Operation* response);
    // Returns the service configuration and enabled state for a given service.
    virtual ::grpc::Status GetService(::grpc::ServerContext* context, const ::google::api::serviceusage::v1::GetServiceRequest* request, ::google::api::serviceusage::v1::Service* response);
    // List all services available to the specified project, and the current
    // state of those services with respect to the project. The list includes
    // all public services, all services for which the calling user has the
    // `servicemanagement.services.bind` permission, and all services that have
    // already been enabled on the project. The list can be filtered to
    // only include services in a specific state, for example to only include
    // services enabled on the project.
    //
    // WARNING: If you need to query enabled services frequently or across
    // an organization, you should use
    // [Cloud Asset Inventory
    // API](https://cloud.google.com/asset-inventory/docs/apis), which provides
    // higher throughput and richer filtering capability.
    virtual ::grpc::Status ListServices(::grpc::ServerContext* context, const ::google::api::serviceusage::v1::ListServicesRequest* request, ::google::api::serviceusage::v1::ListServicesResponse* response);
    // Enable multiple services on a project. The operation is atomic: if enabling
    // any service fails, then the entire batch fails, and no state changes occur.
    // To enable a single service, use the `EnableService` method instead.
    virtual ::grpc::Status BatchEnableServices(::grpc::ServerContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* request, ::google::longrunning::Operation* response);
    // Returns the service configurations and enabled states for a given list of
    // services.
    virtual ::grpc::Status BatchGetServices(::grpc::ServerContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest* request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_EnableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_EnableService() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_EnableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::EnableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEnableService(::grpc::ServerContext* context, ::google::api::serviceusage::v1::EnableServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DisableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DisableService() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_DisableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::DisableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDisableService(::grpc::ServerContext* context, ::google::api::serviceusage::v1::DisableServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetService() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::GetServiceRequest* /*request*/, ::google::api::serviceusage::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::google::api::serviceusage::v1::GetServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::serviceusage::v1::Service>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServices() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::ListServicesRequest* /*request*/, ::google::api::serviceusage::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::google::api::serviceusage::v1::ListServicesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::serviceusage::v1::ListServicesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchEnableServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchEnableServices() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_BatchEnableServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchEnableServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchEnableServices(::grpc::ServerContext* context, ::google::api::serviceusage::v1::BatchEnableServicesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchGetServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchGetServices() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_BatchGetServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchGetServicesRequest* /*request*/, ::google::api::serviceusage::v1::BatchGetServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchGetServices(::grpc::ServerContext* context, ::google::api::serviceusage::v1::BatchGetServicesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::serviceusage::v1::BatchGetServicesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_EnableService<WithAsyncMethod_DisableService<WithAsyncMethod_GetService<WithAsyncMethod_ListServices<WithAsyncMethod_BatchEnableServices<WithAsyncMethod_BatchGetServices<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_EnableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_EnableService() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::EnableServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::serviceusage::v1::EnableServiceRequest* request, ::google::longrunning::Operation* response) { return this->EnableService(context, request, response); }));}
    void SetMessageAllocatorFor_EnableService(
        ::grpc::MessageAllocator< ::google::api::serviceusage::v1::EnableServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::EnableServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_EnableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::EnableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EnableService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::serviceusage::v1::EnableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DisableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DisableService() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::DisableServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::serviceusage::v1::DisableServiceRequest* request, ::google::longrunning::Operation* response) { return this->DisableService(context, request, response); }));}
    void SetMessageAllocatorFor_DisableService(
        ::grpc::MessageAllocator< ::google::api::serviceusage::v1::DisableServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::DisableServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DisableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::DisableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DisableService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::serviceusage::v1::DisableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::GetServiceRequest, ::google::api::serviceusage::v1::Service>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::serviceusage::v1::GetServiceRequest* request, ::google::api::serviceusage::v1::Service* response) { return this->GetService(context, request, response); }));}
    void SetMessageAllocatorFor_GetService(
        ::grpc::MessageAllocator< ::google::api::serviceusage::v1::GetServiceRequest, ::google::api::serviceusage::v1::Service>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::GetServiceRequest, ::google::api::serviceusage::v1::Service>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::GetServiceRequest* /*request*/, ::google::api::serviceusage::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::serviceusage::v1::GetServiceRequest* /*request*/, ::google::api::serviceusage::v1::Service* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::ListServicesRequest, ::google::api::serviceusage::v1::ListServicesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::serviceusage::v1::ListServicesRequest* request, ::google::api::serviceusage::v1::ListServicesResponse* response) { return this->ListServices(context, request, response); }));}
    void SetMessageAllocatorFor_ListServices(
        ::grpc::MessageAllocator< ::google::api::serviceusage::v1::ListServicesRequest, ::google::api::serviceusage::v1::ListServicesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::ListServicesRequest, ::google::api::serviceusage::v1::ListServicesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::ListServicesRequest* /*request*/, ::google::api::serviceusage::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::serviceusage::v1::ListServicesRequest* /*request*/, ::google::api::serviceusage::v1::ListServicesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchEnableServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchEnableServices() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::BatchEnableServicesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* request, ::google::longrunning::Operation* response) { return this->BatchEnableServices(context, request, response); }));}
    void SetMessageAllocatorFor_BatchEnableServices(
        ::grpc::MessageAllocator< ::google::api::serviceusage::v1::BatchEnableServicesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::BatchEnableServicesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchEnableServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchEnableServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchEnableServices(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchGetServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchGetServices() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::BatchGetServicesRequest, ::google::api::serviceusage::v1::BatchGetServicesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::serviceusage::v1::BatchGetServicesRequest* request, ::google::api::serviceusage::v1::BatchGetServicesResponse* response) { return this->BatchGetServices(context, request, response); }));}
    void SetMessageAllocatorFor_BatchGetServices(
        ::grpc::MessageAllocator< ::google::api::serviceusage::v1::BatchGetServicesRequest, ::google::api::serviceusage::v1::BatchGetServicesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::serviceusage::v1::BatchGetServicesRequest, ::google::api::serviceusage::v1::BatchGetServicesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchGetServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchGetServicesRequest* /*request*/, ::google::api::serviceusage::v1::BatchGetServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchGetServices(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchGetServicesRequest* /*request*/, ::google::api::serviceusage::v1::BatchGetServicesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_EnableService<WithCallbackMethod_DisableService<WithCallbackMethod_GetService<WithCallbackMethod_ListServices<WithCallbackMethod_BatchEnableServices<WithCallbackMethod_BatchGetServices<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_EnableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_EnableService() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_EnableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::EnableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DisableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DisableService() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_DisableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::DisableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetService() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::GetServiceRequest* /*request*/, ::google::api::serviceusage::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServices() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::ListServicesRequest* /*request*/, ::google::api::serviceusage::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchEnableServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchEnableServices() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_BatchEnableServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchEnableServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchGetServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchGetServices() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_BatchGetServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchGetServicesRequest* /*request*/, ::google::api::serviceusage::v1::BatchGetServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_EnableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_EnableService() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_EnableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::EnableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEnableService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DisableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DisableService() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_DisableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::DisableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDisableService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetService() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::GetServiceRequest* /*request*/, ::google::api::serviceusage::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServices() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::ListServicesRequest* /*request*/, ::google::api::serviceusage::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchEnableServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchEnableServices() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_BatchEnableServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchEnableServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchEnableServices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchGetServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchGetServices() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_BatchGetServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchGetServicesRequest* /*request*/, ::google::api::serviceusage::v1::BatchGetServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchGetServices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_EnableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_EnableService() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->EnableService(context, request, response); }));
    }
    ~WithRawCallbackMethod_EnableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EnableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::EnableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EnableService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DisableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DisableService() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DisableService(context, request, response); }));
    }
    ~WithRawCallbackMethod_DisableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DisableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::DisableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DisableService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetService(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::GetServiceRequest* /*request*/, ::google::api::serviceusage::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServices(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::ListServicesRequest* /*request*/, ::google::api::serviceusage::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchEnableServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchEnableServices() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchEnableServices(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchEnableServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchEnableServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchEnableServices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchGetServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchGetServices() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchGetServices(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchGetServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchGetServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchGetServicesRequest* /*request*/, ::google::api::serviceusage::v1::BatchGetServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchGetServices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_EnableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_EnableService() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::serviceusage::v1::EnableServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::serviceusage::v1::EnableServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedEnableService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_EnableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status EnableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::EnableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedEnableService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::serviceusage::v1::EnableServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DisableService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DisableService() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::serviceusage::v1::DisableServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::serviceusage::v1::DisableServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDisableService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DisableService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DisableService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::DisableServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDisableService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::serviceusage::v1::DisableServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetService() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::serviceusage::v1::GetServiceRequest, ::google::api::serviceusage::v1::Service>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::serviceusage::v1::GetServiceRequest, ::google::api::serviceusage::v1::Service>* streamer) {
                       return this->StreamedGetService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::GetServiceRequest* /*request*/, ::google::api::serviceusage::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::serviceusage::v1::GetServiceRequest,::google::api::serviceusage::v1::Service>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServices() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::serviceusage::v1::ListServicesRequest, ::google::api::serviceusage::v1::ListServicesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::serviceusage::v1::ListServicesRequest, ::google::api::serviceusage::v1::ListServicesResponse>* streamer) {
                       return this->StreamedListServices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::ListServicesRequest* /*request*/, ::google::api::serviceusage::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::serviceusage::v1::ListServicesRequest,::google::api::serviceusage::v1::ListServicesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchEnableServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchEnableServices() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::serviceusage::v1::BatchEnableServicesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::serviceusage::v1::BatchEnableServicesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchEnableServices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchEnableServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchEnableServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchEnableServicesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchEnableServices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::serviceusage::v1::BatchEnableServicesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchGetServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchGetServices() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::serviceusage::v1::BatchGetServicesRequest, ::google::api::serviceusage::v1::BatchGetServicesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::serviceusage::v1::BatchGetServicesRequest, ::google::api::serviceusage::v1::BatchGetServicesResponse>* streamer) {
                       return this->StreamedBatchGetServices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchGetServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchGetServices(::grpc::ServerContext* /*context*/, const ::google::api::serviceusage::v1::BatchGetServicesRequest* /*request*/, ::google::api::serviceusage::v1::BatchGetServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchGetServices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::serviceusage::v1::BatchGetServicesRequest,::google::api::serviceusage::v1::BatchGetServicesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_EnableService<WithStreamedUnaryMethod_DisableService<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_BatchEnableServices<WithStreamedUnaryMethod_BatchGetServices<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_EnableService<WithStreamedUnaryMethod_DisableService<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_BatchEnableServices<WithStreamedUnaryMethod_BatchGetServices<Service > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace serviceusage
}  // namespace api
}  // namespace google


#endif  // GRPC_google_2fapi_2fserviceusage_2fv1_2fserviceusage_2eproto__INCLUDED
