// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/prediction_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_PREDICTION_LOGGING_DECORATOR_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_PREDICTION_LOGGING_DECORATOR_H

#include "google/cloud/aiplatform/v1/internal/prediction_stub.h"
#include "google/cloud/tracing_options.h"
#include "google/cloud/version.h"
#include <memory>
#include <set>
#include <string>

namespace google {
namespace cloud {
namespace aiplatform_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class PredictionServiceLogging : public PredictionServiceStub {
 public:
  ~PredictionServiceLogging() override = default;
  PredictionServiceLogging(std::shared_ptr<PredictionServiceStub> child,
                           TracingOptions tracing_options,
                           std::set<std::string> const& components);

  StatusOr<google::cloud::aiplatform::v1::PredictResponse> Predict(
      grpc::ClientContext& context,
      google::cloud::aiplatform::v1::PredictRequest const& request) override;

  StatusOr<google::api::HttpBody> RawPredict(
      grpc::ClientContext& context,
      google::cloud::aiplatform::v1::RawPredictRequest const& request) override;

  std::unique_ptr<google::cloud::internal::StreamingReadRpc<
      google::cloud::aiplatform::v1::StreamingPredictResponse>>
  ServerStreamingPredict(
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::aiplatform::v1::StreamingPredictRequest const& request)
      override;

  StatusOr<google::cloud::aiplatform::v1::ExplainResponse> Explain(
      grpc::ClientContext& context,
      google::cloud::aiplatform::v1::ExplainRequest const& request) override;

 private:
  std::shared_ptr<PredictionServiceStub> child_;
  TracingOptions tracing_options_;
  bool stream_logging_;
};  // PredictionServiceLogging

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_PREDICTION_LOGGING_DECORATOR_H
