// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/v2/document.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fv2_2fdocument_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fv2_2fdocument_2eproto__INCLUDED

#include "google/cloud/dialogflow/v2/document.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dialogflow {
namespace v2 {

// Service for managing knowledge
// [Documents][google.cloud.dialogflow.v2.Document].
class Documents final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.v2.Documents";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns the list of all documents of the knowledge base.
    virtual ::grpc::Status ListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListDocumentsResponse>> AsyncListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListDocumentsResponse>>(AsyncListDocumentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListDocumentsResponse>> PrepareAsyncListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListDocumentsResponse>>(PrepareAsyncListDocumentsRaw(context, request, cq));
    }
    // Retrieves the specified document.
    virtual ::grpc::Status GetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::google::cloud::dialogflow::v2::Document* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::Document>> AsyncGetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::Document>>(AsyncGetDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::Document>> PrepareAsyncGetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::Document>>(PrepareAsyncGetDocumentRaw(context, request, cq));
    }
    // Creates a new document.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    virtual ::grpc::Status CreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateDocumentRaw(context, request, cq));
    }
    // Creates documents by importing data from external sources.
    // Dialogflow supports up to 350 documents in each request. If you try to
    // import more, Dialogflow will return an error.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`:
    // [ImportDocumentsResponse][google.cloud.dialogflow.v2.ImportDocumentsResponse]
    virtual ::grpc::Status ImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportDocumentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportDocumentsRaw(context, request, cq));
    }
    // Deletes the specified document.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status DeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteDocumentRaw(context, request, cq));
    }
    // Updates the specified document.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    virtual ::grpc::Status UpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateDocumentRaw(context, request, cq));
    }
    // Reloads the specified document from its specified source, content_uri or
    // content. The previously loaded content of the document will be deleted.
    // Note: Even when the content of the document has not changed, there still
    // may be side effects because of internal implementation changes.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    //
    // Note: The `projects.agent.knowledgeBases.documents` resource is deprecated;
    // only use `projects.knowledgeBases.documents`.
    virtual ::grpc::Status ReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncReloadDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncReloadDocumentRaw(context, request, cq));
    }
    // Exports a smart messaging candidate document into the specified
    // destination.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    virtual ::grpc::Status ExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportDocumentRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Returns the list of all documents of the knowledge base.
      virtual void ListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the specified document.
      virtual void GetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest* request, ::google::cloud::dialogflow::v2::Document* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest* request, ::google::cloud::dialogflow::v2::Document* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new document.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
      // - `response`: [Document][google.cloud.dialogflow.v2.Document]
      virtual void CreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates documents by importing data from external sources.
      // Dialogflow supports up to 350 documents in each request. If you try to
      // import more, Dialogflow will return an error.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
      // - `response`:
      // [ImportDocumentsResponse][google.cloud.dialogflow.v2.ImportDocumentsResponse]
      virtual void ImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified document.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      virtual void DeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified document.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
      // - `response`: [Document][google.cloud.dialogflow.v2.Document]
      virtual void UpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Reloads the specified document from its specified source, content_uri or
      // content. The previously loaded content of the document will be deleted.
      // Note: Even when the content of the document has not changed, there still
      // may be side effects because of internal implementation changes.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
      // - `response`: [Document][google.cloud.dialogflow.v2.Document]
      //
      // Note: The `projects.agent.knowledgeBases.documents` resource is deprecated;
      // only use `projects.knowledgeBases.documents`.
      virtual void ReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports a smart messaging candidate document into the specified
      // destination.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
      // - `response`: [Document][google.cloud.dialogflow.v2.Document]
      virtual void ExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListDocumentsResponse>* AsyncListDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListDocumentsResponse>* PrepareAsyncListDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::Document>* AsyncGetDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::Document>* PrepareAsyncGetDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncReloadDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncReloadDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListDocumentsResponse>> AsyncListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListDocumentsResponse>>(AsyncListDocumentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListDocumentsResponse>> PrepareAsyncListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListDocumentsResponse>>(PrepareAsyncListDocumentsRaw(context, request, cq));
    }
    ::grpc::Status GetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::google::cloud::dialogflow::v2::Document* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::Document>> AsyncGetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::Document>>(AsyncGetDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::Document>> PrepareAsyncGetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::Document>>(PrepareAsyncGetDocumentRaw(context, request, cq));
    }
    ::grpc::Status CreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateDocumentRaw(context, request, cq));
    }
    ::grpc::Status ImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportDocumentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportDocumentsRaw(context, request, cq));
    }
    ::grpc::Status DeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteDocumentRaw(context, request, cq));
    }
    ::grpc::Status UpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateDocumentRaw(context, request, cq));
    }
    ::grpc::Status ReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncReloadDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncReloadDocumentRaw(context, request, cq));
    }
    ::grpc::Status ExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportDocumentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportDocumentRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest* request, ::google::cloud::dialogflow::v2::Document* response, std::function<void(::grpc::Status)>) override;
      void GetDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest* request, ::google::cloud::dialogflow::v2::Document* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportDocuments(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ReloadDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportDocument(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListDocumentsResponse>* AsyncListDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListDocumentsResponse>* PrepareAsyncListDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::Document>* AsyncGetDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::Document>* PrepareAsyncGetDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportDocumentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncReloadDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncReloadDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportDocumentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListDocuments_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDocument_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDocument_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportDocuments_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDocument_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDocument_;
    const ::grpc::internal::RpcMethod rpcmethod_ReloadDocument_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportDocument_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns the list of all documents of the knowledge base.
    virtual ::grpc::Status ListDocuments(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response);
    // Retrieves the specified document.
    virtual ::grpc::Status GetDocument(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest* request, ::google::cloud::dialogflow::v2::Document* response);
    // Creates a new document.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    virtual ::grpc::Status CreateDocument(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* request, ::google::longrunning::Operation* response);
    // Creates documents by importing data from external sources.
    // Dialogflow supports up to 350 documents in each request. If you try to
    // import more, Dialogflow will return an error.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`:
    // [ImportDocumentsResponse][google.cloud.dialogflow.v2.ImportDocumentsResponse]
    virtual ::grpc::Status ImportDocuments(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* request, ::google::longrunning::Operation* response);
    // Deletes the specified document.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status DeleteDocument(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* request, ::google::longrunning::Operation* response);
    // Updates the specified document.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    virtual ::grpc::Status UpdateDocument(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* request, ::google::longrunning::Operation* response);
    // Reloads the specified document from its specified source, content_uri or
    // content. The previously loaded content of the document will be deleted.
    // Note: Even when the content of the document has not changed, there still
    // may be side effects because of internal implementation changes.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    //
    // Note: The `projects.agent.knowledgeBases.documents` resource is deprecated;
    // only use `projects.knowledgeBases.documents`.
    virtual ::grpc::Status ReloadDocument(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* request, ::google::longrunning::Operation* response);
    // Exports a smart messaging candidate document into the specified
    // destination.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/cx/docs/how/long-running-operation).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [KnowledgeOperationMetadata][google.cloud.dialogflow.v2.KnowledgeOperationMetadata]
    // - `response`: [Document][google.cloud.dialogflow.v2.Document]
    virtual ::grpc::Status ExportDocument(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDocuments() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListDocumentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDocuments(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::ListDocumentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::ListDocumentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDocument() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetDocumentRequest* /*request*/, ::google::cloud::dialogflow::v2::Document* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDocument(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::GetDocumentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::Document>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDocument() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDocument(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::CreateDocumentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportDocuments() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ImportDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportDocuments(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::ImportDocumentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDocument() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDocument(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::DeleteDocumentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDocument() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UpdateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDocument(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::UpdateDocumentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReloadDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReloadDocument() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ReloadDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReloadDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReloadDocument(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::ReloadDocumentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportDocument() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ExportDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDocument(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::ExportDocumentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListDocuments<WithAsyncMethod_GetDocument<WithAsyncMethod_CreateDocument<WithAsyncMethod_ImportDocuments<WithAsyncMethod_DeleteDocument<WithAsyncMethod_UpdateDocument<WithAsyncMethod_ReloadDocument<WithAsyncMethod_ExportDocument<Service > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDocuments() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListDocumentsRequest, ::google::cloud::dialogflow::v2::ListDocumentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* request, ::google::cloud::dialogflow::v2::ListDocumentsResponse* response) { return this->ListDocuments(context, request, response); }));}
    void SetMessageAllocatorFor_ListDocuments(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::ListDocumentsRequest, ::google::cloud::dialogflow::v2::ListDocumentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListDocumentsRequest, ::google::cloud::dialogflow::v2::ListDocumentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListDocumentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDocuments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListDocumentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDocument() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetDocumentRequest, ::google::cloud::dialogflow::v2::Document>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::GetDocumentRequest* request, ::google::cloud::dialogflow::v2::Document* response) { return this->GetDocument(context, request, response); }));}
    void SetMessageAllocatorFor_GetDocument(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::GetDocumentRequest, ::google::cloud::dialogflow::v2::Document>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetDocumentRequest, ::google::cloud::dialogflow::v2::Document>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetDocumentRequest* /*request*/, ::google::cloud::dialogflow::v2::Document* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetDocumentRequest* /*request*/, ::google::cloud::dialogflow::v2::Document* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDocument() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateDocumentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* request, ::google::longrunning::Operation* response) { return this->CreateDocument(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDocument(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::CreateDocumentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateDocumentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportDocuments() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ImportDocumentsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* request, ::google::longrunning::Operation* response) { return this->ImportDocuments(context, request, response); }));}
    void SetMessageAllocatorFor_ImportDocuments(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::ImportDocumentsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ImportDocumentsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportDocuments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDocument() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeleteDocumentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* request, ::google::longrunning::Operation* response) { return this->DeleteDocument(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDocument(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::DeleteDocumentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeleteDocumentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDocument() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::UpdateDocumentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* request, ::google::longrunning::Operation* response) { return this->UpdateDocument(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDocument(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::UpdateDocumentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::UpdateDocumentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReloadDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReloadDocument() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ReloadDocumentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* request, ::google::longrunning::Operation* response) { return this->ReloadDocument(context, request, response); }));}
    void SetMessageAllocatorFor_ReloadDocument(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::ReloadDocumentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ReloadDocumentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReloadDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReloadDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReloadDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ExportDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportDocument() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ExportDocumentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* request, ::google::longrunning::Operation* response) { return this->ExportDocument(context, request, response); }));}
    void SetMessageAllocatorFor_ExportDocument(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::ExportDocumentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ExportDocumentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListDocuments<WithCallbackMethod_GetDocument<WithCallbackMethod_CreateDocument<WithCallbackMethod_ImportDocuments<WithCallbackMethod_DeleteDocument<WithCallbackMethod_UpdateDocument<WithCallbackMethod_ReloadDocument<WithCallbackMethod_ExportDocument<Service > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDocuments() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListDocumentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDocument() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetDocumentRequest* /*request*/, ::google::cloud::dialogflow::v2::Document* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDocument() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportDocuments() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ImportDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDocument() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDocument() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UpdateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReloadDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReloadDocument() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ReloadDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReloadDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportDocument() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ExportDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDocuments() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListDocumentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDocuments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDocument() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetDocumentRequest* /*request*/, ::google::cloud::dialogflow::v2::Document* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDocument() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportDocuments() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ImportDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportDocuments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDocument() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDocument() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UpdateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReloadDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReloadDocument() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ReloadDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReloadDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReloadDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportDocument() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ExportDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDocument(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDocuments() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDocuments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListDocumentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDocuments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDocument() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetDocumentRequest* /*request*/, ::google::cloud::dialogflow::v2::Document* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDocument() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportDocuments() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportDocuments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportDocuments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDocument() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDocument() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReloadDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReloadDocument() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReloadDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReloadDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReloadDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReloadDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportDocument() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportDocument(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportDocument(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDocuments() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::ListDocumentsRequest, ::google::cloud::dialogflow::v2::ListDocumentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::ListDocumentsRequest, ::google::cloud::dialogflow::v2::ListDocumentsResponse>* streamer) {
                       return this->StreamedListDocuments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListDocumentsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListDocumentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDocuments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::ListDocumentsRequest,::google::cloud::dialogflow::v2::ListDocumentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDocument() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::GetDocumentRequest, ::google::cloud::dialogflow::v2::Document>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::GetDocumentRequest, ::google::cloud::dialogflow::v2::Document>* streamer) {
                       return this->StreamedGetDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetDocumentRequest* /*request*/, ::google::cloud::dialogflow::v2::Document* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::GetDocumentRequest,::google::cloud::dialogflow::v2::Document>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDocument() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::CreateDocumentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::CreateDocumentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::CreateDocumentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportDocuments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportDocuments() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::ImportDocumentsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::ImportDocumentsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportDocuments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportDocuments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportDocuments(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ImportDocumentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportDocuments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::ImportDocumentsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDocument() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::DeleteDocumentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::DeleteDocumentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::DeleteDocumentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDocument() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::UpdateDocumentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::UpdateDocumentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::UpdateDocumentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReloadDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReloadDocument() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::ReloadDocumentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::ReloadDocumentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedReloadDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReloadDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReloadDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ReloadDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReloadDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::ReloadDocumentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportDocument : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportDocument() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::ExportDocumentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::ExportDocumentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedExportDocument(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportDocument() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportDocument(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ExportDocumentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportDocument(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::ExportDocumentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListDocuments<WithStreamedUnaryMethod_GetDocument<WithStreamedUnaryMethod_CreateDocument<WithStreamedUnaryMethod_ImportDocuments<WithStreamedUnaryMethod_DeleteDocument<WithStreamedUnaryMethod_UpdateDocument<WithStreamedUnaryMethod_ReloadDocument<WithStreamedUnaryMethod_ExportDocument<Service > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListDocuments<WithStreamedUnaryMethod_GetDocument<WithStreamedUnaryMethod_CreateDocument<WithStreamedUnaryMethod_ImportDocuments<WithStreamedUnaryMethod_DeleteDocument<WithStreamedUnaryMethod_UpdateDocument<WithStreamedUnaryMethod_ReloadDocument<WithStreamedUnaryMethod_ExportDocument<Service > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdialogflow_2fv2_2fdocument_2eproto__INCLUDED
