// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/v2/entity_type.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fv2_2fentity_5ftype_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fv2_2fentity_5ftype_2eproto__INCLUDED

#include "google/cloud/dialogflow/v2/entity_type.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace dialogflow {
namespace v2 {

// Service for managing [EntityTypes][google.cloud.dialogflow.v2.EntityType].
class EntityTypes final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.v2.EntityTypes";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns the list of all entity types in the specified agent.
    virtual ::grpc::Status ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>> AsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>>(AsyncListEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>> PrepareAsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>>(PrepareAsyncListEntityTypesRaw(context, request, cq));
    }
    // Retrieves the specified entity type.
    virtual ::grpc::Status GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::google::cloud::dialogflow::v2::EntityType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>> AsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>>(AsyncGetEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>> PrepareAsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>>(PrepareAsyncGetEntityTypeRaw(context, request, cq));
    }
    // Creates an entity type in the specified agent.
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::google::cloud::dialogflow::v2::EntityType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>> AsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>>(AsyncCreateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>> PrepareAsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>>(PrepareAsyncCreateEntityTypeRaw(context, request, cq));
    }
    // Updates the specified entity type.
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::google::cloud::dialogflow::v2::EntityType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>> AsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>>(AsyncUpdateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>> PrepareAsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>>(PrepareAsyncUpdateEntityTypeRaw(context, request, cq));
    }
    // Deletes the specified entity type.
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntityTypeRaw(context, request, cq));
    }
    // Updates/Creates multiple entity types in the specified agent.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`:
    // [BatchUpdateEntityTypesResponse][google.cloud.dialogflow.v2.BatchUpdateEntityTypesResponse]
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    // Deletes entity types in the specified agent.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    // Creates multiple new entities in the specified entity type.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    // Updates or creates multiple entities in the specified entity type. This
    // method does not affect entities in the entity type that aren't explicitly
    // specified in the request.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    //
    virtual ::grpc::Status BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    // Deletes entities in the specified entity type.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Returns the list of all entity types in the specified agent.
      virtual void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the specified entity type.
      virtual void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an entity type in the specified agent.
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      virtual void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified entity type.
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      virtual void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified entity type.
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      virtual void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates/Creates multiple entity types in the specified agent.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`: An empty [Struct
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
      // - `response`:
      // [BatchUpdateEntityTypesResponse][google.cloud.dialogflow.v2.BatchUpdateEntityTypesResponse]
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      virtual void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes entity types in the specified agent.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`: An empty [Struct
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      virtual void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates multiple new entities in the specified entity type.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`: An empty [Struct
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      virtual void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates or creates multiple entities in the specified entity type. This
      // method does not affect entities in the entity type that aren't explicitly
      // specified in the request.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`: An empty [Struct
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      //
      virtual void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes entities in the specified entity type.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`: An empty [Struct
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      //
      // Note: You should always train an agent prior to sending it queries. See the
      // [training
      // documentation](https://cloud.google.com/dialogflow/es/docs/training).
      virtual void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>* AsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>* PrepareAsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>* AsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>* PrepareAsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>* AsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>* PrepareAsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>* AsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::EntityType>* PrepareAsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>> AsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>>(AsyncListEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>> PrepareAsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>>(PrepareAsyncListEntityTypesRaw(context, request, cq));
    }
    ::grpc::Status GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::google::cloud::dialogflow::v2::EntityType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>> AsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>>(AsyncGetEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>> PrepareAsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>>(PrepareAsyncGetEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::google::cloud::dialogflow::v2::EntityType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>> AsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>>(AsyncCreateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>> PrepareAsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>>(PrepareAsyncCreateEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::google::cloud::dialogflow::v2::EntityType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>> AsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>>(AsyncUpdateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>> PrepareAsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>>(PrepareAsyncUpdateEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    ::grpc::Status BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    ::grpc::Status BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    ::grpc::Status BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, std::function<void(::grpc::Status)>) override;
      void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, std::function<void(::grpc::Status)>) override;
      void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, std::function<void(::grpc::Status)>) override;
      void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>* AsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>* PrepareAsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>* AsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>* PrepareAsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>* AsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>* PrepareAsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>* AsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::EntityType>* PrepareAsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListEntityTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchUpdateEntityTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeleteEntityTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchCreateEntities_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchUpdateEntities_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeleteEntities_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns the list of all entity types in the specified agent.
    virtual ::grpc::Status ListEntityTypes(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response);
    // Retrieves the specified entity type.
    virtual ::grpc::Status GetEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response);
    // Creates an entity type in the specified agent.
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status CreateEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response);
    // Updates the specified entity type.
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status UpdateEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response);
    // Deletes the specified entity type.
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status DeleteEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response);
    // Updates/Creates multiple entity types in the specified agent.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`:
    // [BatchUpdateEntityTypesResponse][google.cloud.dialogflow.v2.BatchUpdateEntityTypesResponse]
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response);
    // Deletes entity types in the specified agent.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response);
    // Creates multiple new entities in the specified entity type.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchCreateEntities(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response);
    // Updates or creates multiple entities in the specified entity type. This
    // method does not affect entities in the entity type that aren't explicitly
    // specified in the request.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    //
    virtual ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response);
    // Deletes entities in the specified entity type.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`: An empty [Struct
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#struct)
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    //
    // Note: You should always train an agent prior to sending it queries. See the
    // [training
    // documentation](https://cloud.google.com/dialogflow/es/docs/training).
    virtual ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntityTypes(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::ListEntityTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::ListEntityTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEntityType() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::GetEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::EntityType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::EntityType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::EntityType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntityTypes(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntityTypes(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateEntities(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntities(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntities(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListEntityTypes<WithAsyncMethod_GetEntityType<WithAsyncMethod_CreateEntityType<WithAsyncMethod_UpdateEntityType<WithAsyncMethod_DeleteEntityType<WithAsyncMethod_BatchUpdateEntityTypes<WithAsyncMethod_BatchDeleteEntityTypes<WithAsyncMethod_BatchCreateEntities<WithAsyncMethod_BatchUpdateEntities<WithAsyncMethod_BatchDeleteEntities<Service > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListEntityTypesRequest, ::google::cloud::dialogflow::v2::ListEntityTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* response) { return this->ListEntityTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListEntityTypes(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::ListEntityTypesRequest, ::google::cloud::dialogflow::v2::ListEntityTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListEntityTypesRequest, ::google::cloud::dialogflow::v2::ListEntityTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntityTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEntityType() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response) { return this->GetEntityType(context, request, response); }));}
    void SetMessageAllocatorFor_GetEntityType(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::GetEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response) { return this->CreateEntityType(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEntityType(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2::EntityType* response) { return this->UpdateEntityType(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateEntityType(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response) { return this->DeleteEntityType(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEntityType(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response) { return this->BatchUpdateEntityTypes(context, request, response); }));}
    void SetMessageAllocatorFor_BatchUpdateEntityTypes(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateEntityTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response) { return this->BatchDeleteEntityTypes(context, request, response); }));}
    void SetMessageAllocatorFor_BatchDeleteEntityTypes(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteEntityTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response) { return this->BatchCreateEntities(context, request, response); }));}
    void SetMessageAllocatorFor_BatchCreateEntities(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response) { return this->BatchUpdateEntities(context, request, response); }));}
    void SetMessageAllocatorFor_BatchUpdateEntities(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response) { return this->BatchDeleteEntities(context, request, response); }));}
    void SetMessageAllocatorFor_BatchDeleteEntities(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListEntityTypes<WithCallbackMethod_GetEntityType<WithCallbackMethod_CreateEntityType<WithCallbackMethod_UpdateEntityType<WithCallbackMethod_DeleteEntityType<WithCallbackMethod_BatchUpdateEntityTypes<WithCallbackMethod_BatchDeleteEntityTypes<WithCallbackMethod_BatchCreateEntities<WithCallbackMethod_BatchUpdateEntities<WithCallbackMethod_BatchDeleteEntities<Service > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEntityType() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntityTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEntityType() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntityTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntityTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateEntities(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntities(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntities(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEntityTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntityTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEntityType() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEntityType(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEntityType(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateEntityType(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEntityType(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntityType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchUpdateEntityTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateEntityTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchDeleteEntityTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteEntityTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchCreateEntities(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchUpdateEntities(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchDeleteEntities(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteEntities(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::ListEntityTypesRequest, ::google::cloud::dialogflow::v2::ListEntityTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::ListEntityTypesRequest, ::google::cloud::dialogflow::v2::ListEntityTypesResponse>* streamer) {
                       return this->StreamedListEntityTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEntityTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::ListEntityTypesRequest,::google::cloud::dialogflow::v2::ListEntityTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEntityType() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::GetEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::GetEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>* streamer) {
                       return this->StreamedGetEntityType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::GetEntityTypeRequest,::google::cloud::dialogflow::v2::EntityType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>* streamer) {
                       return this->StreamedCreateEntityType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::CreateEntityTypeRequest,::google::cloud::dialogflow::v2::EntityType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2::EntityType>* streamer) {
                       return this->StreamedUpdateEntityType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::UpdateEntityTypeRequest,::google::cloud::dialogflow::v2::EntityType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteEntityType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::DeleteEntityTypeRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchUpdateEntityTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchUpdateEntityTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::BatchUpdateEntityTypesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchDeleteEntityTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeleteEntityTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::BatchDeleteEntityTypesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchCreateEntities(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchCreateEntities(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::BatchCreateEntitiesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchUpdateEntities(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchUpdateEntities(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::BatchUpdateEntitiesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchDeleteEntities(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeleteEntities(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::BatchDeleteEntitiesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListEntityTypes<WithStreamedUnaryMethod_GetEntityType<WithStreamedUnaryMethod_CreateEntityType<WithStreamedUnaryMethod_UpdateEntityType<WithStreamedUnaryMethod_DeleteEntityType<WithStreamedUnaryMethod_BatchUpdateEntityTypes<WithStreamedUnaryMethod_BatchDeleteEntityTypes<WithStreamedUnaryMethod_BatchCreateEntities<WithStreamedUnaryMethod_BatchUpdateEntities<WithStreamedUnaryMethod_BatchDeleteEntities<Service > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListEntityTypes<WithStreamedUnaryMethod_GetEntityType<WithStreamedUnaryMethod_CreateEntityType<WithStreamedUnaryMethod_UpdateEntityType<WithStreamedUnaryMethod_DeleteEntityType<WithStreamedUnaryMethod_BatchUpdateEntityTypes<WithStreamedUnaryMethod_BatchDeleteEntityTypes<WithStreamedUnaryMethod_BatchCreateEntities<WithStreamedUnaryMethod_BatchUpdateEntities<WithStreamedUnaryMethod_BatchDeleteEntities<Service > > > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdialogflow_2fv2_2fentity_5ftype_2eproto__INCLUDED
