// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/managedidentities/v1/managed_identities_service.proto
// Original file comments:
// Copyright 2019 Google LLC.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
//
#ifndef GRPC_google_2fcloud_2fmanagedidentities_2fv1_2fmanaged_5fidentities_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fmanagedidentities_2fv1_2fmanaged_5fidentities_5fservice_2eproto__INCLUDED

#include "google/cloud/managedidentities/v1/managed_identities_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace managedidentities {
namespace v1 {

// API Overview
//
// The `managedidentites.googleapis.com` service implements the Google Cloud
// Managed Identites API for identity services
// (e.g. Microsoft Active Directory).
//
// The Managed Identities service provides methods to manage
// (create/read/update/delete) domains, reset managed identities admin password,
// add/remove domain controllers in GCP regions and add/remove VPC peering.
//
// Data Model
//
// The Managed Identities service exposes the following resources:
//
// * Locations as global, named as follows:
//   `projects/{project_id}/locations/global`.
//
// * Domains, named as follows:
//   `/projects/{project_id}/locations/global/domain/{domain_name}`.
//
// The `{domain_name}` refers to fully qualified domain name in the customer
// project e.g. mydomain.myorganization.com, with the following restrictions:
//
//  * Must contain only lowercase letters, numbers, periods and hyphens.
//  * Must start with a letter.
//  * Must contain between 2-64 characters.
//  * Must end with a number or a letter.
//  * Must not start with period.
//  * First segement length (mydomain form example above) shouldn't exceed
//    15 chars.
//  * The last segment cannot be fully numeric.
//  * Must be unique within the customer project.
class ManagedIdentitiesService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.managedidentities.v1.ManagedIdentitiesService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a Microsoft AD domain.
    virtual ::grpc::Status CreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateMicrosoftAdDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateMicrosoftAdDomainRaw(context, request, cq));
    }
    // Resets a domain's administrator password.
    virtual ::grpc::Status ResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>> AsyncResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>>(AsyncResetAdminPasswordRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>> PrepareAsyncResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>>(PrepareAsyncResetAdminPasswordRaw(context, request, cq));
    }
    // Lists domains in a project.
    virtual ::grpc::Status ListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ListDomainsResponse>> AsyncListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ListDomainsResponse>>(AsyncListDomainsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ListDomainsResponse>> PrepareAsyncListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ListDomainsResponse>>(PrepareAsyncListDomainsRaw(context, request, cq));
    }
    // Gets information about a domain.
    virtual ::grpc::Status GetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::google::cloud::managedidentities::v1::Domain* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::Domain>> AsyncGetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::Domain>>(AsyncGetDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::Domain>> PrepareAsyncGetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::Domain>>(PrepareAsyncGetDomainRaw(context, request, cq));
    }
    // Updates the metadata and configuration of a domain.
    virtual ::grpc::Status UpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateDomainRaw(context, request, cq));
    }
    // Deletes a domain.
    virtual ::grpc::Status DeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteDomainRaw(context, request, cq));
    }
    // Adds an AD trust to a domain.
    virtual ::grpc::Status AttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAttachTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAttachTrustRaw(context, request, cq));
    }
    // Updates the DNS conditional forwarder.
    virtual ::grpc::Status ReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncReconfigureTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncReconfigureTrustRaw(context, request, cq));
    }
    // Removes an AD trust.
    virtual ::grpc::Status DetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDetachTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDetachTrustRaw(context, request, cq));
    }
    // Validates a trust state, that the target domain is reachable, and that the
    // target domain is able to accept incoming trust requests.
    virtual ::grpc::Status ValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncValidateTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncValidateTrustRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a Microsoft AD domain.
      virtual void CreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets a domain's administrator password.
      virtual void ResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists domains in a project.
      virtual void ListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest* request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest* request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information about a domain.
      virtual void GetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest* request, ::google::cloud::managedidentities::v1::Domain* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest* request, ::google::cloud::managedidentities::v1::Domain* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the metadata and configuration of a domain.
      virtual void UpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a domain.
      virtual void DeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds an AD trust to a domain.
      virtual void AttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the DNS conditional forwarder.
      virtual void ReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Removes an AD trust.
      virtual void DetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Validates a trust state, that the target domain is reachable, and that the
      // target domain is able to accept incoming trust requests.
      virtual void ValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateMicrosoftAdDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateMicrosoftAdDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* AsyncResetAdminPasswordRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* PrepareAsyncResetAdminPasswordRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ListDomainsResponse>* AsyncListDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::ListDomainsResponse>* PrepareAsyncListDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::Domain>* AsyncGetDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::managedidentities::v1::Domain>* PrepareAsyncGetDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAttachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAttachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncReconfigureTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncReconfigureTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDetachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDetachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncValidateTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncValidateTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateMicrosoftAdDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateMicrosoftAdDomainRaw(context, request, cq));
    }
    ::grpc::Status ResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>> AsyncResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>>(AsyncResetAdminPasswordRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>> PrepareAsyncResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>>(PrepareAsyncResetAdminPasswordRaw(context, request, cq));
    }
    ::grpc::Status ListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ListDomainsResponse>> AsyncListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ListDomainsResponse>>(AsyncListDomainsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ListDomainsResponse>> PrepareAsyncListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ListDomainsResponse>>(PrepareAsyncListDomainsRaw(context, request, cq));
    }
    ::grpc::Status GetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::google::cloud::managedidentities::v1::Domain* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::Domain>> AsyncGetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::Domain>>(AsyncGetDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::Domain>> PrepareAsyncGetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::Domain>>(PrepareAsyncGetDomainRaw(context, request, cq));
    }
    ::grpc::Status UpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateDomainRaw(context, request, cq));
    }
    ::grpc::Status DeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteDomainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteDomainRaw(context, request, cq));
    }
    ::grpc::Status AttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAttachTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAttachTrustRaw(context, request, cq));
    }
    ::grpc::Status ReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncReconfigureTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncReconfigureTrustRaw(context, request, cq));
    }
    ::grpc::Status DetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDetachTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDetachTrustRaw(context, request, cq));
    }
    ::grpc::Status ValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncValidateTrustRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncValidateTrustRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateMicrosoftAdDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response, std::function<void(::grpc::Status)>) override;
      void ResetAdminPassword(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest* request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDomains(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest* request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest* request, ::google::cloud::managedidentities::v1::Domain* response, std::function<void(::grpc::Status)>) override;
      void GetDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest* request, ::google::cloud::managedidentities::v1::Domain* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteDomain(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AttachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ReconfigureTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DetachTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ValidateTrust(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateMicrosoftAdDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateMicrosoftAdDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* AsyncResetAdminPasswordRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* PrepareAsyncResetAdminPasswordRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ListDomainsResponse>* AsyncListDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::ListDomainsResponse>* PrepareAsyncListDomainsRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::Domain>* AsyncGetDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::managedidentities::v1::Domain>* PrepareAsyncGetDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteDomainRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAttachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAttachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncReconfigureTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncReconfigureTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDetachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDetachTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncValidateTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncValidateTrustRaw(::grpc::ClientContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateMicrosoftAdDomain_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetAdminPassword_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDomains_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDomain_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDomain_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDomain_;
    const ::grpc::internal::RpcMethod rpcmethod_AttachTrust_;
    const ::grpc::internal::RpcMethod rpcmethod_ReconfigureTrust_;
    const ::grpc::internal::RpcMethod rpcmethod_DetachTrust_;
    const ::grpc::internal::RpcMethod rpcmethod_ValidateTrust_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a Microsoft AD domain.
    virtual ::grpc::Status CreateMicrosoftAdDomain(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* request, ::google::longrunning::Operation* response);
    // Resets a domain's administrator password.
    virtual ::grpc::Status ResetAdminPassword(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response);
    // Lists domains in a project.
    virtual ::grpc::Status ListDomains(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest* request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response);
    // Gets information about a domain.
    virtual ::grpc::Status GetDomain(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest* request, ::google::cloud::managedidentities::v1::Domain* response);
    // Updates the metadata and configuration of a domain.
    virtual ::grpc::Status UpdateDomain(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* request, ::google::longrunning::Operation* response);
    // Deletes a domain.
    virtual ::grpc::Status DeleteDomain(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* request, ::google::longrunning::Operation* response);
    // Adds an AD trust to a domain.
    virtual ::grpc::Status AttachTrust(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest* request, ::google::longrunning::Operation* response);
    // Updates the DNS conditional forwarder.
    virtual ::grpc::Status ReconfigureTrust(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* request, ::google::longrunning::Operation* response);
    // Removes an AD trust.
    virtual ::grpc::Status DetachTrust(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest* request, ::google::longrunning::Operation* response);
    // Validates a trust state, that the target domain is reachable, and that the
    // target domain is able to accept incoming trust requests.
    virtual ::grpc::Status ValidateTrust(::grpc::ServerContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateMicrosoftAdDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateMicrosoftAdDomain() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateMicrosoftAdDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMicrosoftAdDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateMicrosoftAdDomain(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetAdminPassword : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetAdminPassword() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ResetAdminPassword() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAdminPassword(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* /*request*/, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetAdminPassword(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDomains() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ListDomainsRequest* /*request*/, ::google::cloud::managedidentities::v1::ListDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDomains(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::ListDomainsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::managedidentities::v1::ListDomainsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDomain() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::GetDomainRequest* /*request*/, ::google::cloud::managedidentities::v1::Domain* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDomain(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::GetDomainRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::managedidentities::v1::Domain>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDomain() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDomain(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::UpdateDomainRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDomain() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDomain(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::DeleteDomainRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AttachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AttachTrust() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_AttachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AttachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::AttachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAttachTrust(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::AttachTrustRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReconfigureTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReconfigureTrust() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ReconfigureTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconfigureTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReconfigureTrust(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DetachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DetachTrust() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DetachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DetachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDetachTrust(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::DetachTrustRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ValidateTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ValidateTrust() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ValidateTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestValidateTrust(::grpc::ServerContext* context, ::google::cloud::managedidentities::v1::ValidateTrustRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateMicrosoftAdDomain<WithAsyncMethod_ResetAdminPassword<WithAsyncMethod_ListDomains<WithAsyncMethod_GetDomain<WithAsyncMethod_UpdateDomain<WithAsyncMethod_DeleteDomain<WithAsyncMethod_AttachTrust<WithAsyncMethod_ReconfigureTrust<WithAsyncMethod_DetachTrust<WithAsyncMethod_ValidateTrust<Service > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateMicrosoftAdDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateMicrosoftAdDomain() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* request, ::google::longrunning::Operation* response) { return this->CreateMicrosoftAdDomain(context, request, response); }));}
    void SetMessageAllocatorFor_CreateMicrosoftAdDomain(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateMicrosoftAdDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMicrosoftAdDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateMicrosoftAdDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetAdminPassword : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetAdminPassword() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* request, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* response) { return this->ResetAdminPassword(context, request, response); }));}
    void SetMessageAllocatorFor_ResetAdminPassword(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetAdminPassword() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAdminPassword(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* /*request*/, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetAdminPassword(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* /*request*/, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDomains() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ListDomainsRequest, ::google::cloud::managedidentities::v1::ListDomainsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::ListDomainsRequest* request, ::google::cloud::managedidentities::v1::ListDomainsResponse* response) { return this->ListDomains(context, request, response); }));}
    void SetMessageAllocatorFor_ListDomains(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::ListDomainsRequest, ::google::cloud::managedidentities::v1::ListDomainsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ListDomainsRequest, ::google::cloud::managedidentities::v1::ListDomainsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ListDomainsRequest* /*request*/, ::google::cloud::managedidentities::v1::ListDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDomains(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ListDomainsRequest* /*request*/, ::google::cloud::managedidentities::v1::ListDomainsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDomain() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::GetDomainRequest, ::google::cloud::managedidentities::v1::Domain>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::GetDomainRequest* request, ::google::cloud::managedidentities::v1::Domain* response) { return this->GetDomain(context, request, response); }));}
    void SetMessageAllocatorFor_GetDomain(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::GetDomainRequest, ::google::cloud::managedidentities::v1::Domain>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::GetDomainRequest, ::google::cloud::managedidentities::v1::Domain>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::GetDomainRequest* /*request*/, ::google::cloud::managedidentities::v1::Domain* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::GetDomainRequest* /*request*/, ::google::cloud::managedidentities::v1::Domain* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDomain() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::UpdateDomainRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* request, ::google::longrunning::Operation* response) { return this->UpdateDomain(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDomain(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::UpdateDomainRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::UpdateDomainRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDomain() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::DeleteDomainRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* request, ::google::longrunning::Operation* response) { return this->DeleteDomain(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDomain(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::DeleteDomainRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::DeleteDomainRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AttachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AttachTrust() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::AttachTrustRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::AttachTrustRequest* request, ::google::longrunning::Operation* response) { return this->AttachTrust(context, request, response); }));}
    void SetMessageAllocatorFor_AttachTrust(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::AttachTrustRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::AttachTrustRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AttachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AttachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::AttachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AttachTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::AttachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReconfigureTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReconfigureTrust() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ReconfigureTrustRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* request, ::google::longrunning::Operation* response) { return this->ReconfigureTrust(context, request, response); }));}
    void SetMessageAllocatorFor_ReconfigureTrust(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::ReconfigureTrustRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ReconfigureTrustRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReconfigureTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconfigureTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReconfigureTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DetachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DetachTrust() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::DetachTrustRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::DetachTrustRequest* request, ::google::longrunning::Operation* response) { return this->DetachTrust(context, request, response); }));}
    void SetMessageAllocatorFor_DetachTrust(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::DetachTrustRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::DetachTrustRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DetachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DetachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DetachTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DetachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ValidateTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ValidateTrust() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ValidateTrustRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* request, ::google::longrunning::Operation* response) { return this->ValidateTrust(context, request, response); }));}
    void SetMessageAllocatorFor_ValidateTrust(
        ::grpc::MessageAllocator< ::google::cloud::managedidentities::v1::ValidateTrustRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::managedidentities::v1::ValidateTrustRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ValidateTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ValidateTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateMicrosoftAdDomain<WithCallbackMethod_ResetAdminPassword<WithCallbackMethod_ListDomains<WithCallbackMethod_GetDomain<WithCallbackMethod_UpdateDomain<WithCallbackMethod_DeleteDomain<WithCallbackMethod_AttachTrust<WithCallbackMethod_ReconfigureTrust<WithCallbackMethod_DetachTrust<WithCallbackMethod_ValidateTrust<Service > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateMicrosoftAdDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateMicrosoftAdDomain() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateMicrosoftAdDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMicrosoftAdDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetAdminPassword : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetAdminPassword() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ResetAdminPassword() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAdminPassword(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* /*request*/, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDomains() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ListDomainsRequest* /*request*/, ::google::cloud::managedidentities::v1::ListDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDomain() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::GetDomainRequest* /*request*/, ::google::cloud::managedidentities::v1::Domain* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDomain() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDomain() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AttachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AttachTrust() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_AttachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AttachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::AttachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReconfigureTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReconfigureTrust() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ReconfigureTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconfigureTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DetachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DetachTrust() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DetachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DetachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ValidateTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ValidateTrust() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ValidateTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateMicrosoftAdDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateMicrosoftAdDomain() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateMicrosoftAdDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMicrosoftAdDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateMicrosoftAdDomain(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetAdminPassword : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetAdminPassword() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ResetAdminPassword() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAdminPassword(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* /*request*/, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetAdminPassword(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDomains() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ListDomainsRequest* /*request*/, ::google::cloud::managedidentities::v1::ListDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDomains(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDomain() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::GetDomainRequest* /*request*/, ::google::cloud::managedidentities::v1::Domain* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDomain(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDomain() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDomain(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDomain() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDomain(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AttachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AttachTrust() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_AttachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AttachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::AttachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAttachTrust(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReconfigureTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReconfigureTrust() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ReconfigureTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconfigureTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReconfigureTrust(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DetachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DetachTrust() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DetachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DetachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDetachTrust(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ValidateTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ValidateTrust() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ValidateTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestValidateTrust(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateMicrosoftAdDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateMicrosoftAdDomain() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateMicrosoftAdDomain(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateMicrosoftAdDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMicrosoftAdDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateMicrosoftAdDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetAdminPassword : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetAdminPassword() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetAdminPassword(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetAdminPassword() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetAdminPassword(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* /*request*/, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetAdminPassword(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDomains() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDomains(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ListDomainsRequest* /*request*/, ::google::cloud::managedidentities::v1::ListDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDomains(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDomain() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDomain(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::GetDomainRequest* /*request*/, ::google::cloud::managedidentities::v1::Domain* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDomain() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDomain(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDomain() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDomain(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDomain(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AttachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AttachTrust() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AttachTrust(context, request, response); }));
    }
    ~WithRawCallbackMethod_AttachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AttachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::AttachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AttachTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReconfigureTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReconfigureTrust() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReconfigureTrust(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReconfigureTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconfigureTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReconfigureTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DetachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DetachTrust() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DetachTrust(context, request, response); }));
    }
    ~WithRawCallbackMethod_DetachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DetachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DetachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DetachTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ValidateTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ValidateTrust() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ValidateTrust(context, request, response); }));
    }
    ~WithRawCallbackMethod_ValidateTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ValidateTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ValidateTrust(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateMicrosoftAdDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateMicrosoftAdDomain() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateMicrosoftAdDomain(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateMicrosoftAdDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateMicrosoftAdDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateMicrosoftAdDomain(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::CreateMicrosoftAdDomainRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetAdminPassword : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetAdminPassword() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* streamer) {
                       return this->StreamedResetAdminPassword(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetAdminPassword() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetAdminPassword(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest* /*request*/, ::google::cloud::managedidentities::v1::ResetAdminPasswordResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetAdminPassword(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::ResetAdminPasswordRequest,::google::cloud::managedidentities::v1::ResetAdminPasswordResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDomains() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::ListDomainsRequest, ::google::cloud::managedidentities::v1::ListDomainsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::ListDomainsRequest, ::google::cloud::managedidentities::v1::ListDomainsResponse>* streamer) {
                       return this->StreamedListDomains(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDomains(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ListDomainsRequest* /*request*/, ::google::cloud::managedidentities::v1::ListDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDomains(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::ListDomainsRequest,::google::cloud::managedidentities::v1::ListDomainsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDomain() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::GetDomainRequest, ::google::cloud::managedidentities::v1::Domain>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::GetDomainRequest, ::google::cloud::managedidentities::v1::Domain>* streamer) {
                       return this->StreamedGetDomain(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::GetDomainRequest* /*request*/, ::google::cloud::managedidentities::v1::Domain* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDomain(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::GetDomainRequest,::google::cloud::managedidentities::v1::Domain>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDomain() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::UpdateDomainRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::UpdateDomainRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateDomain(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::UpdateDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDomain(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::UpdateDomainRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDomain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDomain() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::DeleteDomainRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::DeleteDomainRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteDomain(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDomain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDomain(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DeleteDomainRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDomain(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::DeleteDomainRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AttachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AttachTrust() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::AttachTrustRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::AttachTrustRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAttachTrust(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AttachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AttachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::AttachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAttachTrust(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::AttachTrustRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReconfigureTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReconfigureTrust() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::ReconfigureTrustRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::ReconfigureTrustRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedReconfigureTrust(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReconfigureTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReconfigureTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ReconfigureTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReconfigureTrust(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::ReconfigureTrustRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DetachTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DetachTrust() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::DetachTrustRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::DetachTrustRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDetachTrust(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DetachTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DetachTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::DetachTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDetachTrust(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::DetachTrustRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ValidateTrust : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ValidateTrust() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::managedidentities::v1::ValidateTrustRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::managedidentities::v1::ValidateTrustRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedValidateTrust(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ValidateTrust() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ValidateTrust(::grpc::ServerContext* /*context*/, const ::google::cloud::managedidentities::v1::ValidateTrustRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedValidateTrust(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::managedidentities::v1::ValidateTrustRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateMicrosoftAdDomain<WithStreamedUnaryMethod_ResetAdminPassword<WithStreamedUnaryMethod_ListDomains<WithStreamedUnaryMethod_GetDomain<WithStreamedUnaryMethod_UpdateDomain<WithStreamedUnaryMethod_DeleteDomain<WithStreamedUnaryMethod_AttachTrust<WithStreamedUnaryMethod_ReconfigureTrust<WithStreamedUnaryMethod_DetachTrust<WithStreamedUnaryMethod_ValidateTrust<Service > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateMicrosoftAdDomain<WithStreamedUnaryMethod_ResetAdminPassword<WithStreamedUnaryMethod_ListDomains<WithStreamedUnaryMethod_GetDomain<WithStreamedUnaryMethod_UpdateDomain<WithStreamedUnaryMethod_DeleteDomain<WithStreamedUnaryMethod_AttachTrust<WithStreamedUnaryMethod_ReconfigureTrust<WithStreamedUnaryMethod_DetachTrust<WithStreamedUnaryMethod_ValidateTrust<Service > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace managedidentities
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fmanagedidentities_2fv1_2fmanaged_5fidentities_5fservice_2eproto__INCLUDED
