// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/policysimulator/v1/simulator.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fpolicysimulator_2fv1_2fsimulator_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fpolicysimulator_2fv1_2fsimulator_2eproto__INCLUDED

#include "google/cloud/policysimulator/v1/simulator.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace policysimulator {
namespace v1 {

// Policy Simulator API service.
//
// Policy Simulator is a collection of endpoints for creating, running, and
// viewing a [Replay][google.cloud.policysimulator.v1.Replay]. A
// [Replay][google.cloud.policysimulator.v1.Replay] is a type of simulation that
// lets you see how your principals' access to resources might change if you
// changed your IAM policy.
//
// During a [Replay][google.cloud.policysimulator.v1.Replay], Policy Simulator
// re-evaluates, or replays, past access attempts under both the current policy
// and  your proposed policy, and compares those results to determine how your
// principals' access might change under the proposed policy.
class Simulator final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.policysimulator.v1.Simulator";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets the specified [Replay][google.cloud.policysimulator.v1.Replay]. Each
    // `Replay` is available for at least 7 days.
    virtual ::grpc::Status GetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::google::cloud::policysimulator::v1::Replay* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::Replay>> AsyncGetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::Replay>>(AsyncGetReplayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::Replay>> PrepareAsyncGetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::Replay>>(PrepareAsyncGetReplayRaw(context, request, cq));
    }
    // Creates and starts a [Replay][google.cloud.policysimulator.v1.Replay] using
    // the given [ReplayConfig][google.cloud.policysimulator.v1.ReplayConfig].
    virtual ::grpc::Status CreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateReplayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateReplayRaw(context, request, cq));
    }
    // Lists the results of running a
    // [Replay][google.cloud.policysimulator.v1.Replay].
    virtual ::grpc::Status ListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>> AsyncListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>>(AsyncListReplayResultsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>> PrepareAsyncListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>>(PrepareAsyncListReplayResultsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets the specified [Replay][google.cloud.policysimulator.v1.Replay]. Each
      // `Replay` is available for at least 7 days.
      virtual void GetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest* request, ::google::cloud::policysimulator::v1::Replay* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest* request, ::google::cloud::policysimulator::v1::Replay* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates and starts a [Replay][google.cloud.policysimulator.v1.Replay] using
      // the given [ReplayConfig][google.cloud.policysimulator.v1.ReplayConfig].
      virtual void CreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the results of running a
      // [Replay][google.cloud.policysimulator.v1.Replay].
      virtual void ListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::Replay>* AsyncGetReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::Replay>* PrepareAsyncGetReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>* AsyncListReplayResultsRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>* PrepareAsyncListReplayResultsRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::google::cloud::policysimulator::v1::Replay* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::Replay>> AsyncGetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::Replay>>(AsyncGetReplayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::Replay>> PrepareAsyncGetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::Replay>>(PrepareAsyncGetReplayRaw(context, request, cq));
    }
    ::grpc::Status CreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateReplayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateReplayRaw(context, request, cq));
    }
    ::grpc::Status ListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>> AsyncListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>>(AsyncListReplayResultsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>> PrepareAsyncListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>>(PrepareAsyncListReplayResultsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest* request, ::google::cloud::policysimulator::v1::Replay* response, std::function<void(::grpc::Status)>) override;
      void GetReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest* request, ::google::cloud::policysimulator::v1::Replay* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateReplay(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListReplayResults(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::Replay>* AsyncGetReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::Replay>* PrepareAsyncGetReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateReplayRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>* AsyncListReplayResultsRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>* PrepareAsyncListReplayResultsRaw(::grpc::ClientContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetReplay_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateReplay_;
    const ::grpc::internal::RpcMethod rpcmethod_ListReplayResults_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets the specified [Replay][google.cloud.policysimulator.v1.Replay]. Each
    // `Replay` is available for at least 7 days.
    virtual ::grpc::Status GetReplay(::grpc::ServerContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest* request, ::google::cloud::policysimulator::v1::Replay* response);
    // Creates and starts a [Replay][google.cloud.policysimulator.v1.Replay] using
    // the given [ReplayConfig][google.cloud.policysimulator.v1.ReplayConfig].
    virtual ::grpc::Status CreateReplay(::grpc::ServerContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest* request, ::google::longrunning::Operation* response);
    // Lists the results of running a
    // [Replay][google.cloud.policysimulator.v1.Replay].
    virtual ::grpc::Status ListReplayResults(::grpc::ServerContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetReplay() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::GetReplayRequest* /*request*/, ::google::cloud::policysimulator::v1::Replay* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetReplay(::grpc::ServerContext* context, ::google::cloud::policysimulator::v1::GetReplayRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::policysimulator::v1::Replay>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateReplay() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::CreateReplayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateReplay(::grpc::ServerContext* context, ::google::cloud::policysimulator::v1::CreateReplayRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListReplayResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListReplayResults() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListReplayResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReplayResults(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* /*request*/, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReplayResults(::grpc::ServerContext* context, ::google::cloud::policysimulator::v1::ListReplayResultsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::policysimulator::v1::ListReplayResultsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetReplay<WithAsyncMethod_CreateReplay<WithAsyncMethod_ListReplayResults<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetReplay() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::policysimulator::v1::GetReplayRequest, ::google::cloud::policysimulator::v1::Replay>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::policysimulator::v1::GetReplayRequest* request, ::google::cloud::policysimulator::v1::Replay* response) { return this->GetReplay(context, request, response); }));}
    void SetMessageAllocatorFor_GetReplay(
        ::grpc::MessageAllocator< ::google::cloud::policysimulator::v1::GetReplayRequest, ::google::cloud::policysimulator::v1::Replay>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::policysimulator::v1::GetReplayRequest, ::google::cloud::policysimulator::v1::Replay>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::GetReplayRequest* /*request*/, ::google::cloud::policysimulator::v1::Replay* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetReplay(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::policysimulator::v1::GetReplayRequest* /*request*/, ::google::cloud::policysimulator::v1::Replay* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateReplay() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::policysimulator::v1::CreateReplayRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::policysimulator::v1::CreateReplayRequest* request, ::google::longrunning::Operation* response) { return this->CreateReplay(context, request, response); }));}
    void SetMessageAllocatorFor_CreateReplay(
        ::grpc::MessageAllocator< ::google::cloud::policysimulator::v1::CreateReplayRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::policysimulator::v1::CreateReplayRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::CreateReplayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateReplay(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::policysimulator::v1::CreateReplayRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListReplayResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListReplayResults() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::policysimulator::v1::ListReplayResultsRequest, ::google::cloud::policysimulator::v1::ListReplayResultsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* request, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* response) { return this->ListReplayResults(context, request, response); }));}
    void SetMessageAllocatorFor_ListReplayResults(
        ::grpc::MessageAllocator< ::google::cloud::policysimulator::v1::ListReplayResultsRequest, ::google::cloud::policysimulator::v1::ListReplayResultsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::policysimulator::v1::ListReplayResultsRequest, ::google::cloud::policysimulator::v1::ListReplayResultsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListReplayResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReplayResults(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* /*request*/, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReplayResults(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* /*request*/, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetReplay<WithCallbackMethod_CreateReplay<WithCallbackMethod_ListReplayResults<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetReplay() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::GetReplayRequest* /*request*/, ::google::cloud::policysimulator::v1::Replay* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateReplay() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::CreateReplayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListReplayResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListReplayResults() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListReplayResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReplayResults(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* /*request*/, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetReplay() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::GetReplayRequest* /*request*/, ::google::cloud::policysimulator::v1::Replay* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetReplay(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateReplay() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::CreateReplayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateReplay(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListReplayResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListReplayResults() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListReplayResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReplayResults(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* /*request*/, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReplayResults(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetReplay() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetReplay(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::GetReplayRequest* /*request*/, ::google::cloud::policysimulator::v1::Replay* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetReplay(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateReplay() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateReplay(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::CreateReplayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateReplay(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListReplayResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListReplayResults() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListReplayResults(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListReplayResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReplayResults(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* /*request*/, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReplayResults(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetReplay() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::policysimulator::v1::GetReplayRequest, ::google::cloud::policysimulator::v1::Replay>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::policysimulator::v1::GetReplayRequest, ::google::cloud::policysimulator::v1::Replay>* streamer) {
                       return this->StreamedGetReplay(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::GetReplayRequest* /*request*/, ::google::cloud::policysimulator::v1::Replay* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetReplay(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::policysimulator::v1::GetReplayRequest,::google::cloud::policysimulator::v1::Replay>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateReplay : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateReplay() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::policysimulator::v1::CreateReplayRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::policysimulator::v1::CreateReplayRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateReplay(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateReplay() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateReplay(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::CreateReplayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateReplay(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::policysimulator::v1::CreateReplayRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListReplayResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListReplayResults() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::policysimulator::v1::ListReplayResultsRequest, ::google::cloud::policysimulator::v1::ListReplayResultsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::policysimulator::v1::ListReplayResultsRequest, ::google::cloud::policysimulator::v1::ListReplayResultsResponse>* streamer) {
                       return this->StreamedListReplayResults(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListReplayResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListReplayResults(::grpc::ServerContext* /*context*/, const ::google::cloud::policysimulator::v1::ListReplayResultsRequest* /*request*/, ::google::cloud::policysimulator::v1::ListReplayResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListReplayResults(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::policysimulator::v1::ListReplayResultsRequest,::google::cloud::policysimulator::v1::ListReplayResultsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetReplay<WithStreamedUnaryMethod_CreateReplay<WithStreamedUnaryMethod_ListReplayResults<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetReplay<WithStreamedUnaryMethod_CreateReplay<WithStreamedUnaryMethod_ListReplayResults<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace policysimulator
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fpolicysimulator_2fv1_2fsimulator_2eproto__INCLUDED
