// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/redis/cluster/v1/cloud_redis_cluster.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fredis_2fcluster_2fv1_2fcloud_5fredis_5fcluster_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fredis_2fcluster_2fv1_2fcloud_5fredis_5fcluster_2eproto__INCLUDED

#include "google/cloud/redis/cluster/v1/cloud_redis_cluster.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace redis {
namespace cluster {
namespace v1 {

// Configures and manages Cloud Memorystore for Redis clusters
//
// Google Cloud Memorystore for Redis Cluster
//
// The `redis.googleapis.com` service implements the Google Cloud Memorystore
// for Redis API and defines the following resource model for managing Redis
// clusters:
// * The service works with a collection of cloud projects, named: `/projects/*`
// * Each project has a collection of available locations, named: `/locations/*`
// * Each location has a collection of Redis clusters, named: `/clusters/*`
// * As such, Redis clusters are resources of the form:
//   `/projects/{project_id}/locations/{location_id}/clusters/{instance_id}`
//
// Note that location_id must be a GCP `region`; for example:
// * `projects/redpepper-1290/locations/us-central1/clusters/my-redis`
//
// We use API version selector for Flex APIs
// * The versioning strategy is release-based versioning
// * Our backend CLH only deals with the superset version (called v1main)
// * Existing backend for Redis Gen1 and MRR is not touched.
// * More details in go/redis-flex-api-versioning
class CloudRedisCluster final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.redis.cluster.v1.CloudRedisCluster";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all Redis clusters owned by a project in either the specified
    // location (region) or all locations.
    //
    // The location should have the following format:
    //
    // * `projects/{project_id}/locations/{location_id}`
    //
    // If `location_id` is specified as `-` (wildcard), then all regions
    // available to the project are queried, and the results are aggregated.
    virtual ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    // Gets the details of a specific Redis cluster.
    virtual ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::google::cloud::redis::cluster::v1::Cluster* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    // Updates the metadata and configuration of a specific Redis cluster.
    //
    // Completed longrunning.Operation will contain the new cluster object
    // in the response field. The returned operation is automatically deleted
    // after a few hours, so there is no need to call DeleteOperation.
    virtual ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    // Deletes a specific Redis cluster. Cluster stops serving and data is
    // deleted.
    virtual ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    // Creates a Redis cluster based on the specified properties.
    // The creation is executed asynchronously and callers may check the returned
    // operation to track its progress. Once the operation is completed the Redis
    // cluster will be fully functional. The completed longrunning.Operation will
    // contain the new cluster object in the response field.
    //
    // The returned operation is automatically deleted after a few hours, so there
    // is no need to call DeleteOperation.
    virtual ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all Redis clusters owned by a project in either the specified
      // location (region) or all locations.
      //
      // The location should have the following format:
      //
      // * `projects/{project_id}/locations/{location_id}`
      //
      // If `location_id` is specified as `-` (wildcard), then all regions
      // available to the project are queried, and the results are aggregated.
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific Redis cluster.
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the metadata and configuration of a specific Redis cluster.
      //
      // Completed longrunning.Operation will contain the new cluster object
      // in the response field. The returned operation is automatically deleted
      // after a few hours, so there is no need to call DeleteOperation.
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific Redis cluster. Cluster stops serving and data is
      // deleted.
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Redis cluster based on the specified properties.
      // The creation is executed asynchronously and callers may check the returned
      // operation to track its progress. Once the operation is completed the Redis
      // cluster will be fully functional. The completed longrunning.Operation will
      // contain the new cluster object in the response field.
      //
      // The returned operation is automatically deleted after a few hours, so there
      // is no need to call DeleteOperation.
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::redis::cluster::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::google::cloud::redis::cluster::v1::Cluster* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, std::function<void(::grpc::Status)>) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::redis::cluster::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListClusters_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCluster_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all Redis clusters owned by a project in either the specified
    // location (region) or all locations.
    //
    // The location should have the following format:
    //
    // * `projects/{project_id}/locations/{location_id}`
    //
    // If `location_id` is specified as `-` (wildcard), then all regions
    // available to the project are queried, and the results are aggregated.
    virtual ::grpc::Status ListClusters(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response);
    // Gets the details of a specific Redis cluster.
    virtual ::grpc::Status GetCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response);
    // Updates the metadata and configuration of a specific Redis cluster.
    //
    // Completed longrunning.Operation will contain the new cluster object
    // in the response field. The returned operation is automatically deleted
    // after a few hours, so there is no need to call DeleteOperation.
    virtual ::grpc::Status UpdateCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response);
    // Deletes a specific Redis cluster. Cluster stops serving and data is
    // deleted.
    virtual ::grpc::Status DeleteCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response);
    // Creates a Redis cluster based on the specified properties.
    // The creation is executed asynchronously and callers may check the returned
    // operation to track its progress. Once the operation is completed the Redis
    // cluster will be fully functional. The completed longrunning.Operation will
    // contain the new cluster object in the response field.
    //
    // The returned operation is automatically deleted after a few hours, so there
    // is no need to call DeleteOperation.
    virtual ::grpc::Status CreateCluster(::grpc::ServerContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListClusters() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::ListClustersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCluster() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::redis::cluster::v1::Cluster>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCluster() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListClusters<WithAsyncMethod_GetCluster<WithAsyncMethod_UpdateCluster<WithAsyncMethod_DeleteCluster<WithAsyncMethod_CreateCluster<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::ListClustersRequest* request, ::google::cloud::redis::cluster::v1::ListClustersResponse* response) { return this->ListClusters(context, request, response); }));}
    void SetMessageAllocatorFor_ListClusters(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::GetClusterRequest* request, ::google::cloud::redis::cluster::v1::Cluster* response) { return this->GetCluster(context, request, response); }));}
    void SetMessageAllocatorFor_GetCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCluster(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response) { return this->CreateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCluster(
        ::grpc::MessageAllocator< ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListClusters<WithCallbackMethod_GetCluster<WithCallbackMethod_UpdateCluster<WithCallbackMethod_DeleteCluster<WithCallbackMethod_CreateCluster<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListClusters() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCluster() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCluster() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListClusters() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCluster() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListClusters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListClusters() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::ListClustersRequest, ::google::cloud::redis::cluster::v1::ListClustersResponse>* streamer) {
                       return this->StreamedListClusters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::ListClustersRequest* /*request*/, ::google::cloud::redis::cluster::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListClusters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::ListClustersRequest,::google::cloud::redis::cluster::v1::ListClustersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCluster() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::GetClusterRequest, ::google::cloud::redis::cluster::v1::Cluster>* streamer) {
                       return this->StreamedGetCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::GetClusterRequest* /*request*/, ::google::cloud::redis::cluster::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::GetClusterRequest,::google::cloud::redis::cluster::v1::Cluster>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::UpdateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::UpdateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::DeleteClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::DeleteClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCluster() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::redis::cluster::v1::CreateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::redis::cluster::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::redis::cluster::v1::CreateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_CreateCluster<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_CreateCluster<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace cluster
}  // namespace redis
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fredis_2fcluster_2fv1_2fcloud_5fredis_5fcluster_2eproto__INCLUDED
