// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/talent/v4/job_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2ftalent_2fv4_2fjob_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2ftalent_2fv4_2fjob_5fservice_2eproto__INCLUDED

#include "google/cloud/talent/v4/job_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace talent {
namespace v4 {

// A service handles job management, including job CRUD, enumeration and search.
class JobService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.talent.v4.JobService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new job.
    //
    // Typically, the job becomes searchable within 10 seconds, but it may take
    // up to 5 minutes.
    virtual ::grpc::Status CreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::google::cloud::talent::v4::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>> AsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>>(AsyncCreateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>> PrepareAsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>>(PrepareAsyncCreateJobRaw(context, request, cq));
    }
    // Begins executing a batch create jobs operation.
    virtual ::grpc::Status BatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchCreateJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchCreateJobsRaw(context, request, cq));
    }
    // Retrieves the specified job, whose status is OPEN or recently EXPIRED
    // within the last 90 days.
    virtual ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::google::cloud::talent::v4::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    // Updates specified job.
    //
    // Typically, updated contents become visible in search results within 10
    // seconds, but it may take up to 5 minutes.
    virtual ::grpc::Status UpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::google::cloud::talent::v4::Job* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>> AsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>>(AsyncUpdateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>> PrepareAsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>>(PrepareAsyncUpdateJobRaw(context, request, cq));
    }
    // Begins executing a batch update jobs operation.
    virtual ::grpc::Status BatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchUpdateJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateJobsRaw(context, request, cq));
    }
    // Deletes the specified job.
    //
    // Typically, the job becomes unsearchable within 10 seconds, but it may take
    // up to 5 minutes.
    virtual ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    // Begins executing a batch delete jobs operation.
    virtual ::grpc::Status BatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeleteJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteJobsRaw(context, request, cq));
    }
    // Lists jobs by filter.
    virtual ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::google::cloud::talent::v4::ListJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    // Searches for jobs using the provided
    // [SearchJobsRequest][google.cloud.talent.v4.SearchJobsRequest].
    //
    // This call constrains the
    // [visibility][google.cloud.talent.v4.Job.visibility] of jobs present in the
    // database, and only returns jobs that the caller has permission to search
    // against.
    virtual ::grpc::Status SearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::google::cloud::talent::v4::SearchJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>> AsyncSearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>>(AsyncSearchJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>> PrepareAsyncSearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>>(PrepareAsyncSearchJobsRaw(context, request, cq));
    }
    // Searches for jobs using the provided
    // [SearchJobsRequest][google.cloud.talent.v4.SearchJobsRequest].
    //
    // This API call is intended for the use case of targeting passive job
    // seekers (for example, job seekers who have signed up to receive email
    // alerts about potential job opportunities), it has different algorithmic
    // adjustments that are designed to specifically target passive job seekers.
    //
    // This call constrains the
    // [visibility][google.cloud.talent.v4.Job.visibility] of jobs present in the
    // database, and only returns jobs the caller has permission to search
    // against.
    virtual ::grpc::Status SearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::google::cloud::talent::v4::SearchJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>> AsyncSearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>>(AsyncSearchJobsForAlertRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>> PrepareAsyncSearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>>(PrepareAsyncSearchJobsForAlertRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new job.
      //
      // Typically, the job becomes searchable within 10 seconds, but it may take
      // up to 5 minutes.
      virtual void CreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest* request, ::google::cloud::talent::v4::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest* request, ::google::cloud::talent::v4::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Begins executing a batch create jobs operation.
      virtual void BatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the specified job, whose status is OPEN or recently EXPIRED
      // within the last 90 days.
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest* request, ::google::cloud::talent::v4::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest* request, ::google::cloud::talent::v4::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates specified job.
      //
      // Typically, updated contents become visible in search results within 10
      // seconds, but it may take up to 5 minutes.
      virtual void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest* request, ::google::cloud::talent::v4::Job* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest* request, ::google::cloud::talent::v4::Job* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Begins executing a batch update jobs operation.
      virtual void BatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified job.
      //
      // Typically, the job becomes unsearchable within 10 seconds, but it may take
      // up to 5 minutes.
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Begins executing a batch delete jobs operation.
      virtual void BatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists jobs by filter.
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest* request, ::google::cloud::talent::v4::ListJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest* request, ::google::cloud::talent::v4::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Searches for jobs using the provided
      // [SearchJobsRequest][google.cloud.talent.v4.SearchJobsRequest].
      //
      // This call constrains the
      // [visibility][google.cloud.talent.v4.Job.visibility] of jobs present in the
      // database, and only returns jobs that the caller has permission to search
      // against.
      virtual void SearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Searches for jobs using the provided
      // [SearchJobsRequest][google.cloud.talent.v4.SearchJobsRequest].
      //
      // This API call is intended for the use case of targeting passive job
      // seekers (for example, job seekers who have signed up to receive email
      // alerts about potential job opportunities), it has different algorithmic
      // adjustments that are designed to specifically target passive job seekers.
      //
      // This call constrains the
      // [visibility][google.cloud.talent.v4.Job.visibility] of jobs present in the
      // database, and only returns jobs the caller has permission to search
      // against.
      virtual void SearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>* AsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>* PrepareAsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchCreateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchCreateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>* AsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::Job>* PrepareAsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchUpdateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeleteJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>* AsyncSearchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>* PrepareAsyncSearchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>* AsyncSearchJobsForAlertRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::talent::v4::SearchJobsResponse>* PrepareAsyncSearchJobsForAlertRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::google::cloud::talent::v4::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>> AsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>>(AsyncCreateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>> PrepareAsyncCreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>>(PrepareAsyncCreateJobRaw(context, request, cq));
    }
    ::grpc::Status BatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchCreateJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchCreateJobsRaw(context, request, cq));
    }
    ::grpc::Status GetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::google::cloud::talent::v4::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>> AsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>>(AsyncGetJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>> PrepareAsyncGetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>>(PrepareAsyncGetJobRaw(context, request, cq));
    }
    ::grpc::Status UpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::google::cloud::talent::v4::Job* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>> AsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>>(AsyncUpdateJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>> PrepareAsyncUpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>>(PrepareAsyncUpdateJobRaw(context, request, cq));
    }
    ::grpc::Status BatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchUpdateJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateJobsRaw(context, request, cq));
    }
    ::grpc::Status DeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteJobRaw(context, request, cq));
    }
    ::grpc::Status BatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeleteJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteJobsRaw(context, request, cq));
    }
    ::grpc::Status ListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::google::cloud::talent::v4::ListJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ListJobsResponse>> AsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ListJobsResponse>>(AsyncListJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ListJobsResponse>> PrepareAsyncListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ListJobsResponse>>(PrepareAsyncListJobsRaw(context, request, cq));
    }
    ::grpc::Status SearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::google::cloud::talent::v4::SearchJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>> AsyncSearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>>(AsyncSearchJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>> PrepareAsyncSearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>>(PrepareAsyncSearchJobsRaw(context, request, cq));
    }
    ::grpc::Status SearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::google::cloud::talent::v4::SearchJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>> AsyncSearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>>(AsyncSearchJobsForAlertRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>> PrepareAsyncSearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>>(PrepareAsyncSearchJobsForAlertRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest* request, ::google::cloud::talent::v4::Job* response, std::function<void(::grpc::Status)>) override;
      void CreateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest* request, ::google::cloud::talent::v4::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchCreateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest* request, ::google::cloud::talent::v4::Job* response, std::function<void(::grpc::Status)>) override;
      void GetJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest* request, ::google::cloud::talent::v4::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest* request, ::google::cloud::talent::v4::Job* response, std::function<void(::grpc::Status)>) override;
      void UpdateJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest* request, ::google::cloud::talent::v4::Job* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteJob(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest* request, ::google::cloud::talent::v4::ListJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest* request, ::google::cloud::talent::v4::ListJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchJobs(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchJobsForAlert(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>* AsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>* PrepareAsyncCreateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::CreateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchCreateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchCreateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>* AsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>* PrepareAsyncGetJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::GetJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>* AsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::Job>* PrepareAsyncUpdateJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::UpdateJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchUpdateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteJobRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::DeleteJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeleteJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ListJobsResponse>* AsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::ListJobsResponse>* PrepareAsyncListJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::ListJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>* AsyncSearchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>* PrepareAsyncSearchJobsRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>* AsyncSearchJobsForAlertRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::talent::v4::SearchJobsResponse>* PrepareAsyncSearchJobsForAlertRaw(::grpc::ClientContext* context, const ::google::cloud::talent::v4::SearchJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateJob_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchCreateJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetJob_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateJob_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchUpdateJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteJob_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeleteJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_ListJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchJobsForAlert_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new job.
    //
    // Typically, the job becomes searchable within 10 seconds, but it may take
    // up to 5 minutes.
    virtual ::grpc::Status CreateJob(::grpc::ServerContext* context, const ::google::cloud::talent::v4::CreateJobRequest* request, ::google::cloud::talent::v4::Job* response);
    // Begins executing a batch create jobs operation.
    virtual ::grpc::Status BatchCreateJobs(::grpc::ServerContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest* request, ::google::longrunning::Operation* response);
    // Retrieves the specified job, whose status is OPEN or recently EXPIRED
    // within the last 90 days.
    virtual ::grpc::Status GetJob(::grpc::ServerContext* context, const ::google::cloud::talent::v4::GetJobRequest* request, ::google::cloud::talent::v4::Job* response);
    // Updates specified job.
    //
    // Typically, updated contents become visible in search results within 10
    // seconds, but it may take up to 5 minutes.
    virtual ::grpc::Status UpdateJob(::grpc::ServerContext* context, const ::google::cloud::talent::v4::UpdateJobRequest* request, ::google::cloud::talent::v4::Job* response);
    // Begins executing a batch update jobs operation.
    virtual ::grpc::Status BatchUpdateJobs(::grpc::ServerContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* request, ::google::longrunning::Operation* response);
    // Deletes the specified job.
    //
    // Typically, the job becomes unsearchable within 10 seconds, but it may take
    // up to 5 minutes.
    virtual ::grpc::Status DeleteJob(::grpc::ServerContext* context, const ::google::cloud::talent::v4::DeleteJobRequest* request, ::google::protobuf::Empty* response);
    // Begins executing a batch delete jobs operation.
    virtual ::grpc::Status BatchDeleteJobs(::grpc::ServerContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* request, ::google::longrunning::Operation* response);
    // Lists jobs by filter.
    virtual ::grpc::Status ListJobs(::grpc::ServerContext* context, const ::google::cloud::talent::v4::ListJobsRequest* request, ::google::cloud::talent::v4::ListJobsResponse* response);
    // Searches for jobs using the provided
    // [SearchJobsRequest][google.cloud.talent.v4.SearchJobsRequest].
    //
    // This call constrains the
    // [visibility][google.cloud.talent.v4.Job.visibility] of jobs present in the
    // database, and only returns jobs that the caller has permission to search
    // against.
    virtual ::grpc::Status SearchJobs(::grpc::ServerContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response);
    // Searches for jobs using the provided
    // [SearchJobsRequest][google.cloud.talent.v4.SearchJobsRequest].
    //
    // This API call is intended for the use case of targeting passive job
    // seekers (for example, job seekers who have signed up to receive email
    // alerts about potential job opportunities), it has different algorithmic
    // adjustments that are designed to specifically target passive job seekers.
    //
    // This call constrains the
    // [visibility][google.cloud.talent.v4.Job.visibility] of jobs present in the
    // database, and only returns jobs the caller has permission to search
    // against.
    virtual ::grpc::Status SearchJobsForAlert(::grpc::ServerContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateJob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJob(::grpc::ServerContext* context, ::google::cloud::talent::v4::CreateJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::talent::v4::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchCreateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchCreateJobs() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_BatchCreateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchCreateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateJobs(::grpc::ServerContext* context, ::google::cloud::talent::v4::BatchCreateJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetJob() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::GetJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::google::cloud::talent::v4::GetJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::talent::v4::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateJob() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::UpdateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateJob(::grpc::ServerContext* context, ::google::cloud::talent::v4::UpdateJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::talent::v4::Job>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchUpdateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchUpdateJobs() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_BatchUpdateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateJobs(::grpc::ServerContext* context, ::google::cloud::talent::v4::BatchUpdateJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteJob() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::google::cloud::talent::v4::DeleteJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeleteJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeleteJobs() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_BatchDeleteJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteJobs(::grpc::ServerContext* context, ::google::cloud::talent::v4::BatchDeleteJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListJobs() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::ListJobsRequest* /*request*/, ::google::cloud::talent::v4::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::google::cloud::talent::v4::ListJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::talent::v4::ListJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchJobs() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_SearchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchJobs(::grpc::ServerContext* context, ::google::cloud::talent::v4::SearchJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::talent::v4::SearchJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchJobsForAlert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchJobsForAlert() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_SearchJobsForAlert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobsForAlert(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchJobsForAlert(::grpc::ServerContext* context, ::google::cloud::talent::v4::SearchJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::talent::v4::SearchJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateJob<WithAsyncMethod_BatchCreateJobs<WithAsyncMethod_GetJob<WithAsyncMethod_UpdateJob<WithAsyncMethod_BatchUpdateJobs<WithAsyncMethod_DeleteJob<WithAsyncMethod_BatchDeleteJobs<WithAsyncMethod_ListJobs<WithAsyncMethod_SearchJobs<WithAsyncMethod_SearchJobsForAlert<Service > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateJob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::CreateJobRequest, ::google::cloud::talent::v4::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::CreateJobRequest* request, ::google::cloud::talent::v4::Job* response) { return this->CreateJob(context, request, response); }));}
    void SetMessageAllocatorFor_CreateJob(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::CreateJobRequest, ::google::cloud::talent::v4::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::CreateJobRequest, ::google::cloud::talent::v4::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::CreateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchCreateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchCreateJobs() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::BatchCreateJobsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::BatchCreateJobsRequest* request, ::google::longrunning::Operation* response) { return this->BatchCreateJobs(context, request, response); }));}
    void SetMessageAllocatorFor_BatchCreateJobs(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::BatchCreateJobsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::BatchCreateJobsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchCreateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchCreateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::BatchCreateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::GetJobRequest, ::google::cloud::talent::v4::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::GetJobRequest* request, ::google::cloud::talent::v4::Job* response) { return this->GetJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetJob(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::GetJobRequest, ::google::cloud::talent::v4::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::GetJobRequest, ::google::cloud::talent::v4::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::GetJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::GetJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateJob() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::UpdateJobRequest, ::google::cloud::talent::v4::Job>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::UpdateJobRequest* request, ::google::cloud::talent::v4::Job* response) { return this->UpdateJob(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateJob(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::UpdateJobRequest, ::google::cloud::talent::v4::Job>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::UpdateJobRequest, ::google::cloud::talent::v4::Job>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::UpdateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::UpdateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchUpdateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchUpdateJobs() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::BatchUpdateJobsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* request, ::google::longrunning::Operation* response) { return this->BatchUpdateJobs(context, request, response); }));}
    void SetMessageAllocatorFor_BatchUpdateJobs(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::BatchUpdateJobsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::BatchUpdateJobsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchUpdateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::DeleteJobRequest* request, ::google::protobuf::Empty* response) { return this->DeleteJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteJob(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::DeleteJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::DeleteJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchDeleteJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchDeleteJobs() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::BatchDeleteJobsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* request, ::google::longrunning::Operation* response) { return this->BatchDeleteJobs(context, request, response); }));}
    void SetMessageAllocatorFor_BatchDeleteJobs(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::BatchDeleteJobsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::BatchDeleteJobsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchDeleteJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::ListJobsRequest, ::google::cloud::talent::v4::ListJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::ListJobsRequest* request, ::google::cloud::talent::v4::ListJobsResponse* response) { return this->ListJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListJobs(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::ListJobsRequest, ::google::cloud::talent::v4::ListJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::ListJobsRequest, ::google::cloud::talent::v4::ListJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::ListJobsRequest* /*request*/, ::google::cloud::talent::v4::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::ListJobsRequest* /*request*/, ::google::cloud::talent::v4::ListJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchJobs() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response) { return this->SearchJobs(context, request, response); }));}
    void SetMessageAllocatorFor_SearchJobs(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchJobsForAlert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchJobsForAlert() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::talent::v4::SearchJobsRequest* request, ::google::cloud::talent::v4::SearchJobsResponse* response) { return this->SearchJobsForAlert(context, request, response); }));}
    void SetMessageAllocatorFor_SearchJobsForAlert(
        ::grpc::MessageAllocator< ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchJobsForAlert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobsForAlert(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchJobsForAlert(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateJob<WithCallbackMethod_BatchCreateJobs<WithCallbackMethod_GetJob<WithCallbackMethod_UpdateJob<WithCallbackMethod_BatchUpdateJobs<WithCallbackMethod_DeleteJob<WithCallbackMethod_BatchDeleteJobs<WithCallbackMethod_ListJobs<WithCallbackMethod_SearchJobs<WithCallbackMethod_SearchJobsForAlert<Service > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateJob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchCreateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchCreateJobs() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_BatchCreateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchCreateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetJob() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::GetJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateJob() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::UpdateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchUpdateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchUpdateJobs() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_BatchUpdateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteJob() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeleteJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeleteJobs() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_BatchDeleteJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListJobs() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::ListJobsRequest* /*request*/, ::google::cloud::talent::v4::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchJobs() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_SearchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchJobsForAlert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchJobsForAlert() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_SearchJobsForAlert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobsForAlert(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateJob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchCreateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchCreateJobs() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_BatchCreateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchCreateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetJob() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::GetJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateJob() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::UpdateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchUpdateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchUpdateJobs() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_BatchUpdateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeleteJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeleteJobs() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_BatchDeleteJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListJobs() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::ListJobsRequest* /*request*/, ::google::cloud::talent::v4::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchJobs() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_SearchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchJobsForAlert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchJobsForAlert() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_SearchJobsForAlert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobsForAlert(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchJobsForAlert(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateJob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchCreateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchCreateJobs() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchCreateJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchCreateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchCreateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetJob() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::GetJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateJob() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::UpdateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchUpdateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchUpdateJobs() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchUpdateJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchUpdateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteJob() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchDeleteJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchDeleteJobs() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchDeleteJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchDeleteJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchDeleteJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListJobs() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::ListJobsRequest* /*request*/, ::google::cloud::talent::v4::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchJobs() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchJobsForAlert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchJobsForAlert() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchJobsForAlert(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchJobsForAlert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchJobsForAlert(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchJobsForAlert(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateJob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::CreateJobRequest, ::google::cloud::talent::v4::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::CreateJobRequest, ::google::cloud::talent::v4::Job>* streamer) {
                       return this->StreamedCreateJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::CreateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::CreateJobRequest,::google::cloud::talent::v4::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchCreateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchCreateJobs() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::BatchCreateJobsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::BatchCreateJobsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchCreateJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchCreateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchCreateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchCreateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchCreateJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::BatchCreateJobsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetJob() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::GetJobRequest, ::google::cloud::talent::v4::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::GetJobRequest, ::google::cloud::talent::v4::Job>* streamer) {
                       return this->StreamedGetJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::GetJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::GetJobRequest,::google::cloud::talent::v4::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateJob() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::UpdateJobRequest, ::google::cloud::talent::v4::Job>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::UpdateJobRequest, ::google::cloud::talent::v4::Job>* streamer) {
                       return this->StreamedUpdateJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::UpdateJobRequest* /*request*/, ::google::cloud::talent::v4::Job* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::UpdateJobRequest,::google::cloud::talent::v4::Job>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchUpdateJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchUpdateJobs() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::BatchUpdateJobsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::BatchUpdateJobsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchUpdateJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchUpdateJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchUpdateJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchUpdateJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchUpdateJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::BatchUpdateJobsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteJob() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::DeleteJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::DeleteJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteJob(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::DeleteJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::DeleteJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeleteJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeleteJobs() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::BatchDeleteJobsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::BatchDeleteJobsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchDeleteJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchDeleteJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeleteJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::BatchDeleteJobsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeleteJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::BatchDeleteJobsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListJobs() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::ListJobsRequest, ::google::cloud::talent::v4::ListJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::ListJobsRequest, ::google::cloud::talent::v4::ListJobsResponse>* streamer) {
                       return this->StreamedListJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::ListJobsRequest* /*request*/, ::google::cloud::talent::v4::ListJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::ListJobsRequest,::google::cloud::talent::v4::ListJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchJobs() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>* streamer) {
                       return this->StreamedSearchJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchJobs(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::SearchJobsRequest,::google::cloud::talent::v4::SearchJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchJobsForAlert : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchJobsForAlert() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::talent::v4::SearchJobsRequest, ::google::cloud::talent::v4::SearchJobsResponse>* streamer) {
                       return this->StreamedSearchJobsForAlert(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchJobsForAlert() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchJobsForAlert(::grpc::ServerContext* /*context*/, const ::google::cloud::talent::v4::SearchJobsRequest* /*request*/, ::google::cloud::talent::v4::SearchJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchJobsForAlert(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::talent::v4::SearchJobsRequest,::google::cloud::talent::v4::SearchJobsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateJob<WithStreamedUnaryMethod_BatchCreateJobs<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_UpdateJob<WithStreamedUnaryMethod_BatchUpdateJobs<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_BatchDeleteJobs<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_SearchJobs<WithStreamedUnaryMethod_SearchJobsForAlert<Service > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateJob<WithStreamedUnaryMethod_BatchCreateJobs<WithStreamedUnaryMethod_GetJob<WithStreamedUnaryMethod_UpdateJob<WithStreamedUnaryMethod_BatchUpdateJobs<WithStreamedUnaryMethod_DeleteJob<WithStreamedUnaryMethod_BatchDeleteJobs<WithStreamedUnaryMethod_ListJobs<WithStreamedUnaryMethod_SearchJobs<WithStreamedUnaryMethod_SearchJobsForAlert<Service > > > > > > > > > > StreamedService;
};

}  // namespace v4
}  // namespace talent
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2ftalent_2fv4_2fjob_5fservice_2eproto__INCLUDED
