// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/tpu/v2/cloud_tpu.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2ftpu_2fv2_2fcloud_5ftpu_2eproto__INCLUDED
#define GRPC_google_2fcloud_2ftpu_2fv2_2fcloud_5ftpu_2eproto__INCLUDED

#include "google/cloud/tpu/v2/cloud_tpu.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace tpu {
namespace v2 {

// Manages TPU nodes and other resources
//
// TPU API v2
class Tpu final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.tpu.v2.Tpu";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists nodes.
    virtual ::grpc::Status ListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::google::cloud::tpu::v2::ListNodesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListNodesResponse>> AsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListNodesResponse>>(AsyncListNodesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListNodesResponse>> PrepareAsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListNodesResponse>>(PrepareAsyncListNodesRaw(context, request, cq));
    }
    // Gets the details of a node.
    virtual ::grpc::Status GetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::google::cloud::tpu::v2::Node* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::Node>> AsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::Node>>(AsyncGetNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::Node>> PrepareAsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::Node>>(PrepareAsyncGetNodeRaw(context, request, cq));
    }
    // Creates a node.
    virtual ::grpc::Status CreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateNodeRaw(context, request, cq));
    }
    // Deletes a node.
    virtual ::grpc::Status DeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteNodeRaw(context, request, cq));
    }
    // Stops a node. This operation is only available with single TPU nodes.
    virtual ::grpc::Status StopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStopNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStopNodeRaw(context, request, cq));
    }
    // Starts a node.
    virtual ::grpc::Status StartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStartNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStartNodeRaw(context, request, cq));
    }
    // Updates the configurations of a node.
    virtual ::grpc::Status UpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateNodeRaw(context, request, cq));
    }
    // Generates the Cloud TPU service identity for the project.
    virtual ::grpc::Status GenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>> AsyncGenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>>(AsyncGenerateServiceIdentityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>> PrepareAsyncGenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>>(PrepareAsyncGenerateServiceIdentityRaw(context, request, cq));
    }
    // Lists accelerator types supported by this API.
    virtual ::grpc::Status ListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>> AsyncListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>>(AsyncListAcceleratorTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>> PrepareAsyncListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>>(PrepareAsyncListAcceleratorTypesRaw(context, request, cq));
    }
    // Gets AcceleratorType.
    virtual ::grpc::Status GetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::google::cloud::tpu::v2::AcceleratorType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::AcceleratorType>> AsyncGetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::AcceleratorType>>(AsyncGetAcceleratorTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::AcceleratorType>> PrepareAsyncGetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::AcceleratorType>>(PrepareAsyncGetAcceleratorTypeRaw(context, request, cq));
    }
    // Lists runtime versions supported by this API.
    virtual ::grpc::Status ListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>> AsyncListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>>(AsyncListRuntimeVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>> PrepareAsyncListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>>(PrepareAsyncListRuntimeVersionsRaw(context, request, cq));
    }
    // Gets a runtime version.
    virtual ::grpc::Status GetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::google::cloud::tpu::v2::RuntimeVersion* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::RuntimeVersion>> AsyncGetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::RuntimeVersion>>(AsyncGetRuntimeVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::RuntimeVersion>> PrepareAsyncGetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::RuntimeVersion>>(PrepareAsyncGetRuntimeVersionRaw(context, request, cq));
    }
    // Retrieves the guest attributes for the node.
    virtual ::grpc::Status GetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GetGuestAttributesResponse>> AsyncGetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GetGuestAttributesResponse>>(AsyncGetGuestAttributesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GetGuestAttributesResponse>> PrepareAsyncGetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GetGuestAttributesResponse>>(PrepareAsyncGetGuestAttributesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists nodes.
      virtual void ListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest* request, ::google::cloud::tpu::v2::ListNodesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest* request, ::google::cloud::tpu::v2::ListNodesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a node.
      virtual void GetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest* request, ::google::cloud::tpu::v2::Node* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest* request, ::google::cloud::tpu::v2::Node* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a node.
      virtual void CreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a node.
      virtual void DeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Stops a node. This operation is only available with single TPU nodes.
      virtual void StopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts a node.
      virtual void StartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the configurations of a node.
      virtual void UpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Generates the Cloud TPU service identity for the project.
      virtual void GenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists accelerator types supported by this API.
      virtual void ListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets AcceleratorType.
      virtual void GetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* request, ::google::cloud::tpu::v2::AcceleratorType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* request, ::google::cloud::tpu::v2::AcceleratorType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists runtime versions supported by this API.
      virtual void ListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a runtime version.
      virtual void GetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* request, ::google::cloud::tpu::v2::RuntimeVersion* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* request, ::google::cloud::tpu::v2::RuntimeVersion* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the guest attributes for the node.
      virtual void GetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListNodesResponse>* AsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListNodesResponse>* PrepareAsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::Node>* AsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::Node>* PrepareAsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStopNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStopNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStartNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStartNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* AsyncGenerateServiceIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* PrepareAsyncGenerateServiceIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* AsyncListAcceleratorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* PrepareAsyncListAcceleratorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::AcceleratorType>* AsyncGetAcceleratorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::AcceleratorType>* PrepareAsyncGetAcceleratorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* AsyncListRuntimeVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* PrepareAsyncListRuntimeVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::RuntimeVersion>* AsyncGetRuntimeVersionRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::RuntimeVersion>* PrepareAsyncGetRuntimeVersionRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GetGuestAttributesResponse>* AsyncGetGuestAttributesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::tpu::v2::GetGuestAttributesResponse>* PrepareAsyncGetGuestAttributesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::google::cloud::tpu::v2::ListNodesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListNodesResponse>> AsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListNodesResponse>>(AsyncListNodesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListNodesResponse>> PrepareAsyncListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListNodesResponse>>(PrepareAsyncListNodesRaw(context, request, cq));
    }
    ::grpc::Status GetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::google::cloud::tpu::v2::Node* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::Node>> AsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::Node>>(AsyncGetNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::Node>> PrepareAsyncGetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::Node>>(PrepareAsyncGetNodeRaw(context, request, cq));
    }
    ::grpc::Status CreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateNodeRaw(context, request, cq));
    }
    ::grpc::Status DeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteNodeRaw(context, request, cq));
    }
    ::grpc::Status StopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStopNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStopNodeRaw(context, request, cq));
    }
    ::grpc::Status StartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStartNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStartNodeRaw(context, request, cq));
    }
    ::grpc::Status UpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateNodeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateNodeRaw(context, request, cq));
    }
    ::grpc::Status GenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>> AsyncGenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>>(AsyncGenerateServiceIdentityRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>> PrepareAsyncGenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>>(PrepareAsyncGenerateServiceIdentityRaw(context, request, cq));
    }
    ::grpc::Status ListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>> AsyncListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>>(AsyncListAcceleratorTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>> PrepareAsyncListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>>(PrepareAsyncListAcceleratorTypesRaw(context, request, cq));
    }
    ::grpc::Status GetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::google::cloud::tpu::v2::AcceleratorType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::AcceleratorType>> AsyncGetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::AcceleratorType>>(AsyncGetAcceleratorTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::AcceleratorType>> PrepareAsyncGetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::AcceleratorType>>(PrepareAsyncGetAcceleratorTypeRaw(context, request, cq));
    }
    ::grpc::Status ListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>> AsyncListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>>(AsyncListRuntimeVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>> PrepareAsyncListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>>(PrepareAsyncListRuntimeVersionsRaw(context, request, cq));
    }
    ::grpc::Status GetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::google::cloud::tpu::v2::RuntimeVersion* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::RuntimeVersion>> AsyncGetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::RuntimeVersion>>(AsyncGetRuntimeVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::RuntimeVersion>> PrepareAsyncGetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::RuntimeVersion>>(PrepareAsyncGetRuntimeVersionRaw(context, request, cq));
    }
    ::grpc::Status GetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GetGuestAttributesResponse>> AsyncGetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GetGuestAttributesResponse>>(AsyncGetGuestAttributesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GetGuestAttributesResponse>> PrepareAsyncGetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GetGuestAttributesResponse>>(PrepareAsyncGetGuestAttributesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest* request, ::google::cloud::tpu::v2::ListNodesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNodes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest* request, ::google::cloud::tpu::v2::ListNodesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest* request, ::google::cloud::tpu::v2::Node* response, std::function<void(::grpc::Status)>) override;
      void GetNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest* request, ::google::cloud::tpu::v2::Node* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StopNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StartNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateNode(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateServiceIdentity(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAcceleratorTypes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* request, ::google::cloud::tpu::v2::AcceleratorType* response, std::function<void(::grpc::Status)>) override;
      void GetAcceleratorType(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* request, ::google::cloud::tpu::v2::AcceleratorType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRuntimeVersions(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* request, ::google::cloud::tpu::v2::RuntimeVersion* response, std::function<void(::grpc::Status)>) override;
      void GetRuntimeVersion(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* request, ::google::cloud::tpu::v2::RuntimeVersion* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response, std::function<void(::grpc::Status)>) override;
      void GetGuestAttributes(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListNodesResponse>* AsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListNodesResponse>* PrepareAsyncListNodesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListNodesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::Node>* AsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::Node>* PrepareAsyncGetNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStopNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStopNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StopNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStartNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStartNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::StartNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateNodeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* AsyncGenerateServiceIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* PrepareAsyncGenerateServiceIdentityRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* AsyncListAcceleratorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* PrepareAsyncListAcceleratorTypesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::AcceleratorType>* AsyncGetAcceleratorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::AcceleratorType>* PrepareAsyncGetAcceleratorTypeRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* AsyncListRuntimeVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* PrepareAsyncListRuntimeVersionsRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::RuntimeVersion>* AsyncGetRuntimeVersionRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::RuntimeVersion>* PrepareAsyncGetRuntimeVersionRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GetGuestAttributesResponse>* AsyncGetGuestAttributesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::tpu::v2::GetGuestAttributesResponse>* PrepareAsyncGetGuestAttributesRaw(::grpc::ClientContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListNodes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNode_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateNode_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteNode_;
    const ::grpc::internal::RpcMethod rpcmethod_StopNode_;
    const ::grpc::internal::RpcMethod rpcmethod_StartNode_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateNode_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateServiceIdentity_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAcceleratorTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAcceleratorType_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRuntimeVersions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRuntimeVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_GetGuestAttributes_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists nodes.
    virtual ::grpc::Status ListNodes(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::ListNodesRequest* request, ::google::cloud::tpu::v2::ListNodesResponse* response);
    // Gets the details of a node.
    virtual ::grpc::Status GetNode(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::GetNodeRequest* request, ::google::cloud::tpu::v2::Node* response);
    // Creates a node.
    virtual ::grpc::Status CreateNode(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest* request, ::google::longrunning::Operation* response);
    // Deletes a node.
    virtual ::grpc::Status DeleteNode(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest* request, ::google::longrunning::Operation* response);
    // Stops a node. This operation is only available with single TPU nodes.
    virtual ::grpc::Status StopNode(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::StopNodeRequest* request, ::google::longrunning::Operation* response);
    // Starts a node.
    virtual ::grpc::Status StartNode(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::StartNodeRequest* request, ::google::longrunning::Operation* response);
    // Updates the configurations of a node.
    virtual ::grpc::Status UpdateNode(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest* request, ::google::longrunning::Operation* response);
    // Generates the Cloud TPU service identity for the project.
    virtual ::grpc::Status GenerateServiceIdentity(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response);
    // Lists accelerator types supported by this API.
    virtual ::grpc::Status ListAcceleratorTypes(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response);
    // Gets AcceleratorType.
    virtual ::grpc::Status GetAcceleratorType(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* request, ::google::cloud::tpu::v2::AcceleratorType* response);
    // Lists runtime versions supported by this API.
    virtual ::grpc::Status ListRuntimeVersions(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response);
    // Gets a runtime version.
    virtual ::grpc::Status GetRuntimeVersion(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* request, ::google::cloud::tpu::v2::RuntimeVersion* response);
    // Retrieves the guest attributes for the node.
    virtual ::grpc::Status GetGuestAttributes(::grpc::ServerContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNodes() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListNodesRequest* /*request*/, ::google::cloud::tpu::v2::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodes(::grpc::ServerContext* context, ::google::cloud::tpu::v2::ListNodesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::ListNodesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNode() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetNodeRequest* /*request*/, ::google::cloud::tpu::v2::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNode(::grpc::ServerContext* context, ::google::cloud::tpu::v2::GetNodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::Node>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateNode() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::CreateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNode(::grpc::ServerContext* context, ::google::cloud::tpu::v2::CreateNodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteNode() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::DeleteNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNode(::grpc::ServerContext* context, ::google::cloud::tpu::v2::DeleteNodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StopNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StopNode() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_StopNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StopNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopNode(::grpc::ServerContext* context, ::google::cloud::tpu::v2::StopNodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StartNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StartNode() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_StartNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StartNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartNode(::grpc::ServerContext* context, ::google::cloud::tpu::v2::StartNodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateNode() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::UpdateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNode(::grpc::ServerContext* context, ::google::cloud::tpu::v2::UpdateNodeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateServiceIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateServiceIdentity() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GenerateServiceIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateServiceIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* /*request*/, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateServiceIdentity(::grpc::ServerContext* context, ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAcceleratorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAcceleratorTypes() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListAcceleratorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAcceleratorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* /*request*/, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAcceleratorTypes(::grpc::ServerContext* context, ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAcceleratorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAcceleratorType() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetAcceleratorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAcceleratorType(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* /*request*/, ::google::cloud::tpu::v2::AcceleratorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAcceleratorType(::grpc::ServerContext* context, ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::AcceleratorType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRuntimeVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRuntimeVersions() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListRuntimeVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimeVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* /*request*/, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRuntimeVersions(::grpc::ServerContext* context, ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRuntimeVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRuntimeVersion() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetRuntimeVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRuntimeVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* /*request*/, ::google::cloud::tpu::v2::RuntimeVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRuntimeVersion(::grpc::ServerContext* context, ::google::cloud::tpu::v2::GetRuntimeVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::RuntimeVersion>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetGuestAttributes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetGuestAttributes() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetGuestAttributes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGuestAttributes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* /*request*/, ::google::cloud::tpu::v2::GetGuestAttributesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGuestAttributes(::grpc::ServerContext* context, ::google::cloud::tpu::v2::GetGuestAttributesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::tpu::v2::GetGuestAttributesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListNodes<WithAsyncMethod_GetNode<WithAsyncMethod_CreateNode<WithAsyncMethod_DeleteNode<WithAsyncMethod_StopNode<WithAsyncMethod_StartNode<WithAsyncMethod_UpdateNode<WithAsyncMethod_GenerateServiceIdentity<WithAsyncMethod_ListAcceleratorTypes<WithAsyncMethod_GetAcceleratorType<WithAsyncMethod_ListRuntimeVersions<WithAsyncMethod_GetRuntimeVersion<WithAsyncMethod_GetGuestAttributes<Service > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNodes() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::ListNodesRequest, ::google::cloud::tpu::v2::ListNodesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::ListNodesRequest* request, ::google::cloud::tpu::v2::ListNodesResponse* response) { return this->ListNodes(context, request, response); }));}
    void SetMessageAllocatorFor_ListNodes(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::ListNodesRequest, ::google::cloud::tpu::v2::ListNodesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::ListNodesRequest, ::google::cloud::tpu::v2::ListNodesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListNodesRequest* /*request*/, ::google::cloud::tpu::v2::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::ListNodesRequest* /*request*/, ::google::cloud::tpu::v2::ListNodesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNode() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetNodeRequest, ::google::cloud::tpu::v2::Node>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::GetNodeRequest* request, ::google::cloud::tpu::v2::Node* response) { return this->GetNode(context, request, response); }));}
    void SetMessageAllocatorFor_GetNode(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::GetNodeRequest, ::google::cloud::tpu::v2::Node>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetNodeRequest, ::google::cloud::tpu::v2::Node>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetNodeRequest* /*request*/, ::google::cloud::tpu::v2::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::GetNodeRequest* /*request*/, ::google::cloud::tpu::v2::Node* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateNode() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::CreateNodeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::CreateNodeRequest* request, ::google::longrunning::Operation* response) { return this->CreateNode(context, request, response); }));}
    void SetMessageAllocatorFor_CreateNode(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::CreateNodeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::CreateNodeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::CreateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::CreateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteNode() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::DeleteNodeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::DeleteNodeRequest* request, ::google::longrunning::Operation* response) { return this->DeleteNode(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteNode(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::DeleteNodeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::DeleteNodeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::DeleteNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::DeleteNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StopNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StopNode() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::StopNodeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::StopNodeRequest* request, ::google::longrunning::Operation* response) { return this->StopNode(context, request, response); }));}
    void SetMessageAllocatorFor_StopNode(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::StopNodeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::StopNodeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StopNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StopNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopNode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::StopNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StartNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StartNode() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::StartNodeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::StartNodeRequest* request, ::google::longrunning::Operation* response) { return this->StartNode(context, request, response); }));}
    void SetMessageAllocatorFor_StartNode(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::StartNodeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::StartNodeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StartNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StartNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartNode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::StartNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateNode() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::UpdateNodeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::UpdateNodeRequest* request, ::google::longrunning::Operation* response) { return this->UpdateNode(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateNode(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::UpdateNodeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::UpdateNodeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::UpdateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNode(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::UpdateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateServiceIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateServiceIdentity() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GenerateServiceIdentityRequest, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* request, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* response) { return this->GenerateServiceIdentity(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateServiceIdentity(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::GenerateServiceIdentityRequest, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GenerateServiceIdentityRequest, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateServiceIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateServiceIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* /*request*/, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateServiceIdentity(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* /*request*/, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAcceleratorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAcceleratorTypes() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::ListAcceleratorTypesRequest, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* request, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* response) { return this->ListAcceleratorTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListAcceleratorTypes(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::ListAcceleratorTypesRequest, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::ListAcceleratorTypesRequest, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAcceleratorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAcceleratorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* /*request*/, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAcceleratorTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* /*request*/, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAcceleratorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAcceleratorType() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetAcceleratorTypeRequest, ::google::cloud::tpu::v2::AcceleratorType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* request, ::google::cloud::tpu::v2::AcceleratorType* response) { return this->GetAcceleratorType(context, request, response); }));}
    void SetMessageAllocatorFor_GetAcceleratorType(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::GetAcceleratorTypeRequest, ::google::cloud::tpu::v2::AcceleratorType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetAcceleratorTypeRequest, ::google::cloud::tpu::v2::AcceleratorType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAcceleratorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAcceleratorType(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* /*request*/, ::google::cloud::tpu::v2::AcceleratorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAcceleratorType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* /*request*/, ::google::cloud::tpu::v2::AcceleratorType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRuntimeVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRuntimeVersions() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::ListRuntimeVersionsRequest, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* request, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* response) { return this->ListRuntimeVersions(context, request, response); }));}
    void SetMessageAllocatorFor_ListRuntimeVersions(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::ListRuntimeVersionsRequest, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::ListRuntimeVersionsRequest, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRuntimeVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimeVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* /*request*/, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRuntimeVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* /*request*/, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRuntimeVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRuntimeVersion() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetRuntimeVersionRequest, ::google::cloud::tpu::v2::RuntimeVersion>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* request, ::google::cloud::tpu::v2::RuntimeVersion* response) { return this->GetRuntimeVersion(context, request, response); }));}
    void SetMessageAllocatorFor_GetRuntimeVersion(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::GetRuntimeVersionRequest, ::google::cloud::tpu::v2::RuntimeVersion>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetRuntimeVersionRequest, ::google::cloud::tpu::v2::RuntimeVersion>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRuntimeVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRuntimeVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* /*request*/, ::google::cloud::tpu::v2::RuntimeVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRuntimeVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* /*request*/, ::google::cloud::tpu::v2::RuntimeVersion* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetGuestAttributes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetGuestAttributes() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetGuestAttributesRequest, ::google::cloud::tpu::v2::GetGuestAttributesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* request, ::google::cloud::tpu::v2::GetGuestAttributesResponse* response) { return this->GetGuestAttributes(context, request, response); }));}
    void SetMessageAllocatorFor_GetGuestAttributes(
        ::grpc::MessageAllocator< ::google::cloud::tpu::v2::GetGuestAttributesRequest, ::google::cloud::tpu::v2::GetGuestAttributesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::tpu::v2::GetGuestAttributesRequest, ::google::cloud::tpu::v2::GetGuestAttributesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetGuestAttributes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGuestAttributes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* /*request*/, ::google::cloud::tpu::v2::GetGuestAttributesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGuestAttributes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* /*request*/, ::google::cloud::tpu::v2::GetGuestAttributesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListNodes<WithCallbackMethod_GetNode<WithCallbackMethod_CreateNode<WithCallbackMethod_DeleteNode<WithCallbackMethod_StopNode<WithCallbackMethod_StartNode<WithCallbackMethod_UpdateNode<WithCallbackMethod_GenerateServiceIdentity<WithCallbackMethod_ListAcceleratorTypes<WithCallbackMethod_GetAcceleratorType<WithCallbackMethod_ListRuntimeVersions<WithCallbackMethod_GetRuntimeVersion<WithCallbackMethod_GetGuestAttributes<Service > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNodes() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListNodesRequest* /*request*/, ::google::cloud::tpu::v2::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNode() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetNodeRequest* /*request*/, ::google::cloud::tpu::v2::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateNode() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::CreateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteNode() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::DeleteNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StopNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StopNode() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_StopNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StopNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StartNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StartNode() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_StartNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StartNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateNode() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::UpdateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateServiceIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateServiceIdentity() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GenerateServiceIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateServiceIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* /*request*/, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAcceleratorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAcceleratorTypes() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListAcceleratorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAcceleratorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* /*request*/, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAcceleratorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAcceleratorType() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetAcceleratorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAcceleratorType(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* /*request*/, ::google::cloud::tpu::v2::AcceleratorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRuntimeVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRuntimeVersions() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListRuntimeVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimeVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* /*request*/, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRuntimeVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRuntimeVersion() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetRuntimeVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRuntimeVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* /*request*/, ::google::cloud::tpu::v2::RuntimeVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetGuestAttributes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetGuestAttributes() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetGuestAttributes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGuestAttributes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* /*request*/, ::google::cloud::tpu::v2::GetGuestAttributesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNodes() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListNodesRequest* /*request*/, ::google::cloud::tpu::v2::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNode() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetNodeRequest* /*request*/, ::google::cloud::tpu::v2::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateNode() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::CreateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteNode() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::DeleteNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StopNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StopNode() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_StopNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StopNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopNode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StartNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StartNode() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_StartNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StartNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartNode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateNode() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::UpdateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNode(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateServiceIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateServiceIdentity() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GenerateServiceIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateServiceIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* /*request*/, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateServiceIdentity(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAcceleratorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAcceleratorTypes() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListAcceleratorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAcceleratorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* /*request*/, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAcceleratorTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAcceleratorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAcceleratorType() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetAcceleratorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAcceleratorType(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* /*request*/, ::google::cloud::tpu::v2::AcceleratorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAcceleratorType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRuntimeVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRuntimeVersions() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListRuntimeVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimeVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* /*request*/, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRuntimeVersions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRuntimeVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRuntimeVersion() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetRuntimeVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRuntimeVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* /*request*/, ::google::cloud::tpu::v2::RuntimeVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRuntimeVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetGuestAttributes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetGuestAttributes() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetGuestAttributes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGuestAttributes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* /*request*/, ::google::cloud::tpu::v2::GetGuestAttributesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGuestAttributes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNodes() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNodes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListNodesRequest* /*request*/, ::google::cloud::tpu::v2::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNode() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNode(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetNodeRequest* /*request*/, ::google::cloud::tpu::v2::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateNode() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateNode(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::CreateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteNode() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteNode(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::DeleteNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StopNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StopNode() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StopNode(context, request, response); }));
    }
    ~WithRawCallbackMethod_StopNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StopNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopNode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StartNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StartNode() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StartNode(context, request, response); }));
    }
    ~WithRawCallbackMethod_StartNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StartNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartNode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateNode() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateNode(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::UpdateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNode(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateServiceIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateServiceIdentity() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateServiceIdentity(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateServiceIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateServiceIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* /*request*/, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateServiceIdentity(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAcceleratorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAcceleratorTypes() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAcceleratorTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAcceleratorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAcceleratorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* /*request*/, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAcceleratorTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAcceleratorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAcceleratorType() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAcceleratorType(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAcceleratorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAcceleratorType(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* /*request*/, ::google::cloud::tpu::v2::AcceleratorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAcceleratorType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRuntimeVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRuntimeVersions() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRuntimeVersions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRuntimeVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRuntimeVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* /*request*/, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRuntimeVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRuntimeVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRuntimeVersion() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRuntimeVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRuntimeVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRuntimeVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* /*request*/, ::google::cloud::tpu::v2::RuntimeVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRuntimeVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetGuestAttributes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetGuestAttributes() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetGuestAttributes(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetGuestAttributes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGuestAttributes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* /*request*/, ::google::cloud::tpu::v2::GetGuestAttributesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGuestAttributes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNodes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNodes() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::ListNodesRequest, ::google::cloud::tpu::v2::ListNodesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::ListNodesRequest, ::google::cloud::tpu::v2::ListNodesResponse>* streamer) {
                       return this->StreamedListNodes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNodes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNodes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListNodesRequest* /*request*/, ::google::cloud::tpu::v2::ListNodesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNodes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::ListNodesRequest,::google::cloud::tpu::v2::ListNodesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNode() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::GetNodeRequest, ::google::cloud::tpu::v2::Node>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::GetNodeRequest, ::google::cloud::tpu::v2::Node>* streamer) {
                       return this->StreamedGetNode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetNodeRequest* /*request*/, ::google::cloud::tpu::v2::Node* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::GetNodeRequest,::google::cloud::tpu::v2::Node>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateNode() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::CreateNodeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::CreateNodeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateNode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::CreateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateNode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::CreateNodeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteNode() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::DeleteNodeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::DeleteNodeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteNode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::DeleteNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteNode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::DeleteNodeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StopNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StopNode() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::StopNodeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::StopNodeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStopNode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StopNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StopNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StopNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStopNode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::StopNodeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StartNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StartNode() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::StartNodeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::StartNodeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStartNode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StartNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StartNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::StartNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStartNode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::StartNodeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateNode : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateNode() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::UpdateNodeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::UpdateNodeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateNode(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateNode() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateNode(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::UpdateNodeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateNode(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::UpdateNodeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateServiceIdentity : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateServiceIdentity() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::GenerateServiceIdentityRequest, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::GenerateServiceIdentityRequest, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* streamer) {
                       return this->StreamedGenerateServiceIdentity(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateServiceIdentity() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateServiceIdentity(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GenerateServiceIdentityRequest* /*request*/, ::google::cloud::tpu::v2::GenerateServiceIdentityResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateServiceIdentity(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::GenerateServiceIdentityRequest,::google::cloud::tpu::v2::GenerateServiceIdentityResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAcceleratorTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAcceleratorTypes() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::ListAcceleratorTypesRequest, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::ListAcceleratorTypesRequest, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* streamer) {
                       return this->StreamedListAcceleratorTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAcceleratorTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAcceleratorTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListAcceleratorTypesRequest* /*request*/, ::google::cloud::tpu::v2::ListAcceleratorTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAcceleratorTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::ListAcceleratorTypesRequest,::google::cloud::tpu::v2::ListAcceleratorTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAcceleratorType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAcceleratorType() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::GetAcceleratorTypeRequest, ::google::cloud::tpu::v2::AcceleratorType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::GetAcceleratorTypeRequest, ::google::cloud::tpu::v2::AcceleratorType>* streamer) {
                       return this->StreamedGetAcceleratorType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAcceleratorType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAcceleratorType(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetAcceleratorTypeRequest* /*request*/, ::google::cloud::tpu::v2::AcceleratorType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAcceleratorType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::GetAcceleratorTypeRequest,::google::cloud::tpu::v2::AcceleratorType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRuntimeVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRuntimeVersions() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::ListRuntimeVersionsRequest, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::ListRuntimeVersionsRequest, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* streamer) {
                       return this->StreamedListRuntimeVersions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRuntimeVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRuntimeVersions(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::ListRuntimeVersionsRequest* /*request*/, ::google::cloud::tpu::v2::ListRuntimeVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRuntimeVersions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::ListRuntimeVersionsRequest,::google::cloud::tpu::v2::ListRuntimeVersionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRuntimeVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRuntimeVersion() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::GetRuntimeVersionRequest, ::google::cloud::tpu::v2::RuntimeVersion>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::GetRuntimeVersionRequest, ::google::cloud::tpu::v2::RuntimeVersion>* streamer) {
                       return this->StreamedGetRuntimeVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRuntimeVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRuntimeVersion(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetRuntimeVersionRequest* /*request*/, ::google::cloud::tpu::v2::RuntimeVersion* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRuntimeVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::GetRuntimeVersionRequest,::google::cloud::tpu::v2::RuntimeVersion>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetGuestAttributes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetGuestAttributes() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::tpu::v2::GetGuestAttributesRequest, ::google::cloud::tpu::v2::GetGuestAttributesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::tpu::v2::GetGuestAttributesRequest, ::google::cloud::tpu::v2::GetGuestAttributesResponse>* streamer) {
                       return this->StreamedGetGuestAttributes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetGuestAttributes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetGuestAttributes(::grpc::ServerContext* /*context*/, const ::google::cloud::tpu::v2::GetGuestAttributesRequest* /*request*/, ::google::cloud::tpu::v2::GetGuestAttributesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetGuestAttributes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::tpu::v2::GetGuestAttributesRequest,::google::cloud::tpu::v2::GetGuestAttributesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListNodes<WithStreamedUnaryMethod_GetNode<WithStreamedUnaryMethod_CreateNode<WithStreamedUnaryMethod_DeleteNode<WithStreamedUnaryMethod_StopNode<WithStreamedUnaryMethod_StartNode<WithStreamedUnaryMethod_UpdateNode<WithStreamedUnaryMethod_GenerateServiceIdentity<WithStreamedUnaryMethod_ListAcceleratorTypes<WithStreamedUnaryMethod_GetAcceleratorType<WithStreamedUnaryMethod_ListRuntimeVersions<WithStreamedUnaryMethod_GetRuntimeVersion<WithStreamedUnaryMethod_GetGuestAttributes<Service > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListNodes<WithStreamedUnaryMethod_GetNode<WithStreamedUnaryMethod_CreateNode<WithStreamedUnaryMethod_DeleteNode<WithStreamedUnaryMethod_StopNode<WithStreamedUnaryMethod_StartNode<WithStreamedUnaryMethod_UpdateNode<WithStreamedUnaryMethod_GenerateServiceIdentity<WithStreamedUnaryMethod_ListAcceleratorTypes<WithStreamedUnaryMethod_GetAcceleratorType<WithStreamedUnaryMethod_ListRuntimeVersions<WithStreamedUnaryMethod_GetRuntimeVersion<WithStreamedUnaryMethod_GetGuestAttributes<Service > > > > > > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace tpu
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2ftpu_2fv2_2fcloud_5ftpu_2eproto__INCLUDED
