// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/storagetransfer/v1/transfer.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fstoragetransfer_2fv1_2ftransfer_2eproto__INCLUDED
#define GRPC_google_2fstoragetransfer_2fv1_2ftransfer_2eproto__INCLUDED

#include "google/storagetransfer/v1/transfer.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace storagetransfer {
namespace v1 {

// Storage Transfer Service and its protos.
// Transfers data between between Google Cloud Storage buckets or from a data
// source external to Google to a Cloud Storage bucket.
class StorageTransferService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.storagetransfer.v1.StorageTransferService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns the Google service account that is used by Storage Transfer
    // Service to access buckets in the project where transfers
    // run or in other projects. Each Google service account is associated
    // with one Google Cloud project. Users
    // should add this service account to the Google Cloud Storage bucket
    // ACLs to grant access to Storage Transfer Service. This service
    // account is created and owned by Storage Transfer Service and can
    // only be used by Storage Transfer Service.
    virtual ::grpc::Status GetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::google::storagetransfer::v1::GoogleServiceAccount* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::GoogleServiceAccount>> AsyncGetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::GoogleServiceAccount>>(AsyncGetGoogleServiceAccountRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::GoogleServiceAccount>> PrepareAsyncGetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::GoogleServiceAccount>>(PrepareAsyncGetGoogleServiceAccountRaw(context, request, cq));
    }
    // Creates a transfer job that runs periodically.
    virtual ::grpc::Status CreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::google::storagetransfer::v1::TransferJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>> AsyncCreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>>(AsyncCreateTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>> PrepareAsyncCreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>>(PrepareAsyncCreateTransferJobRaw(context, request, cq));
    }
    // Updates a transfer job. Updating a job's transfer spec does not affect
    // transfer operations that are running already.
    //
    // **Note:** The job's [status][google.storagetransfer.v1.TransferJob.status]
    // field can be modified using this RPC (for example, to set a job's status to
    // [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED],
    // [DISABLED][google.storagetransfer.v1.TransferJob.Status.DISABLED], or
    // [ENABLED][google.storagetransfer.v1.TransferJob.Status.ENABLED]).
    virtual ::grpc::Status UpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::google::storagetransfer::v1::TransferJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>> AsyncUpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>>(AsyncUpdateTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>> PrepareAsyncUpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>>(PrepareAsyncUpdateTransferJobRaw(context, request, cq));
    }
    // Gets a transfer job.
    virtual ::grpc::Status GetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::google::storagetransfer::v1::TransferJob* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>> AsyncGetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>>(AsyncGetTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>> PrepareAsyncGetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>>(PrepareAsyncGetTransferJobRaw(context, request, cq));
    }
    // Lists transfer jobs.
    virtual ::grpc::Status ListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::google::storagetransfer::v1::ListTransferJobsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListTransferJobsResponse>> AsyncListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListTransferJobsResponse>>(AsyncListTransferJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListTransferJobsResponse>> PrepareAsyncListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListTransferJobsResponse>>(PrepareAsyncListTransferJobsRaw(context, request, cq));
    }
    // Pauses a transfer operation.
    virtual ::grpc::Status PauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncPauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncPauseTransferOperationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncPauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncPauseTransferOperationRaw(context, request, cq));
    }
    // Resumes a transfer operation that is paused.
    virtual ::grpc::Status ResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncResumeTransferOperationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncResumeTransferOperationRaw(context, request, cq));
    }
    // Starts a new operation for the specified transfer job.
    // A `TransferJob` has a maximum of one active `TransferOperation`. If this
    // method is called while a `TransferOperation` is active, an error is
    // returned.
    virtual ::grpc::Status RunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRunTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRunTransferJobRaw(context, request, cq));
    }
    // Deletes a transfer job. Deleting a transfer job sets its status to
    // [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED].
    virtual ::grpc::Status DeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTransferJobRaw(context, request, cq));
    }
    // Creates an agent pool resource.
    virtual ::grpc::Status CreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::google::storagetransfer::v1::AgentPool* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>> AsyncCreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>>(AsyncCreateAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>> PrepareAsyncCreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>>(PrepareAsyncCreateAgentPoolRaw(context, request, cq));
    }
    // Updates an existing agent pool resource.
    virtual ::grpc::Status UpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::google::storagetransfer::v1::AgentPool* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>> AsyncUpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>>(AsyncUpdateAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>> PrepareAsyncUpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>>(PrepareAsyncUpdateAgentPoolRaw(context, request, cq));
    }
    // Gets an agent pool.
    virtual ::grpc::Status GetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::google::storagetransfer::v1::AgentPool* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>> AsyncGetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>>(AsyncGetAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>> PrepareAsyncGetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>>(PrepareAsyncGetAgentPoolRaw(context, request, cq));
    }
    // Lists agent pools.
    virtual ::grpc::Status ListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListAgentPoolsResponse>> AsyncListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListAgentPoolsResponse>>(AsyncListAgentPoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListAgentPoolsResponse>> PrepareAsyncListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListAgentPoolsResponse>>(PrepareAsyncListAgentPoolsRaw(context, request, cq));
    }
    // Deletes an agent pool.
    virtual ::grpc::Status DeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteAgentPoolRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Returns the Google service account that is used by Storage Transfer
      // Service to access buckets in the project where transfers
      // run or in other projects. Each Google service account is associated
      // with one Google Cloud project. Users
      // should add this service account to the Google Cloud Storage bucket
      // ACLs to grant access to Storage Transfer Service. This service
      // account is created and owned by Storage Transfer Service and can
      // only be used by Storage Transfer Service.
      virtual void GetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* request, ::google::storagetransfer::v1::GoogleServiceAccount* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* request, ::google::storagetransfer::v1::GoogleServiceAccount* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a transfer job that runs periodically.
      virtual void CreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a transfer job. Updating a job's transfer spec does not affect
      // transfer operations that are running already.
      //
      // **Note:** The job's [status][google.storagetransfer.v1.TransferJob.status]
      // field can be modified using this RPC (for example, to set a job's status to
      // [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED],
      // [DISABLED][google.storagetransfer.v1.TransferJob.Status.DISABLED], or
      // [ENABLED][google.storagetransfer.v1.TransferJob.Status.ENABLED]).
      virtual void UpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a transfer job.
      virtual void GetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists transfer jobs.
      virtual void ListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest* request, ::google::storagetransfer::v1::ListTransferJobsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest* request, ::google::storagetransfer::v1::ListTransferJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Pauses a transfer operation.
      virtual void PauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resumes a transfer operation that is paused.
      virtual void ResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts a new operation for the specified transfer job.
      // A `TransferJob` has a maximum of one active `TransferOperation`. If this
      // method is called while a `TransferOperation` is active, an error is
      // returned.
      virtual void RunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a transfer job. Deleting a transfer job sets its status to
      // [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED].
      virtual void DeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an agent pool resource.
      virtual void CreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing agent pool resource.
      virtual void UpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an agent pool.
      virtual void GetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists agent pools.
      virtual void ListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest* request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest* request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an agent pool.
      virtual void DeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::GoogleServiceAccount>* AsyncGetGoogleServiceAccountRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::GoogleServiceAccount>* PrepareAsyncGetGoogleServiceAccountRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>* AsyncCreateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>* PrepareAsyncCreateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>* AsyncUpdateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>* PrepareAsyncUpdateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>* AsyncGetTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::TransferJob>* PrepareAsyncGetTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListTransferJobsResponse>* AsyncListTransferJobsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListTransferJobsResponse>* PrepareAsyncListTransferJobsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncPauseTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncPauseTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncResumeTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncResumeTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRunTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRunTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>* AsyncCreateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>* PrepareAsyncCreateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>* AsyncUpdateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>* PrepareAsyncUpdateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>* AsyncGetAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::AgentPool>* PrepareAsyncGetAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListAgentPoolsResponse>* AsyncListAgentPoolsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::storagetransfer::v1::ListAgentPoolsResponse>* PrepareAsyncListAgentPoolsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::google::storagetransfer::v1::GoogleServiceAccount* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::GoogleServiceAccount>> AsyncGetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::GoogleServiceAccount>>(AsyncGetGoogleServiceAccountRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::GoogleServiceAccount>> PrepareAsyncGetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::GoogleServiceAccount>>(PrepareAsyncGetGoogleServiceAccountRaw(context, request, cq));
    }
    ::grpc::Status CreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::google::storagetransfer::v1::TransferJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>> AsyncCreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>>(AsyncCreateTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>> PrepareAsyncCreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>>(PrepareAsyncCreateTransferJobRaw(context, request, cq));
    }
    ::grpc::Status UpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::google::storagetransfer::v1::TransferJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>> AsyncUpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>>(AsyncUpdateTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>> PrepareAsyncUpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>>(PrepareAsyncUpdateTransferJobRaw(context, request, cq));
    }
    ::grpc::Status GetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::google::storagetransfer::v1::TransferJob* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>> AsyncGetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>>(AsyncGetTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>> PrepareAsyncGetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>>(PrepareAsyncGetTransferJobRaw(context, request, cq));
    }
    ::grpc::Status ListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::google::storagetransfer::v1::ListTransferJobsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListTransferJobsResponse>> AsyncListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListTransferJobsResponse>>(AsyncListTransferJobsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListTransferJobsResponse>> PrepareAsyncListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListTransferJobsResponse>>(PrepareAsyncListTransferJobsRaw(context, request, cq));
    }
    ::grpc::Status PauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncPauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncPauseTransferOperationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncPauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncPauseTransferOperationRaw(context, request, cq));
    }
    ::grpc::Status ResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncResumeTransferOperationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncResumeTransferOperationRaw(context, request, cq));
    }
    ::grpc::Status RunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRunTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRunTransferJobRaw(context, request, cq));
    }
    ::grpc::Status DeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTransferJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTransferJobRaw(context, request, cq));
    }
    ::grpc::Status CreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::google::storagetransfer::v1::AgentPool* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>> AsyncCreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>>(AsyncCreateAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>> PrepareAsyncCreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>>(PrepareAsyncCreateAgentPoolRaw(context, request, cq));
    }
    ::grpc::Status UpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::google::storagetransfer::v1::AgentPool* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>> AsyncUpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>>(AsyncUpdateAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>> PrepareAsyncUpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>>(PrepareAsyncUpdateAgentPoolRaw(context, request, cq));
    }
    ::grpc::Status GetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::google::storagetransfer::v1::AgentPool* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>> AsyncGetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>>(AsyncGetAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>> PrepareAsyncGetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>>(PrepareAsyncGetAgentPoolRaw(context, request, cq));
    }
    ::grpc::Status ListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListAgentPoolsResponse>> AsyncListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListAgentPoolsResponse>>(AsyncListAgentPoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListAgentPoolsResponse>> PrepareAsyncListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListAgentPoolsResponse>>(PrepareAsyncListAgentPoolsRaw(context, request, cq));
    }
    ::grpc::Status DeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteAgentPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteAgentPoolRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* request, ::google::storagetransfer::v1::GoogleServiceAccount* response, std::function<void(::grpc::Status)>) override;
      void GetGoogleServiceAccount(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* request, ::google::storagetransfer::v1::GoogleServiceAccount* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, std::function<void(::grpc::Status)>) override;
      void CreateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, std::function<void(::grpc::Status)>) override;
      void UpdateTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, std::function<void(::grpc::Status)>) override;
      void GetTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest* request, ::google::storagetransfer::v1::ListTransferJobsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTransferJobs(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest* request, ::google::storagetransfer::v1::ListTransferJobsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void PauseTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void ResumeTransferOperation(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RunTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTransferJob(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, std::function<void(::grpc::Status)>) override;
      void CreateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, std::function<void(::grpc::Status)>) override;
      void UpdateAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, std::function<void(::grpc::Status)>) override;
      void GetAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest* request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAgentPools(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest* request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteAgentPool(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::GoogleServiceAccount>* AsyncGetGoogleServiceAccountRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::GoogleServiceAccount>* PrepareAsyncGetGoogleServiceAccountRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>* AsyncCreateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>* PrepareAsyncCreateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>* AsyncUpdateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>* PrepareAsyncUpdateTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>* AsyncGetTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::TransferJob>* PrepareAsyncGetTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListTransferJobsResponse>* AsyncListTransferJobsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListTransferJobsResponse>* PrepareAsyncListTransferJobsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncPauseTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncPauseTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncResumeTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncResumeTransferOperationRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRunTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRunTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTransferJobRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>* AsyncCreateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>* PrepareAsyncCreateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>* AsyncUpdateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>* PrepareAsyncUpdateAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>* AsyncGetAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::AgentPool>* PrepareAsyncGetAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListAgentPoolsResponse>* AsyncListAgentPoolsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::storagetransfer::v1::ListAgentPoolsResponse>* PrepareAsyncListAgentPoolsRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteAgentPoolRaw(::grpc::ClientContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetGoogleServiceAccount_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTransferJob_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTransferJob_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTransferJob_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTransferJobs_;
    const ::grpc::internal::RpcMethod rpcmethod_PauseTransferOperation_;
    const ::grpc::internal::RpcMethod rpcmethod_ResumeTransferOperation_;
    const ::grpc::internal::RpcMethod rpcmethod_RunTransferJob_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTransferJob_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAgentPool_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAgentPool_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAgentPool_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAgentPools_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAgentPool_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns the Google service account that is used by Storage Transfer
    // Service to access buckets in the project where transfers
    // run or in other projects. Each Google service account is associated
    // with one Google Cloud project. Users
    // should add this service account to the Google Cloud Storage bucket
    // ACLs to grant access to Storage Transfer Service. This service
    // account is created and owned by Storage Transfer Service and can
    // only be used by Storage Transfer Service.
    virtual ::grpc::Status GetGoogleServiceAccount(::grpc::ServerContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* request, ::google::storagetransfer::v1::GoogleServiceAccount* response);
    // Creates a transfer job that runs periodically.
    virtual ::grpc::Status CreateTransferJob(::grpc::ServerContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response);
    // Updates a transfer job. Updating a job's transfer spec does not affect
    // transfer operations that are running already.
    //
    // **Note:** The job's [status][google.storagetransfer.v1.TransferJob.status]
    // field can be modified using this RPC (for example, to set a job's status to
    // [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED],
    // [DISABLED][google.storagetransfer.v1.TransferJob.Status.DISABLED], or
    // [ENABLED][google.storagetransfer.v1.TransferJob.Status.ENABLED]).
    virtual ::grpc::Status UpdateTransferJob(::grpc::ServerContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response);
    // Gets a transfer job.
    virtual ::grpc::Status GetTransferJob(::grpc::ServerContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response);
    // Lists transfer jobs.
    virtual ::grpc::Status ListTransferJobs(::grpc::ServerContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest* request, ::google::storagetransfer::v1::ListTransferJobsResponse* response);
    // Pauses a transfer operation.
    virtual ::grpc::Status PauseTransferOperation(::grpc::ServerContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest* request, ::google::protobuf::Empty* response);
    // Resumes a transfer operation that is paused.
    virtual ::grpc::Status ResumeTransferOperation(::grpc::ServerContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* request, ::google::protobuf::Empty* response);
    // Starts a new operation for the specified transfer job.
    // A `TransferJob` has a maximum of one active `TransferOperation`. If this
    // method is called while a `TransferOperation` is active, an error is
    // returned.
    virtual ::grpc::Status RunTransferJob(::grpc::ServerContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest* request, ::google::longrunning::Operation* response);
    // Deletes a transfer job. Deleting a transfer job sets its status to
    // [DELETED][google.storagetransfer.v1.TransferJob.Status.DELETED].
    virtual ::grpc::Status DeleteTransferJob(::grpc::ServerContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest* request, ::google::protobuf::Empty* response);
    // Creates an agent pool resource.
    virtual ::grpc::Status CreateAgentPool(::grpc::ServerContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response);
    // Updates an existing agent pool resource.
    virtual ::grpc::Status UpdateAgentPool(::grpc::ServerContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response);
    // Gets an agent pool.
    virtual ::grpc::Status GetAgentPool(::grpc::ServerContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response);
    // Lists agent pools.
    virtual ::grpc::Status ListAgentPools(::grpc::ServerContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest* request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response);
    // Deletes an agent pool.
    virtual ::grpc::Status DeleteAgentPool(::grpc::ServerContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetGoogleServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetGoogleServiceAccount() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetGoogleServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGoogleServiceAccount(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* /*request*/, ::google::storagetransfer::v1::GoogleServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGoogleServiceAccount(::grpc::ServerContext* context, ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::GoogleServiceAccount>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTransferJob() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTransferJob(::grpc::ServerContext* context, ::google::storagetransfer::v1::CreateTransferJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::TransferJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTransferJob() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTransferJob(::grpc::ServerContext* context, ::google::storagetransfer::v1::UpdateTransferJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::TransferJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTransferJob() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTransferJob(::grpc::ServerContext* context, ::google::storagetransfer::v1::GetTransferJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::TransferJob>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTransferJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTransferJobs() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListTransferJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferJobs(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListTransferJobsRequest* /*request*/, ::google::storagetransfer::v1::ListTransferJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTransferJobs(::grpc::ServerContext* context, ::google::storagetransfer::v1::ListTransferJobsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::ListTransferJobsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PauseTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PauseTransferOperation() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_PauseTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::PauseTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPauseTransferOperation(::grpc::ServerContext* context, ::google::storagetransfer::v1::PauseTransferOperationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResumeTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResumeTransferOperation() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ResumeTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResumeTransferOperation(::grpc::ServerContext* context, ::google::storagetransfer::v1::ResumeTransferOperationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RunTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RunTransferJob() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_RunTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::RunTransferJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunTransferJob(::grpc::ServerContext* context, ::google::storagetransfer::v1::RunTransferJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTransferJob() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DeleteTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteTransferJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTransferJob(::grpc::ServerContext* context, ::google::storagetransfer::v1::DeleteTransferJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAgentPool() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_CreateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAgentPool(::grpc::ServerContext* context, ::google::storagetransfer::v1::CreateAgentPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::AgentPool>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAgentPool() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_UpdateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAgentPool(::grpc::ServerContext* context, ::google::storagetransfer::v1::UpdateAgentPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::AgentPool>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAgentPool() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAgentPool(::grpc::ServerContext* context, ::google::storagetransfer::v1::GetAgentPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::AgentPool>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAgentPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAgentPools() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ListAgentPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAgentPools(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListAgentPoolsRequest* /*request*/, ::google::storagetransfer::v1::ListAgentPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAgentPools(::grpc::ServerContext* context, ::google::storagetransfer::v1::ListAgentPoolsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::storagetransfer::v1::ListAgentPoolsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAgentPool() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_DeleteAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAgentPool(::grpc::ServerContext* context, ::google::storagetransfer::v1::DeleteAgentPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetGoogleServiceAccount<WithAsyncMethod_CreateTransferJob<WithAsyncMethod_UpdateTransferJob<WithAsyncMethod_GetTransferJob<WithAsyncMethod_ListTransferJobs<WithAsyncMethod_PauseTransferOperation<WithAsyncMethod_ResumeTransferOperation<WithAsyncMethod_RunTransferJob<WithAsyncMethod_DeleteTransferJob<WithAsyncMethod_CreateAgentPool<WithAsyncMethod_UpdateAgentPool<WithAsyncMethod_GetAgentPool<WithAsyncMethod_ListAgentPools<WithAsyncMethod_DeleteAgentPool<Service > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetGoogleServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetGoogleServiceAccount() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::GetGoogleServiceAccountRequest, ::google::storagetransfer::v1::GoogleServiceAccount>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* request, ::google::storagetransfer::v1::GoogleServiceAccount* response) { return this->GetGoogleServiceAccount(context, request, response); }));}
    void SetMessageAllocatorFor_GetGoogleServiceAccount(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::GetGoogleServiceAccountRequest, ::google::storagetransfer::v1::GoogleServiceAccount>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::GetGoogleServiceAccountRequest, ::google::storagetransfer::v1::GoogleServiceAccount>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetGoogleServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGoogleServiceAccount(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* /*request*/, ::google::storagetransfer::v1::GoogleServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGoogleServiceAccount(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* /*request*/, ::google::storagetransfer::v1::GoogleServiceAccount* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTransferJob() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::CreateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::CreateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response) { return this->CreateTransferJob(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTransferJob(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::CreateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::CreateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::CreateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTransferJob() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::UpdateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::UpdateTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response) { return this->UpdateTransferJob(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTransferJob(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::UpdateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::UpdateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTransferJob() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::GetTransferJobRequest, ::google::storagetransfer::v1::TransferJob>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::GetTransferJobRequest* request, ::google::storagetransfer::v1::TransferJob* response) { return this->GetTransferJob(context, request, response); }));}
    void SetMessageAllocatorFor_GetTransferJob(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::GetTransferJobRequest, ::google::storagetransfer::v1::TransferJob>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::GetTransferJobRequest, ::google::storagetransfer::v1::TransferJob>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::GetTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTransferJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTransferJobs() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::ListTransferJobsRequest, ::google::storagetransfer::v1::ListTransferJobsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::ListTransferJobsRequest* request, ::google::storagetransfer::v1::ListTransferJobsResponse* response) { return this->ListTransferJobs(context, request, response); }));}
    void SetMessageAllocatorFor_ListTransferJobs(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::ListTransferJobsRequest, ::google::storagetransfer::v1::ListTransferJobsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::ListTransferJobsRequest, ::google::storagetransfer::v1::ListTransferJobsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTransferJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferJobs(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListTransferJobsRequest* /*request*/, ::google::storagetransfer::v1::ListTransferJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTransferJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::ListTransferJobsRequest* /*request*/, ::google::storagetransfer::v1::ListTransferJobsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PauseTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PauseTransferOperation() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::PauseTransferOperationRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::PauseTransferOperationRequest* request, ::google::protobuf::Empty* response) { return this->PauseTransferOperation(context, request, response); }));}
    void SetMessageAllocatorFor_PauseTransferOperation(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::PauseTransferOperationRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::PauseTransferOperationRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PauseTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::PauseTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PauseTransferOperation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::PauseTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResumeTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResumeTransferOperation() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::ResumeTransferOperationRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* request, ::google::protobuf::Empty* response) { return this->ResumeTransferOperation(context, request, response); }));}
    void SetMessageAllocatorFor_ResumeTransferOperation(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::ResumeTransferOperationRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::ResumeTransferOperationRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResumeTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResumeTransferOperation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RunTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RunTransferJob() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::RunTransferJobRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::RunTransferJobRequest* request, ::google::longrunning::Operation* response) { return this->RunTransferJob(context, request, response); }));}
    void SetMessageAllocatorFor_RunTransferJob(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::RunTransferJobRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::RunTransferJobRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RunTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::RunTransferJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::RunTransferJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTransferJob() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::DeleteTransferJobRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::DeleteTransferJobRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTransferJob(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTransferJob(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::DeleteTransferJobRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::DeleteTransferJobRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteTransferJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteTransferJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAgentPool() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::CreateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::CreateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response) { return this->CreateAgentPool(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAgentPool(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::CreateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::CreateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::CreateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAgentPool() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::UpdateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response) { return this->UpdateAgentPool(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAgentPool(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::UpdateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::UpdateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAgentPool() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::GetAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::GetAgentPoolRequest* request, ::google::storagetransfer::v1::AgentPool* response) { return this->GetAgentPool(context, request, response); }));}
    void SetMessageAllocatorFor_GetAgentPool(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::GetAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::GetAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::GetAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAgentPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAgentPools() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::ListAgentPoolsRequest, ::google::storagetransfer::v1::ListAgentPoolsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::ListAgentPoolsRequest* request, ::google::storagetransfer::v1::ListAgentPoolsResponse* response) { return this->ListAgentPools(context, request, response); }));}
    void SetMessageAllocatorFor_ListAgentPools(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::ListAgentPoolsRequest, ::google::storagetransfer::v1::ListAgentPoolsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::ListAgentPoolsRequest, ::google::storagetransfer::v1::ListAgentPoolsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAgentPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAgentPools(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListAgentPoolsRequest* /*request*/, ::google::storagetransfer::v1::ListAgentPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAgentPools(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::ListAgentPoolsRequest* /*request*/, ::google::storagetransfer::v1::ListAgentPoolsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAgentPool() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::DeleteAgentPoolRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* request, ::google::protobuf::Empty* response) { return this->DeleteAgentPool(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAgentPool(
        ::grpc::MessageAllocator< ::google::storagetransfer::v1::DeleteAgentPoolRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::storagetransfer::v1::DeleteAgentPoolRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetGoogleServiceAccount<WithCallbackMethod_CreateTransferJob<WithCallbackMethod_UpdateTransferJob<WithCallbackMethod_GetTransferJob<WithCallbackMethod_ListTransferJobs<WithCallbackMethod_PauseTransferOperation<WithCallbackMethod_ResumeTransferOperation<WithCallbackMethod_RunTransferJob<WithCallbackMethod_DeleteTransferJob<WithCallbackMethod_CreateAgentPool<WithCallbackMethod_UpdateAgentPool<WithCallbackMethod_GetAgentPool<WithCallbackMethod_ListAgentPools<WithCallbackMethod_DeleteAgentPool<Service > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetGoogleServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetGoogleServiceAccount() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetGoogleServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGoogleServiceAccount(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* /*request*/, ::google::storagetransfer::v1::GoogleServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTransferJob() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTransferJob() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTransferJob() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTransferJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTransferJobs() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListTransferJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferJobs(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListTransferJobsRequest* /*request*/, ::google::storagetransfer::v1::ListTransferJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PauseTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PauseTransferOperation() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_PauseTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::PauseTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResumeTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResumeTransferOperation() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ResumeTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RunTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RunTransferJob() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_RunTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::RunTransferJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTransferJob() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DeleteTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteTransferJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAgentPool() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_CreateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAgentPool() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_UpdateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAgentPool() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAgentPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAgentPools() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ListAgentPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAgentPools(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListAgentPoolsRequest* /*request*/, ::google::storagetransfer::v1::ListAgentPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAgentPool() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_DeleteAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetGoogleServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetGoogleServiceAccount() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetGoogleServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGoogleServiceAccount(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* /*request*/, ::google::storagetransfer::v1::GoogleServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGoogleServiceAccount(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTransferJob() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTransferJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTransferJob() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTransferJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTransferJob() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTransferJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTransferJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTransferJobs() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListTransferJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferJobs(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListTransferJobsRequest* /*request*/, ::google::storagetransfer::v1::ListTransferJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTransferJobs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PauseTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PauseTransferOperation() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_PauseTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::PauseTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPauseTransferOperation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResumeTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResumeTransferOperation() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ResumeTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResumeTransferOperation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RunTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RunTransferJob() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_RunTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::RunTransferJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunTransferJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTransferJob() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DeleteTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteTransferJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTransferJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAgentPool() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_CreateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAgentPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAgentPool() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_UpdateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAgentPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAgentPool() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAgentPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAgentPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAgentPools() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ListAgentPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAgentPools(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListAgentPoolsRequest* /*request*/, ::google::storagetransfer::v1::ListAgentPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAgentPools(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAgentPool() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_DeleteAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAgentPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetGoogleServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetGoogleServiceAccount() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetGoogleServiceAccount(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetGoogleServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGoogleServiceAccount(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* /*request*/, ::google::storagetransfer::v1::GoogleServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGoogleServiceAccount(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTransferJob() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTransferJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTransferJob() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTransferJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTransferJob() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTransferJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTransferJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTransferJobs() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTransferJobs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTransferJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTransferJobs(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListTransferJobsRequest* /*request*/, ::google::storagetransfer::v1::ListTransferJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTransferJobs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PauseTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PauseTransferOperation() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PauseTransferOperation(context, request, response); }));
    }
    ~WithRawCallbackMethod_PauseTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PauseTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::PauseTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PauseTransferOperation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResumeTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResumeTransferOperation() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResumeTransferOperation(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResumeTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResumeTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResumeTransferOperation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RunTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RunTransferJob() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RunTransferJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_RunTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::RunTransferJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTransferJob() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTransferJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteTransferJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTransferJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAgentPool() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAgentPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAgentPool() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAgentPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAgentPool() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAgentPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAgentPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAgentPools() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAgentPools(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAgentPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAgentPools(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListAgentPoolsRequest* /*request*/, ::google::storagetransfer::v1::ListAgentPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAgentPools(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAgentPool() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAgentPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAgentPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetGoogleServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetGoogleServiceAccount() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::GetGoogleServiceAccountRequest, ::google::storagetransfer::v1::GoogleServiceAccount>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::GetGoogleServiceAccountRequest, ::google::storagetransfer::v1::GoogleServiceAccount>* streamer) {
                       return this->StreamedGetGoogleServiceAccount(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetGoogleServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetGoogleServiceAccount(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetGoogleServiceAccountRequest* /*request*/, ::google::storagetransfer::v1::GoogleServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetGoogleServiceAccount(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::GetGoogleServiceAccountRequest,::google::storagetransfer::v1::GoogleServiceAccount>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTransferJob() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::CreateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::CreateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>* streamer) {
                       return this->StreamedCreateTransferJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTransferJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::CreateTransferJobRequest,::google::storagetransfer::v1::TransferJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTransferJob() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::UpdateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::UpdateTransferJobRequest, ::google::storagetransfer::v1::TransferJob>* streamer) {
                       return this->StreamedUpdateTransferJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTransferJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::UpdateTransferJobRequest,::google::storagetransfer::v1::TransferJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTransferJob() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::GetTransferJobRequest, ::google::storagetransfer::v1::TransferJob>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::GetTransferJobRequest, ::google::storagetransfer::v1::TransferJob>* streamer) {
                       return this->StreamedGetTransferJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetTransferJobRequest* /*request*/, ::google::storagetransfer::v1::TransferJob* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTransferJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::GetTransferJobRequest,::google::storagetransfer::v1::TransferJob>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTransferJobs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTransferJobs() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::ListTransferJobsRequest, ::google::storagetransfer::v1::ListTransferJobsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::ListTransferJobsRequest, ::google::storagetransfer::v1::ListTransferJobsResponse>* streamer) {
                       return this->StreamedListTransferJobs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTransferJobs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTransferJobs(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListTransferJobsRequest* /*request*/, ::google::storagetransfer::v1::ListTransferJobsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTransferJobs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::ListTransferJobsRequest,::google::storagetransfer::v1::ListTransferJobsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PauseTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PauseTransferOperation() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::PauseTransferOperationRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::PauseTransferOperationRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedPauseTransferOperation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PauseTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PauseTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::PauseTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPauseTransferOperation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::PauseTransferOperationRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResumeTransferOperation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResumeTransferOperation() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::ResumeTransferOperationRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::ResumeTransferOperationRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedResumeTransferOperation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResumeTransferOperation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResumeTransferOperation(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ResumeTransferOperationRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResumeTransferOperation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::ResumeTransferOperationRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RunTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RunTransferJob() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::RunTransferJobRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::RunTransferJobRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRunTransferJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RunTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RunTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::RunTransferJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRunTransferJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::RunTransferJobRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTransferJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTransferJob() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::DeleteTransferJobRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::DeleteTransferJobRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTransferJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTransferJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTransferJob(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteTransferJobRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTransferJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::DeleteTransferJobRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAgentPool() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::CreateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::CreateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>* streamer) {
                       return this->StreamedCreateAgentPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::CreateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAgentPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::CreateAgentPoolRequest,::google::storagetransfer::v1::AgentPool>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAgentPool() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::UpdateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::UpdateAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>* streamer) {
                       return this->StreamedUpdateAgentPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::UpdateAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAgentPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::UpdateAgentPoolRequest,::google::storagetransfer::v1::AgentPool>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAgentPool() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::GetAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::GetAgentPoolRequest, ::google::storagetransfer::v1::AgentPool>* streamer) {
                       return this->StreamedGetAgentPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::GetAgentPoolRequest* /*request*/, ::google::storagetransfer::v1::AgentPool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAgentPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::GetAgentPoolRequest,::google::storagetransfer::v1::AgentPool>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAgentPools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAgentPools() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::ListAgentPoolsRequest, ::google::storagetransfer::v1::ListAgentPoolsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::ListAgentPoolsRequest, ::google::storagetransfer::v1::ListAgentPoolsResponse>* streamer) {
                       return this->StreamedListAgentPools(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAgentPools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAgentPools(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::ListAgentPoolsRequest* /*request*/, ::google::storagetransfer::v1::ListAgentPoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAgentPools(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::ListAgentPoolsRequest,::google::storagetransfer::v1::ListAgentPoolsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAgentPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAgentPool() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::storagetransfer::v1::DeleteAgentPoolRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::storagetransfer::v1::DeleteAgentPoolRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteAgentPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAgentPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAgentPool(::grpc::ServerContext* /*context*/, const ::google::storagetransfer::v1::DeleteAgentPoolRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAgentPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::storagetransfer::v1::DeleteAgentPoolRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetGoogleServiceAccount<WithStreamedUnaryMethod_CreateTransferJob<WithStreamedUnaryMethod_UpdateTransferJob<WithStreamedUnaryMethod_GetTransferJob<WithStreamedUnaryMethod_ListTransferJobs<WithStreamedUnaryMethod_PauseTransferOperation<WithStreamedUnaryMethod_ResumeTransferOperation<WithStreamedUnaryMethod_RunTransferJob<WithStreamedUnaryMethod_DeleteTransferJob<WithStreamedUnaryMethod_CreateAgentPool<WithStreamedUnaryMethod_UpdateAgentPool<WithStreamedUnaryMethod_GetAgentPool<WithStreamedUnaryMethod_ListAgentPools<WithStreamedUnaryMethod_DeleteAgentPool<Service > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetGoogleServiceAccount<WithStreamedUnaryMethod_CreateTransferJob<WithStreamedUnaryMethod_UpdateTransferJob<WithStreamedUnaryMethod_GetTransferJob<WithStreamedUnaryMethod_ListTransferJobs<WithStreamedUnaryMethod_PauseTransferOperation<WithStreamedUnaryMethod_ResumeTransferOperation<WithStreamedUnaryMethod_RunTransferJob<WithStreamedUnaryMethod_DeleteTransferJob<WithStreamedUnaryMethod_CreateAgentPool<WithStreamedUnaryMethod_UpdateAgentPool<WithStreamedUnaryMethod_GetAgentPool<WithStreamedUnaryMethod_ListAgentPools<WithStreamedUnaryMethod_DeleteAgentPool<Service > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace storagetransfer
}  // namespace google


#endif  // GRPC_google_2fstoragetransfer_2fv1_2ftransfer_2eproto__INCLUDED
