// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/notebooks/v1/service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fnotebooks_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fnotebooks_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/notebooks/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace notebooks {
namespace v1 {

// API v1 service for Cloud AI Platform Notebooks.
class NotebookService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.notebooks.v1.NotebookService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists instances in a given project and location.
    virtual ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::google::cloud::notebooks::v1::ListInstancesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    // Gets details of a single Instance.
    virtual ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::google::cloud::notebooks::v1::Instance* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    // Creates a new Instance in a given project and location.
    virtual ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    // Registers an existing legacy notebook instance to the Notebooks API server.
    // Legacy instances are instances created with the legacy Compute Engine
    // calls. They are not manageable by the Notebooks API out of the box. This
    // call makes these instances manageable by the Notebooks API.
    virtual ::grpc::Status RegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRegisterInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRegisterInstanceRaw(context, request, cq));
    }
    // Updates the guest accelerators of a single Instance.
    virtual ::grpc::Status SetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSetInstanceAcceleratorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSetInstanceAcceleratorRaw(context, request, cq));
    }
    // Updates the machine type of a single Instance.
    virtual ::grpc::Status SetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSetInstanceMachineTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSetInstanceMachineTypeRaw(context, request, cq));
    }
    // Update Notebook Instance configurations.
    virtual ::grpc::Status UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    // Updates the Shielded instance configuration of a single Instance.
    virtual ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateShieldedInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateShieldedInstanceConfigRaw(context, request, cq));
    }
    // Replaces all the labels of an Instance.
    virtual ::grpc::Status SetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSetInstanceLabelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSetInstanceLabelsRaw(context, request, cq));
    }
    // Add/update metadata items for an instance.
    virtual ::grpc::Status UpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>> AsyncUpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>>(AsyncUpdateInstanceMetadataItemsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>> PrepareAsyncUpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>>(PrepareAsyncUpdateInstanceMetadataItemsRaw(context, request, cq));
    }
    // Deletes a single Instance.
    virtual ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    // Starts a notebook instance.
    virtual ::grpc::Status StartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStartInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStartInstanceRaw(context, request, cq));
    }
    // Stops a notebook instance.
    virtual ::grpc::Status StopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStopInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStopInstanceRaw(context, request, cq));
    }
    // Resets a notebook instance.
    virtual ::grpc::Status ResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncResetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncResetInstanceRaw(context, request, cq));
    }
    // Allows notebook instances to
    // report their latest instance information to the Notebooks
    // API server. The server will merge the reported information to
    // the instance metadata store. Do not use this method directly.
    virtual ::grpc::Status ReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncReportInstanceInfoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncReportInstanceInfoRaw(context, request, cq));
    }
    // Check if a notebook instance is upgradable.
    virtual ::grpc::Status IsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>> AsyncIsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>>(AsyncIsInstanceUpgradeableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>> PrepareAsyncIsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>>(PrepareAsyncIsInstanceUpgradeableRaw(context, request, cq));
    }
    // Check if a notebook instance is healthy.
    virtual ::grpc::Status GetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>> AsyncGetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>>(AsyncGetInstanceHealthRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>> PrepareAsyncGetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>>(PrepareAsyncGetInstanceHealthRaw(context, request, cq));
    }
    // Upgrades a notebook instance to the latest version.
    virtual ::grpc::Status UpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpgradeInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpgradeInstanceRaw(context, request, cq));
    }
    // Rollbacks a notebook instance to the previous version.
    virtual ::grpc::Status RollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRollbackInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRollbackInstanceRaw(context, request, cq));
    }
    // Creates a Diagnostic File and runs Diagnostic Tool given an Instance.
    virtual ::grpc::Status DiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDiagnoseInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDiagnoseInstanceRaw(context, request, cq));
    }
    // Allows notebook instances to
    // call this endpoint to upgrade themselves. Do not use this method directly.
    virtual ::grpc::Status UpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpgradeInstanceInternalRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpgradeInstanceInternalRaw(context, request, cq));
    }
    // Lists environments in a project.
    virtual ::grpc::Status ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>> AsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>>(AsyncListEnvironmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>> PrepareAsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>>(PrepareAsyncListEnvironmentsRaw(context, request, cq));
    }
    // Gets details of a single Environment.
    virtual ::grpc::Status GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::google::cloud::notebooks::v1::Environment* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Environment>> AsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Environment>>(AsyncGetEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Environment>> PrepareAsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Environment>>(PrepareAsyncGetEnvironmentRaw(context, request, cq));
    }
    // Creates a new Environment.
    virtual ::grpc::Status CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateEnvironmentRaw(context, request, cq));
    }
    // Deletes a single Environment.
    virtual ::grpc::Status DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteEnvironmentRaw(context, request, cq));
    }
    // Lists schedules in a given project and location.
    virtual ::grpc::Status ListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListSchedulesResponse>> AsyncListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListSchedulesResponse>>(AsyncListSchedulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListSchedulesResponse>> PrepareAsyncListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListSchedulesResponse>>(PrepareAsyncListSchedulesRaw(context, request, cq));
    }
    // Gets details of schedule
    virtual ::grpc::Status GetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::google::cloud::notebooks::v1::Schedule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Schedule>> AsyncGetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Schedule>>(AsyncGetScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Schedule>> PrepareAsyncGetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Schedule>>(PrepareAsyncGetScheduleRaw(context, request, cq));
    }
    // Deletes schedule and all underlying jobs
    virtual ::grpc::Status DeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteScheduleRaw(context, request, cq));
    }
    // Creates a new Scheduled Notebook in a given project and location.
    virtual ::grpc::Status CreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateScheduleRaw(context, request, cq));
    }
    // Triggers execution of an existing schedule.
    virtual ::grpc::Status TriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncTriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncTriggerScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncTriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncTriggerScheduleRaw(context, request, cq));
    }
    // Lists executions in a given project and location
    virtual ::grpc::Status ListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListExecutionsResponse>> AsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListExecutionsResponse>>(AsyncListExecutionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListExecutionsResponse>> PrepareAsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListExecutionsResponse>>(PrepareAsyncListExecutionsRaw(context, request, cq));
    }
    // Gets details of executions
    virtual ::grpc::Status GetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::google::cloud::notebooks::v1::Execution* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Execution>> AsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Execution>>(AsyncGetExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Execution>> PrepareAsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Execution>>(PrepareAsyncGetExecutionRaw(context, request, cq));
    }
    // Deletes execution
    virtual ::grpc::Status DeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteExecutionRaw(context, request, cq));
    }
    // Creates a new Execution in a given project and location.
    virtual ::grpc::Status CreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateExecutionRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists instances in a given project and location.
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest* request, ::google::cloud::notebooks::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest* request, ::google::cloud::notebooks::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Instance.
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest* request, ::google::cloud::notebooks::v1::Instance* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest* request, ::google::cloud::notebooks::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Instance in a given project and location.
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Registers an existing legacy notebook instance to the Notebooks API server.
      // Legacy instances are instances created with the legacy Compute Engine
      // calls. They are not manageable by the Notebooks API out of the box. This
      // call makes these instances manageable by the Notebooks API.
      virtual void RegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the guest accelerators of a single Instance.
      virtual void SetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the machine type of a single Instance.
      virtual void SetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update Notebook Instance configurations.
      virtual void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the Shielded instance configuration of a single Instance.
      virtual void UpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Replaces all the labels of an Instance.
      virtual void SetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Add/update metadata items for an instance.
      virtual void UpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Instance.
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts a notebook instance.
      virtual void StartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Stops a notebook instance.
      virtual void StopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets a notebook instance.
      virtual void ResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Allows notebook instances to
      // report their latest instance information to the Notebooks
      // API server. The server will merge the reported information to
      // the instance metadata store. Do not use this method directly.
      virtual void ReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Check if a notebook instance is upgradable.
      virtual void IsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void IsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Check if a notebook instance is healthy.
      virtual void GetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Upgrades a notebook instance to the latest version.
      virtual void UpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Rollbacks a notebook instance to the previous version.
      virtual void RollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Diagnostic File and runs Diagnostic Tool given an Instance.
      virtual void DiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Allows notebook instances to
      // call this endpoint to upgrade themselves. Do not use this method directly.
      virtual void UpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists environments in a project.
      virtual void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Environment.
      virtual void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* request, ::google::cloud::notebooks::v1::Environment* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* request, ::google::cloud::notebooks::v1::Environment* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Environment.
      virtual void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Environment.
      virtual void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists schedules in a given project and location.
      virtual void ListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest* request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest* request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of schedule
      virtual void GetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest* request, ::google::cloud::notebooks::v1::Schedule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest* request, ::google::cloud::notebooks::v1::Schedule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes schedule and all underlying jobs
      virtual void DeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Scheduled Notebook in a given project and location.
      virtual void CreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Triggers execution of an existing schedule.
      virtual void TriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists executions in a given project and location
      virtual void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest* request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest* request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of executions
      virtual void GetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest* request, ::google::cloud::notebooks::v1::Execution* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest* request, ::google::cloud::notebooks::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes execution
      virtual void DeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Execution in a given project and location.
      virtual void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRegisterInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRegisterInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSetInstanceAcceleratorRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSetInstanceAcceleratorRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSetInstanceMachineTypeRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSetInstanceMachineTypeRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateShieldedInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateShieldedInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSetInstanceLabelsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSetInstanceLabelsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* AsyncUpdateInstanceMetadataItemsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* PrepareAsyncUpdateInstanceMetadataItemsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStartInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStartInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStopInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStopInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncResetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncResetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncReportInstanceInfoRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncReportInstanceInfoRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* AsyncIsInstanceUpgradeableRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* PrepareAsyncIsInstanceUpgradeableRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>* AsyncGetInstanceHealthRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>* PrepareAsyncGetInstanceHealthRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpgradeInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpgradeInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRollbackInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRollbackInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDiagnoseInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDiagnoseInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpgradeInstanceInternalRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpgradeInstanceInternalRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>* AsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>* PrepareAsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Environment>* AsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Environment>* PrepareAsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListSchedulesResponse>* AsyncListSchedulesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListSchedulesResponse>* PrepareAsyncListSchedulesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Schedule>* AsyncGetScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Schedule>* PrepareAsyncGetScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncTriggerScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncTriggerScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListExecutionsResponse>* AsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::ListExecutionsResponse>* PrepareAsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Execution>* AsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::notebooks::v1::Execution>* PrepareAsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::google::cloud::notebooks::v1::ListInstancesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::google::cloud::notebooks::v1::Instance* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    ::grpc::Status CreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInstanceRaw(context, request, cq));
    }
    ::grpc::Status RegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRegisterInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRegisterInstanceRaw(context, request, cq));
    }
    ::grpc::Status SetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSetInstanceAcceleratorRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSetInstanceAcceleratorRaw(context, request, cq));
    }
    ::grpc::Status SetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSetInstanceMachineTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSetInstanceMachineTypeRaw(context, request, cq));
    }
    ::grpc::Status UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateInstanceConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateShieldedInstanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateShieldedInstanceConfigRaw(context, request, cq));
    }
    ::grpc::Status SetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSetInstanceLabelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSetInstanceLabelsRaw(context, request, cq));
    }
    ::grpc::Status UpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>> AsyncUpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>>(AsyncUpdateInstanceMetadataItemsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>> PrepareAsyncUpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>>(PrepareAsyncUpdateInstanceMetadataItemsRaw(context, request, cq));
    }
    ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    ::grpc::Status StartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStartInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStartInstanceRaw(context, request, cq));
    }
    ::grpc::Status StopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStopInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStopInstanceRaw(context, request, cq));
    }
    ::grpc::Status ResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncResetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncResetInstanceRaw(context, request, cq));
    }
    ::grpc::Status ReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncReportInstanceInfoRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncReportInstanceInfoRaw(context, request, cq));
    }
    ::grpc::Status IsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>> AsyncIsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>>(AsyncIsInstanceUpgradeableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>> PrepareAsyncIsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>>(PrepareAsyncIsInstanceUpgradeableRaw(context, request, cq));
    }
    ::grpc::Status GetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>> AsyncGetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>>(AsyncGetInstanceHealthRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>> PrepareAsyncGetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>>(PrepareAsyncGetInstanceHealthRaw(context, request, cq));
    }
    ::grpc::Status UpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpgradeInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpgradeInstanceRaw(context, request, cq));
    }
    ::grpc::Status RollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRollbackInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRollbackInstanceRaw(context, request, cq));
    }
    ::grpc::Status DiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDiagnoseInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDiagnoseInstanceRaw(context, request, cq));
    }
    ::grpc::Status UpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpgradeInstanceInternalRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpgradeInstanceInternalRaw(context, request, cq));
    }
    ::grpc::Status ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>> AsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>>(AsyncListEnvironmentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>> PrepareAsyncListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>>(PrepareAsyncListEnvironmentsRaw(context, request, cq));
    }
    ::grpc::Status GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::google::cloud::notebooks::v1::Environment* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Environment>> AsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Environment>>(AsyncGetEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Environment>> PrepareAsyncGetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Environment>>(PrepareAsyncGetEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteEnvironmentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteEnvironmentRaw(context, request, cq));
    }
    ::grpc::Status ListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListSchedulesResponse>> AsyncListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListSchedulesResponse>>(AsyncListSchedulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListSchedulesResponse>> PrepareAsyncListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListSchedulesResponse>>(PrepareAsyncListSchedulesRaw(context, request, cq));
    }
    ::grpc::Status GetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::google::cloud::notebooks::v1::Schedule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Schedule>> AsyncGetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Schedule>>(AsyncGetScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Schedule>> PrepareAsyncGetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Schedule>>(PrepareAsyncGetScheduleRaw(context, request, cq));
    }
    ::grpc::Status DeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteScheduleRaw(context, request, cq));
    }
    ::grpc::Status CreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateScheduleRaw(context, request, cq));
    }
    ::grpc::Status TriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncTriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncTriggerScheduleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncTriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncTriggerScheduleRaw(context, request, cq));
    }
    ::grpc::Status ListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListExecutionsResponse>> AsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListExecutionsResponse>>(AsyncListExecutionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListExecutionsResponse>> PrepareAsyncListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListExecutionsResponse>>(PrepareAsyncListExecutionsRaw(context, request, cq));
    }
    ::grpc::Status GetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::google::cloud::notebooks::v1::Execution* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Execution>> AsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Execution>>(AsyncGetExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Execution>> PrepareAsyncGetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Execution>>(PrepareAsyncGetExecutionRaw(context, request, cq));
    }
    ::grpc::Status DeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteExecutionRaw(context, request, cq));
    }
    ::grpc::Status CreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateExecutionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateExecutionRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest* request, ::google::cloud::notebooks::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstances(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest* request, ::google::cloud::notebooks::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest* request, ::google::cloud::notebooks::v1::Instance* response, std::function<void(::grpc::Status)>) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest* request, ::google::cloud::notebooks::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RegisterInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SetInstanceAccelerator(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SetInstanceMachineType(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateShieldedInstanceConfig(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SetInstanceLabels(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response, std::function<void(::grpc::Status)>) override;
      void UpdateInstanceMetadataItems(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StartInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StopInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResetInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ReportInstanceInfo(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void IsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response, std::function<void(::grpc::Status)>) override;
      void IsInstanceUpgradeable(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response, std::function<void(::grpc::Status)>) override;
      void GetInstanceHealth(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpgradeInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RollbackInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DiagnoseInstance(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpgradeInstanceInternal(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEnvironments(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* request, ::google::cloud::notebooks::v1::Environment* response, std::function<void(::grpc::Status)>) override;
      void GetEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* request, ::google::cloud::notebooks::v1::Environment* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteEnvironment(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest* request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSchedules(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest* request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest* request, ::google::cloud::notebooks::v1::Schedule* response, std::function<void(::grpc::Status)>) override;
      void GetSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest* request, ::google::cloud::notebooks::v1::Schedule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TriggerSchedule(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest* request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListExecutions(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest* request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest* request, ::google::cloud::notebooks::v1::Execution* response, std::function<void(::grpc::Status)>) override;
      void GetExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest* request, ::google::cloud::notebooks::v1::Execution* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateExecution(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRegisterInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRegisterInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSetInstanceAcceleratorRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSetInstanceAcceleratorRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSetInstanceMachineTypeRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSetInstanceMachineTypeRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateShieldedInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateShieldedInstanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSetInstanceLabelsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSetInstanceLabelsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* AsyncUpdateInstanceMetadataItemsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* PrepareAsyncUpdateInstanceMetadataItemsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStartInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStartInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStopInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStopInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncResetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncResetInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncReportInstanceInfoRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncReportInstanceInfoRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* AsyncIsInstanceUpgradeableRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* PrepareAsyncIsInstanceUpgradeableRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>* AsyncGetInstanceHealthRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>* PrepareAsyncGetInstanceHealthRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpgradeInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpgradeInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRollbackInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRollbackInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDiagnoseInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDiagnoseInstanceRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpgradeInstanceInternalRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpgradeInstanceInternalRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>* AsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>* PrepareAsyncListEnvironmentsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Environment>* AsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Environment>* PrepareAsyncGetEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteEnvironmentRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListSchedulesResponse>* AsyncListSchedulesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListSchedulesResponse>* PrepareAsyncListSchedulesRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Schedule>* AsyncGetScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Schedule>* PrepareAsyncGetScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncTriggerScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncTriggerScheduleRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListExecutionsResponse>* AsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::ListExecutionsResponse>* PrepareAsyncListExecutionsRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Execution>* AsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::notebooks::v1::Execution>* PrepareAsyncGetExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateExecutionRaw(::grpc::ClientContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstances_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_RegisterInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_SetInstanceAccelerator_;
    const ::grpc::internal::RpcMethod rpcmethod_SetInstanceMachineType_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInstanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateShieldedInstanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_SetInstanceLabels_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInstanceMetadataItems_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_StartInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_StopInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_ReportInstanceInfo_;
    const ::grpc::internal::RpcMethod rpcmethod_IsInstanceUpgradeable_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstanceHealth_;
    const ::grpc::internal::RpcMethod rpcmethod_UpgradeInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_RollbackInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_DiagnoseInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_UpgradeInstanceInternal_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEnvironments_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEnvironment_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSchedules_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSchedule_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSchedule_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSchedule_;
    const ::grpc::internal::RpcMethod rpcmethod_TriggerSchedule_;
    const ::grpc::internal::RpcMethod rpcmethod_ListExecutions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetExecution_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteExecution_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateExecution_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists instances in a given project and location.
    virtual ::grpc::Status ListInstances(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest* request, ::google::cloud::notebooks::v1::ListInstancesResponse* response);
    // Gets details of a single Instance.
    virtual ::grpc::Status GetInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest* request, ::google::cloud::notebooks::v1::Instance* response);
    // Creates a new Instance in a given project and location.
    virtual ::grpc::Status CreateInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response);
    // Registers an existing legacy notebook instance to the Notebooks API server.
    // Legacy instances are instances created with the legacy Compute Engine
    // calls. They are not manageable by the Notebooks API out of the box. This
    // call makes these instances manageable by the Notebooks API.
    virtual ::grpc::Status RegisterInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* request, ::google::longrunning::Operation* response);
    // Updates the guest accelerators of a single Instance.
    virtual ::grpc::Status SetInstanceAccelerator(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* request, ::google::longrunning::Operation* response);
    // Updates the machine type of a single Instance.
    virtual ::grpc::Status SetInstanceMachineType(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* request, ::google::longrunning::Operation* response);
    // Update Notebook Instance configurations.
    virtual ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response);
    // Updates the Shielded instance configuration of a single Instance.
    virtual ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* request, ::google::longrunning::Operation* response);
    // Replaces all the labels of an Instance.
    virtual ::grpc::Status SetInstanceLabels(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* request, ::google::longrunning::Operation* response);
    // Add/update metadata items for an instance.
    virtual ::grpc::Status UpdateInstanceMetadataItems(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response);
    // Deletes a single Instance.
    virtual ::grpc::Status DeleteInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response);
    // Starts a notebook instance.
    virtual ::grpc::Status StartInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest* request, ::google::longrunning::Operation* response);
    // Stops a notebook instance.
    virtual ::grpc::Status StopInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest* request, ::google::longrunning::Operation* response);
    // Resets a notebook instance.
    virtual ::grpc::Status ResetInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest* request, ::google::longrunning::Operation* response);
    // Allows notebook instances to
    // report their latest instance information to the Notebooks
    // API server. The server will merge the reported information to
    // the instance metadata store. Do not use this method directly.
    virtual ::grpc::Status ReportInstanceInfo(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* request, ::google::longrunning::Operation* response);
    // Check if a notebook instance is upgradable.
    virtual ::grpc::Status IsInstanceUpgradeable(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response);
    // Check if a notebook instance is healthy.
    virtual ::grpc::Status GetInstanceHealth(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response);
    // Upgrades a notebook instance to the latest version.
    virtual ::grpc::Status UpgradeInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* request, ::google::longrunning::Operation* response);
    // Rollbacks a notebook instance to the previous version.
    virtual ::grpc::Status RollbackInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* request, ::google::longrunning::Operation* response);
    // Creates a Diagnostic File and runs Diagnostic Tool given an Instance.
    virtual ::grpc::Status DiagnoseInstance(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* request, ::google::longrunning::Operation* response);
    // Allows notebook instances to
    // call this endpoint to upgrade themselves. Do not use this method directly.
    virtual ::grpc::Status UpgradeInstanceInternal(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* request, ::google::longrunning::Operation* response);
    // Lists environments in a project.
    virtual ::grpc::Status ListEnvironments(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response);
    // Gets details of a single Environment.
    virtual ::grpc::Status GetEnvironment(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* request, ::google::cloud::notebooks::v1::Environment* response);
    // Creates a new Environment.
    virtual ::grpc::Status CreateEnvironment(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Environment.
    virtual ::grpc::Status DeleteEnvironment(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response);
    // Lists schedules in a given project and location.
    virtual ::grpc::Status ListSchedules(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest* request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response);
    // Gets details of schedule
    virtual ::grpc::Status GetSchedule(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest* request, ::google::cloud::notebooks::v1::Schedule* response);
    // Deletes schedule and all underlying jobs
    virtual ::grpc::Status DeleteSchedule(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* request, ::google::longrunning::Operation* response);
    // Creates a new Scheduled Notebook in a given project and location.
    virtual ::grpc::Status CreateSchedule(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest* request, ::google::longrunning::Operation* response);
    // Triggers execution of an existing schedule.
    virtual ::grpc::Status TriggerSchedule(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* request, ::google::longrunning::Operation* response);
    // Lists executions in a given project and location
    virtual ::grpc::Status ListExecutions(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest* request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response);
    // Gets details of executions
    virtual ::grpc::Status GetExecution(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest* request, ::google::cloud::notebooks::v1::Execution* response);
    // Deletes execution
    virtual ::grpc::Status DeleteExecution(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* request, ::google::longrunning::Operation* response);
    // Creates a new Execution in a given project and location.
    virtual ::grpc::Status CreateExecution(::grpc::ServerContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstances() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListInstancesRequest* /*request*/, ::google::cloud::notebooks::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::ListInstancesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::ListInstancesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstance() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceRequest* /*request*/, ::google::cloud::notebooks::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::GetInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::Instance>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInstance() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::CreateInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RegisterInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RegisterInstance() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_RegisterInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRegisterInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::RegisterInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetInstanceAccelerator : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetInstanceAccelerator() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_SetInstanceAccelerator() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceAccelerator(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetInstanceAccelerator(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetInstanceMachineType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetInstanceMachineType() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_SetInstanceMachineType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceMachineType(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetInstanceMachineType(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstanceConfig(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateShieldedInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateShieldedInstanceConfig() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UpdateShieldedInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateShieldedInstanceConfig(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetInstanceLabels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetInstanceLabels() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_SetInstanceLabels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceLabels(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetInstanceLabels(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInstanceMetadataItems : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInstanceMetadataItems() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateInstanceMetadataItems() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceMetadataItems(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* /*request*/, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstanceMetadataItems(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::DeleteInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StartInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StartInstance() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_StartInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StartInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::StartInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StopInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StopInstance() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_StopInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StopInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::StopInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetInstance() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ResetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ResetInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::ResetInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReportInstanceInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReportInstanceInfo() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ReportInstanceInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportInstanceInfo(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReportInstanceInfo(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_IsInstanceUpgradeable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_IsInstanceUpgradeable() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_IsInstanceUpgradeable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IsInstanceUpgradeable(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* /*request*/, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestIsInstanceUpgradeable(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstanceHealth : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstanceHealth() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_GetInstanceHealth() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceHealth(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* /*request*/, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstanceHealth(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::GetInstanceHealthRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::GetInstanceHealthResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpgradeInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpgradeInstance() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_UpgradeInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpgradeInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::UpgradeInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RollbackInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RollbackInstance() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_RollbackInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRollbackInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::RollbackInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DiagnoseInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DiagnoseInstance() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_DiagnoseInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseInstance(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpgradeInstanceInternal : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpgradeInstanceInternal() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_UpgradeInstanceInternal() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstanceInternal(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpgradeInstanceInternal(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEnvironments(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::ListEnvironmentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::ListEnvironmentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::notebooks::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEnvironment(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::GetEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::Environment>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEnvironment(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::CreateEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEnvironment(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSchedules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSchedules() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_ListSchedules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSchedules(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListSchedulesRequest* /*request*/, ::google::cloud::notebooks::v1::ListSchedulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSchedules(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::ListSchedulesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::ListSchedulesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSchedule() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_GetSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetScheduleRequest* /*request*/, ::google::cloud::notebooks::v1::Schedule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSchedule(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::GetScheduleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::Schedule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSchedule() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_DeleteSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSchedule(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::DeleteScheduleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSchedule() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_CreateSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSchedule(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::CreateScheduleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TriggerSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TriggerSchedule() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_TriggerSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TriggerSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTriggerSchedule(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::TriggerScheduleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListExecutions() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListExecutionsRequest* /*request*/, ::google::cloud::notebooks::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExecutions(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::ListExecutionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::ListExecutionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetExecution() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetExecutionRequest* /*request*/, ::google::cloud::notebooks::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExecution(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::GetExecutionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::notebooks::v1::Execution>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteExecution() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_DeleteExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteExecution(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::DeleteExecutionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateExecution() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExecution(::grpc::ServerContext* context, ::google::cloud::notebooks::v1::CreateExecutionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListInstances<WithAsyncMethod_GetInstance<WithAsyncMethod_CreateInstance<WithAsyncMethod_RegisterInstance<WithAsyncMethod_SetInstanceAccelerator<WithAsyncMethod_SetInstanceMachineType<WithAsyncMethod_UpdateInstanceConfig<WithAsyncMethod_UpdateShieldedInstanceConfig<WithAsyncMethod_SetInstanceLabels<WithAsyncMethod_UpdateInstanceMetadataItems<WithAsyncMethod_DeleteInstance<WithAsyncMethod_StartInstance<WithAsyncMethod_StopInstance<WithAsyncMethod_ResetInstance<WithAsyncMethod_ReportInstanceInfo<WithAsyncMethod_IsInstanceUpgradeable<WithAsyncMethod_GetInstanceHealth<WithAsyncMethod_UpgradeInstance<WithAsyncMethod_RollbackInstance<WithAsyncMethod_DiagnoseInstance<WithAsyncMethod_UpgradeInstanceInternal<WithAsyncMethod_ListEnvironments<WithAsyncMethod_GetEnvironment<WithAsyncMethod_CreateEnvironment<WithAsyncMethod_DeleteEnvironment<WithAsyncMethod_ListSchedules<WithAsyncMethod_GetSchedule<WithAsyncMethod_DeleteSchedule<WithAsyncMethod_CreateSchedule<WithAsyncMethod_TriggerSchedule<WithAsyncMethod_ListExecutions<WithAsyncMethod_GetExecution<WithAsyncMethod_DeleteExecution<WithAsyncMethod_CreateExecution<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListInstancesRequest, ::google::cloud::notebooks::v1::ListInstancesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::ListInstancesRequest* request, ::google::cloud::notebooks::v1::ListInstancesResponse* response) { return this->ListInstances(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstances(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::ListInstancesRequest, ::google::cloud::notebooks::v1::ListInstancesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListInstancesRequest, ::google::cloud::notebooks::v1::ListInstancesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListInstancesRequest* /*request*/, ::google::cloud::notebooks::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListInstancesRequest* /*request*/, ::google::cloud::notebooks::v1::ListInstancesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetInstanceRequest, ::google::cloud::notebooks::v1::Instance>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::GetInstanceRequest* request, ::google::cloud::notebooks::v1::Instance* response) { return this->GetInstance(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::GetInstanceRequest, ::google::cloud::notebooks::v1::Instance>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetInstanceRequest, ::google::cloud::notebooks::v1::Instance>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceRequest* /*request*/, ::google::cloud::notebooks::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceRequest* /*request*/, ::google::cloud::notebooks::v1::Instance* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::CreateInstanceRequest* request, ::google::longrunning::Operation* response) { return this->CreateInstance(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::CreateInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RegisterInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RegisterInstance() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::RegisterInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* request, ::google::longrunning::Operation* response) { return this->RegisterInstance(context, request, response); }));}
    void SetMessageAllocatorFor_RegisterInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::RegisterInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::RegisterInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RegisterInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RegisterInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetInstanceAccelerator : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetInstanceAccelerator() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* request, ::google::longrunning::Operation* response) { return this->SetInstanceAccelerator(context, request, response); }));}
    void SetMessageAllocatorFor_SetInstanceAccelerator(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetInstanceAccelerator() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceAccelerator(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetInstanceAccelerator(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetInstanceMachineType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetInstanceMachineType() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* request, ::google::longrunning::Operation* response) { return this->SetInstanceMachineType(context, request, response); }));}
    void SetMessageAllocatorFor_SetInstanceMachineType(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetInstanceMachineType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceMachineType(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetInstanceMachineType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* request, ::google::longrunning::Operation* response) { return this->UpdateInstanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInstanceConfig(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateShieldedInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateShieldedInstanceConfig() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* request, ::google::longrunning::Operation* response) { return this->UpdateShieldedInstanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateShieldedInstanceConfig(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateShieldedInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateShieldedInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetInstanceLabels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetInstanceLabels() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::SetInstanceLabelsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* request, ::google::longrunning::Operation* response) { return this->SetInstanceLabels(context, request, response); }));}
    void SetMessageAllocatorFor_SetInstanceLabels(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::SetInstanceLabelsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::SetInstanceLabelsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetInstanceLabels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceLabels(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetInstanceLabels(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInstanceMetadataItems : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInstanceMetadataItems() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* request, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* response) { return this->UpdateInstanceMetadataItems(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInstanceMetadataItems(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInstanceMetadataItems() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceMetadataItems(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* /*request*/, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstanceMetadataItems(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* /*request*/, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response) { return this->DeleteInstance(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StartInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StartInstance() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::StartInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::StartInstanceRequest* request, ::google::longrunning::Operation* response) { return this->StartInstance(context, request, response); }));}
    void SetMessageAllocatorFor_StartInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::StartInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::StartInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StartInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StartInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::StartInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StopInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StopInstance() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::StopInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::StopInstanceRequest* request, ::google::longrunning::Operation* response) { return this->StopInstance(context, request, response); }));}
    void SetMessageAllocatorFor_StopInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::StopInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::StopInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StopInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StopInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::StopInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetInstance() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ResetInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::ResetInstanceRequest* request, ::google::longrunning::Operation* response) { return this->ResetInstance(context, request, response); }));}
    void SetMessageAllocatorFor_ResetInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::ResetInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ResetInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ResetInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::ResetInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReportInstanceInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReportInstanceInfo() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ReportInstanceInfoRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* request, ::google::longrunning::Operation* response) { return this->ReportInstanceInfo(context, request, response); }));}
    void SetMessageAllocatorFor_ReportInstanceInfo(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::ReportInstanceInfoRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ReportInstanceInfoRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReportInstanceInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportInstanceInfo(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReportInstanceInfo(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_IsInstanceUpgradeable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_IsInstanceUpgradeable() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* request, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* response) { return this->IsInstanceUpgradeable(context, request, response); }));}
    void SetMessageAllocatorFor_IsInstanceUpgradeable(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_IsInstanceUpgradeable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IsInstanceUpgradeable(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* /*request*/, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* IsInstanceUpgradeable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* /*request*/, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstanceHealth : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstanceHealth() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetInstanceHealthRequest, ::google::cloud::notebooks::v1::GetInstanceHealthResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* request, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* response) { return this->GetInstanceHealth(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstanceHealth(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::GetInstanceHealthRequest, ::google::cloud::notebooks::v1::GetInstanceHealthResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetInstanceHealthRequest, ::google::cloud::notebooks::v1::GetInstanceHealthResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstanceHealth() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceHealth(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* /*request*/, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstanceHealth(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* /*request*/, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpgradeInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpgradeInstance() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpgradeInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* request, ::google::longrunning::Operation* response) { return this->UpgradeInstance(context, request, response); }));}
    void SetMessageAllocatorFor_UpgradeInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::UpgradeInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpgradeInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpgradeInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpgradeInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RollbackInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RollbackInstance() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::RollbackInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* request, ::google::longrunning::Operation* response) { return this->RollbackInstance(context, request, response); }));}
    void SetMessageAllocatorFor_RollbackInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::RollbackInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::RollbackInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RollbackInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RollbackInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DiagnoseInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DiagnoseInstance() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DiagnoseInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* request, ::google::longrunning::Operation* response) { return this->DiagnoseInstance(context, request, response); }));}
    void SetMessageAllocatorFor_DiagnoseInstance(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::DiagnoseInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DiagnoseInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DiagnoseInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpgradeInstanceInternal : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpgradeInstanceInternal() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* request, ::google::longrunning::Operation* response) { return this->UpgradeInstanceInternal(context, request, response); }));}
    void SetMessageAllocatorFor_UpgradeInstanceInternal(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpgradeInstanceInternal() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstanceInternal(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpgradeInstanceInternal(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListEnvironmentsRequest, ::google::cloud::notebooks::v1::ListEnvironmentsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* request, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* response) { return this->ListEnvironments(context, request, response); }));}
    void SetMessageAllocatorFor_ListEnvironments(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::ListEnvironmentsRequest, ::google::cloud::notebooks::v1::ListEnvironmentsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListEnvironmentsRequest, ::google::cloud::notebooks::v1::ListEnvironmentsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEnvironments(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetEnvironmentRequest, ::google::cloud::notebooks::v1::Environment>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* request, ::google::cloud::notebooks::v1::Environment* response) { return this->GetEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_GetEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::GetEnvironmentRequest, ::google::cloud::notebooks::v1::Environment>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetEnvironmentRequest, ::google::cloud::notebooks::v1::Environment>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::notebooks::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::notebooks::v1::Environment* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* request, ::google::longrunning::Operation* response) { return this->CreateEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* request, ::google::longrunning::Operation* response) { return this->DeleteEnvironment(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEnvironment(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSchedules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSchedules() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListSchedulesRequest, ::google::cloud::notebooks::v1::ListSchedulesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::ListSchedulesRequest* request, ::google::cloud::notebooks::v1::ListSchedulesResponse* response) { return this->ListSchedules(context, request, response); }));}
    void SetMessageAllocatorFor_ListSchedules(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::ListSchedulesRequest, ::google::cloud::notebooks::v1::ListSchedulesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListSchedulesRequest, ::google::cloud::notebooks::v1::ListSchedulesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSchedules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSchedules(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListSchedulesRequest* /*request*/, ::google::cloud::notebooks::v1::ListSchedulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSchedules(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListSchedulesRequest* /*request*/, ::google::cloud::notebooks::v1::ListSchedulesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSchedule() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetScheduleRequest, ::google::cloud::notebooks::v1::Schedule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::GetScheduleRequest* request, ::google::cloud::notebooks::v1::Schedule* response) { return this->GetSchedule(context, request, response); }));}
    void SetMessageAllocatorFor_GetSchedule(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::GetScheduleRequest, ::google::cloud::notebooks::v1::Schedule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetScheduleRequest, ::google::cloud::notebooks::v1::Schedule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetScheduleRequest* /*request*/, ::google::cloud::notebooks::v1::Schedule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetScheduleRequest* /*request*/, ::google::cloud::notebooks::v1::Schedule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSchedule() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteScheduleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* request, ::google::longrunning::Operation* response) { return this->DeleteSchedule(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSchedule(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::DeleteScheduleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteScheduleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSchedule() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateScheduleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::CreateScheduleRequest* request, ::google::longrunning::Operation* response) { return this->CreateSchedule(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSchedule(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::CreateScheduleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateScheduleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TriggerSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TriggerSchedule() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::TriggerScheduleRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* request, ::google::longrunning::Operation* response) { return this->TriggerSchedule(context, request, response); }));}
    void SetMessageAllocatorFor_TriggerSchedule(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::TriggerScheduleRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::TriggerScheduleRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TriggerSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TriggerSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TriggerSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListExecutions() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListExecutionsRequest, ::google::cloud::notebooks::v1::ListExecutionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::ListExecutionsRequest* request, ::google::cloud::notebooks::v1::ListExecutionsResponse* response) { return this->ListExecutions(context, request, response); }));}
    void SetMessageAllocatorFor_ListExecutions(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::ListExecutionsRequest, ::google::cloud::notebooks::v1::ListExecutionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::ListExecutionsRequest, ::google::cloud::notebooks::v1::ListExecutionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListExecutionsRequest* /*request*/, ::google::cloud::notebooks::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExecutions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListExecutionsRequest* /*request*/, ::google::cloud::notebooks::v1::ListExecutionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetExecution() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetExecutionRequest, ::google::cloud::notebooks::v1::Execution>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::GetExecutionRequest* request, ::google::cloud::notebooks::v1::Execution* response) { return this->GetExecution(context, request, response); }));}
    void SetMessageAllocatorFor_GetExecution(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::GetExecutionRequest, ::google::cloud::notebooks::v1::Execution>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::GetExecutionRequest, ::google::cloud::notebooks::v1::Execution>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetExecutionRequest* /*request*/, ::google::cloud::notebooks::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetExecutionRequest* /*request*/, ::google::cloud::notebooks::v1::Execution* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteExecution() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteExecutionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* request, ::google::longrunning::Operation* response) { return this->DeleteExecution(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteExecution(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::DeleteExecutionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::DeleteExecutionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateExecution() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateExecutionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::notebooks::v1::CreateExecutionRequest* request, ::google::longrunning::Operation* response) { return this->CreateExecution(context, request, response); }));}
    void SetMessageAllocatorFor_CreateExecution(
        ::grpc::MessageAllocator< ::google::cloud::notebooks::v1::CreateExecutionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::notebooks::v1::CreateExecutionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListInstances<WithCallbackMethod_GetInstance<WithCallbackMethod_CreateInstance<WithCallbackMethod_RegisterInstance<WithCallbackMethod_SetInstanceAccelerator<WithCallbackMethod_SetInstanceMachineType<WithCallbackMethod_UpdateInstanceConfig<WithCallbackMethod_UpdateShieldedInstanceConfig<WithCallbackMethod_SetInstanceLabels<WithCallbackMethod_UpdateInstanceMetadataItems<WithCallbackMethod_DeleteInstance<WithCallbackMethod_StartInstance<WithCallbackMethod_StopInstance<WithCallbackMethod_ResetInstance<WithCallbackMethod_ReportInstanceInfo<WithCallbackMethod_IsInstanceUpgradeable<WithCallbackMethod_GetInstanceHealth<WithCallbackMethod_UpgradeInstance<WithCallbackMethod_RollbackInstance<WithCallbackMethod_DiagnoseInstance<WithCallbackMethod_UpgradeInstanceInternal<WithCallbackMethod_ListEnvironments<WithCallbackMethod_GetEnvironment<WithCallbackMethod_CreateEnvironment<WithCallbackMethod_DeleteEnvironment<WithCallbackMethod_ListSchedules<WithCallbackMethod_GetSchedule<WithCallbackMethod_DeleteSchedule<WithCallbackMethod_CreateSchedule<WithCallbackMethod_TriggerSchedule<WithCallbackMethod_ListExecutions<WithCallbackMethod_GetExecution<WithCallbackMethod_DeleteExecution<WithCallbackMethod_CreateExecution<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstances() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListInstancesRequest* /*request*/, ::google::cloud::notebooks::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstance() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceRequest* /*request*/, ::google::cloud::notebooks::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInstance() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RegisterInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RegisterInstance() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_RegisterInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetInstanceAccelerator : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetInstanceAccelerator() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_SetInstanceAccelerator() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceAccelerator(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetInstanceMachineType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetInstanceMachineType() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_SetInstanceMachineType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceMachineType(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateShieldedInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateShieldedInstanceConfig() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UpdateShieldedInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetInstanceLabels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetInstanceLabels() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_SetInstanceLabels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceLabels(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInstanceMetadataItems : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInstanceMetadataItems() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateInstanceMetadataItems() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceMetadataItems(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* /*request*/, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StartInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StartInstance() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_StartInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StartInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StopInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StopInstance() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_StopInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StopInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetInstance() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ResetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ResetInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReportInstanceInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReportInstanceInfo() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ReportInstanceInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportInstanceInfo(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_IsInstanceUpgradeable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_IsInstanceUpgradeable() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_IsInstanceUpgradeable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IsInstanceUpgradeable(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* /*request*/, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstanceHealth : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstanceHealth() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_GetInstanceHealth() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceHealth(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* /*request*/, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpgradeInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpgradeInstance() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_UpgradeInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RollbackInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RollbackInstance() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_RollbackInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DiagnoseInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DiagnoseInstance() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_DiagnoseInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpgradeInstanceInternal : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpgradeInstanceInternal() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_UpgradeInstanceInternal() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstanceInternal(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::notebooks::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSchedules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSchedules() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_ListSchedules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSchedules(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListSchedulesRequest* /*request*/, ::google::cloud::notebooks::v1::ListSchedulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSchedule() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_GetSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetScheduleRequest* /*request*/, ::google::cloud::notebooks::v1::Schedule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSchedule() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_DeleteSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSchedule() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_CreateSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TriggerSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TriggerSchedule() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_TriggerSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TriggerSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListExecutions() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListExecutionsRequest* /*request*/, ::google::cloud::notebooks::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetExecution() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetExecutionRequest* /*request*/, ::google::cloud::notebooks::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteExecution() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_DeleteExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateExecution() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstances() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListInstancesRequest* /*request*/, ::google::cloud::notebooks::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstance() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceRequest* /*request*/, ::google::cloud::notebooks::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RegisterInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RegisterInstance() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_RegisterInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRegisterInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetInstanceAccelerator : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetInstanceAccelerator() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_SetInstanceAccelerator() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceAccelerator(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetInstanceAccelerator(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetInstanceMachineType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetInstanceMachineType() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_SetInstanceMachineType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceMachineType(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetInstanceMachineType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateShieldedInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateShieldedInstanceConfig() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UpdateShieldedInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateShieldedInstanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetInstanceLabels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetInstanceLabels() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_SetInstanceLabels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceLabels(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetInstanceLabels(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInstanceMetadataItems : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInstanceMetadataItems() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateInstanceMetadataItems() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceMetadataItems(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* /*request*/, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInstanceMetadataItems(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StartInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StartInstance() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_StartInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StartInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StopInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StopInstance() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_StopInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StopInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetInstance() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ResetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ResetInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReportInstanceInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReportInstanceInfo() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ReportInstanceInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportInstanceInfo(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReportInstanceInfo(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_IsInstanceUpgradeable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_IsInstanceUpgradeable() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_IsInstanceUpgradeable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IsInstanceUpgradeable(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* /*request*/, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestIsInstanceUpgradeable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstanceHealth : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstanceHealth() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_GetInstanceHealth() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceHealth(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* /*request*/, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstanceHealth(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpgradeInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpgradeInstance() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_UpgradeInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpgradeInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RollbackInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RollbackInstance() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_RollbackInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRollbackInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DiagnoseInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DiagnoseInstance() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_DiagnoseInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDiagnoseInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpgradeInstanceInternal : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpgradeInstanceInternal() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_UpgradeInstanceInternal() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstanceInternal(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpgradeInstanceInternal(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEnvironments(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::notebooks::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEnvironment(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSchedules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSchedules() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_ListSchedules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSchedules(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListSchedulesRequest* /*request*/, ::google::cloud::notebooks::v1::ListSchedulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSchedules(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSchedule() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_GetSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetScheduleRequest* /*request*/, ::google::cloud::notebooks::v1::Schedule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSchedule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSchedule() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_DeleteSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSchedule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSchedule() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_CreateSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSchedule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TriggerSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TriggerSchedule() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_TriggerSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TriggerSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTriggerSchedule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListExecutions() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListExecutionsRequest* /*request*/, ::google::cloud::notebooks::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListExecutions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetExecution() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetExecutionRequest* /*request*/, ::google::cloud::notebooks::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetExecution(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteExecution() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_DeleteExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteExecution(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateExecution() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExecution(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstances(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListInstancesRequest* /*request*/, ::google::cloud::notebooks::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceRequest* /*request*/, ::google::cloud::notebooks::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInstance() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RegisterInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RegisterInstance() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RegisterInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_RegisterInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RegisterInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RegisterInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetInstanceAccelerator : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetInstanceAccelerator() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetInstanceAccelerator(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetInstanceAccelerator() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceAccelerator(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetInstanceAccelerator(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetInstanceMachineType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetInstanceMachineType() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetInstanceMachineType(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetInstanceMachineType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceMachineType(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetInstanceMachineType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInstanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateShieldedInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateShieldedInstanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateShieldedInstanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateShieldedInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateShieldedInstanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetInstanceLabels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetInstanceLabels() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetInstanceLabels(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetInstanceLabels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetInstanceLabels(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetInstanceLabels(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInstanceMetadataItems : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInstanceMetadataItems() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInstanceMetadataItems(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInstanceMetadataItems() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInstanceMetadataItems(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* /*request*/, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInstanceMetadataItems(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StartInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StartInstance() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StartInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_StartInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StartInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StopInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StopInstance() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StopInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_StopInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StopInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetInstance() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ResetInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReportInstanceInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReportInstanceInfo() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReportInstanceInfo(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReportInstanceInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReportInstanceInfo(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReportInstanceInfo(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_IsInstanceUpgradeable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_IsInstanceUpgradeable() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->IsInstanceUpgradeable(context, request, response); }));
    }
    ~WithRawCallbackMethod_IsInstanceUpgradeable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status IsInstanceUpgradeable(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* /*request*/, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* IsInstanceUpgradeable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstanceHealth : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstanceHealth() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstanceHealth(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstanceHealth() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstanceHealth(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* /*request*/, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstanceHealth(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpgradeInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpgradeInstance() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpgradeInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpgradeInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpgradeInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RollbackInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RollbackInstance() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RollbackInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_RollbackInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RollbackInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RollbackInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DiagnoseInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DiagnoseInstance() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DiagnoseInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_DiagnoseInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DiagnoseInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DiagnoseInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpgradeInstanceInternal : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpgradeInstanceInternal() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpgradeInstanceInternal(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpgradeInstanceInternal() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpgradeInstanceInternal(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpgradeInstanceInternal(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEnvironments(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEnvironments(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::notebooks::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEnvironment(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEnvironment(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSchedules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSchedules() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSchedules(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSchedules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSchedules(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListSchedulesRequest* /*request*/, ::google::cloud::notebooks::v1::ListSchedulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSchedules(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSchedule() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSchedule(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetScheduleRequest* /*request*/, ::google::cloud::notebooks::v1::Schedule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSchedule() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSchedule(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSchedule() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSchedule(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TriggerSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TriggerSchedule() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TriggerSchedule(context, request, response); }));
    }
    ~WithRawCallbackMethod_TriggerSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TriggerSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TriggerSchedule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListExecutions() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListExecutions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListExecutionsRequest* /*request*/, ::google::cloud::notebooks::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListExecutions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetExecution() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetExecution(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetExecutionRequest* /*request*/, ::google::cloud::notebooks::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteExecution() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteExecution(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateExecution() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateExecution(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExecution(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstances() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::ListInstancesRequest, ::google::cloud::notebooks::v1::ListInstancesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::ListInstancesRequest, ::google::cloud::notebooks::v1::ListInstancesResponse>* streamer) {
                       return this->StreamedListInstances(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListInstancesRequest* /*request*/, ::google::cloud::notebooks::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstances(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::ListInstancesRequest,::google::cloud::notebooks::v1::ListInstancesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstance() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::GetInstanceRequest, ::google::cloud::notebooks::v1::Instance>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::GetInstanceRequest, ::google::cloud::notebooks::v1::Instance>* streamer) {
                       return this->StreamedGetInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceRequest* /*request*/, ::google::cloud::notebooks::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::GetInstanceRequest,::google::cloud::notebooks::v1::Instance>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInstance() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::CreateInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::CreateInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::CreateInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RegisterInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RegisterInstance() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::RegisterInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::RegisterInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRegisterInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RegisterInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RegisterInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RegisterInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRegisterInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::RegisterInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetInstanceAccelerator : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetInstanceAccelerator() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSetInstanceAccelerator(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetInstanceAccelerator() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetInstanceAccelerator(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetInstanceAccelerator(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::SetInstanceAcceleratorRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetInstanceMachineType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetInstanceMachineType() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSetInstanceMachineType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetInstanceMachineType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetInstanceMachineType(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetInstanceMachineType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::SetInstanceMachineTypeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInstanceConfig() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateInstanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInstanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::UpdateInstanceConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateShieldedInstanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateShieldedInstanceConfig() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateShieldedInstanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateShieldedInstanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateShieldedInstanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateShieldedInstanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::UpdateShieldedInstanceConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetInstanceLabels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetInstanceLabels() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::SetInstanceLabelsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::SetInstanceLabelsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSetInstanceLabels(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetInstanceLabels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetInstanceLabels(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::SetInstanceLabelsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetInstanceLabels(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::SetInstanceLabelsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInstanceMetadataItems : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInstanceMetadataItems() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* streamer) {
                       return this->StreamedUpdateInstanceMetadataItems(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInstanceMetadataItems() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInstanceMetadataItems(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest* /*request*/, ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInstanceMetadataItems(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsRequest,::google::cloud::notebooks::v1::UpdateInstanceMetadataItemsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::DeleteInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StartInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StartInstance() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::StartInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::StartInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStartInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StartInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StartInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StartInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStartInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::StartInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StopInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StopInstance() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::StopInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::StopInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStopInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StopInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StopInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::StopInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStopInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::StopInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetInstance() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::ResetInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::ResetInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedResetInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ResetInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::ResetInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReportInstanceInfo : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReportInstanceInfo() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::ReportInstanceInfoRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::ReportInstanceInfoRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedReportInstanceInfo(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReportInstanceInfo() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReportInstanceInfo(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ReportInstanceInfoRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReportInstanceInfo(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::ReportInstanceInfoRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_IsInstanceUpgradeable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_IsInstanceUpgradeable() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* streamer) {
                       return this->StreamedIsInstanceUpgradeable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_IsInstanceUpgradeable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status IsInstanceUpgradeable(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest* /*request*/, ::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedIsInstanceUpgradeable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::IsInstanceUpgradeableRequest,::google::cloud::notebooks::v1::IsInstanceUpgradeableResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstanceHealth : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstanceHealth() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::GetInstanceHealthRequest, ::google::cloud::notebooks::v1::GetInstanceHealthResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::GetInstanceHealthRequest, ::google::cloud::notebooks::v1::GetInstanceHealthResponse>* streamer) {
                       return this->StreamedGetInstanceHealth(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstanceHealth() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstanceHealth(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetInstanceHealthRequest* /*request*/, ::google::cloud::notebooks::v1::GetInstanceHealthResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstanceHealth(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::GetInstanceHealthRequest,::google::cloud::notebooks::v1::GetInstanceHealthResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpgradeInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpgradeInstance() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::UpgradeInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::UpgradeInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpgradeInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpgradeInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpgradeInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpgradeInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::UpgradeInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RollbackInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RollbackInstance() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::RollbackInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::RollbackInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRollbackInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RollbackInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RollbackInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::RollbackInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRollbackInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::RollbackInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DiagnoseInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DiagnoseInstance() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::DiagnoseInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::DiagnoseInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDiagnoseInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DiagnoseInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DiagnoseInstance(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DiagnoseInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDiagnoseInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::DiagnoseInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpgradeInstanceInternal : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpgradeInstanceInternal() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpgradeInstanceInternal(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpgradeInstanceInternal() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpgradeInstanceInternal(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpgradeInstanceInternal(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::UpgradeInstanceInternalRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEnvironments : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEnvironments() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::ListEnvironmentsRequest, ::google::cloud::notebooks::v1::ListEnvironmentsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::ListEnvironmentsRequest, ::google::cloud::notebooks::v1::ListEnvironmentsResponse>* streamer) {
                       return this->StreamedListEnvironments(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEnvironments() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEnvironments(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListEnvironmentsRequest* /*request*/, ::google::cloud::notebooks::v1::ListEnvironmentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEnvironments(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::ListEnvironmentsRequest,::google::cloud::notebooks::v1::ListEnvironmentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEnvironment() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::GetEnvironmentRequest, ::google::cloud::notebooks::v1::Environment>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::GetEnvironmentRequest, ::google::cloud::notebooks::v1::Environment>* streamer) {
                       return this->StreamedGetEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetEnvironmentRequest* /*request*/, ::google::cloud::notebooks::v1::Environment* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::GetEnvironmentRequest,::google::cloud::notebooks::v1::Environment>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEnvironment() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::CreateEnvironmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::CreateEnvironmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEnvironment : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEnvironment() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::DeleteEnvironmentRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteEnvironment(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEnvironment() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEnvironment(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteEnvironmentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEnvironment(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::DeleteEnvironmentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSchedules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSchedules() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::ListSchedulesRequest, ::google::cloud::notebooks::v1::ListSchedulesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::ListSchedulesRequest, ::google::cloud::notebooks::v1::ListSchedulesResponse>* streamer) {
                       return this->StreamedListSchedules(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSchedules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSchedules(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListSchedulesRequest* /*request*/, ::google::cloud::notebooks::v1::ListSchedulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSchedules(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::ListSchedulesRequest,::google::cloud::notebooks::v1::ListSchedulesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSchedule() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::GetScheduleRequest, ::google::cloud::notebooks::v1::Schedule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::GetScheduleRequest, ::google::cloud::notebooks::v1::Schedule>* streamer) {
                       return this->StreamedGetSchedule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetScheduleRequest* /*request*/, ::google::cloud::notebooks::v1::Schedule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSchedule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::GetScheduleRequest,::google::cloud::notebooks::v1::Schedule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSchedule() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::DeleteScheduleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::DeleteScheduleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteSchedule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSchedule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::DeleteScheduleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSchedule() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::CreateScheduleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::CreateScheduleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateSchedule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSchedule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::CreateScheduleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TriggerSchedule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TriggerSchedule() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::TriggerScheduleRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::TriggerScheduleRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedTriggerSchedule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TriggerSchedule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TriggerSchedule(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::TriggerScheduleRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTriggerSchedule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::TriggerScheduleRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListExecutions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListExecutions() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::ListExecutionsRequest, ::google::cloud::notebooks::v1::ListExecutionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::ListExecutionsRequest, ::google::cloud::notebooks::v1::ListExecutionsResponse>* streamer) {
                       return this->StreamedListExecutions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListExecutions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListExecutions(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::ListExecutionsRequest* /*request*/, ::google::cloud::notebooks::v1::ListExecutionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListExecutions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::ListExecutionsRequest,::google::cloud::notebooks::v1::ListExecutionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetExecution() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::GetExecutionRequest, ::google::cloud::notebooks::v1::Execution>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::GetExecutionRequest, ::google::cloud::notebooks::v1::Execution>* streamer) {
                       return this->StreamedGetExecution(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::GetExecutionRequest* /*request*/, ::google::cloud::notebooks::v1::Execution* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetExecution(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::GetExecutionRequest,::google::cloud::notebooks::v1::Execution>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteExecution() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::DeleteExecutionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::DeleteExecutionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteExecution(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::DeleteExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteExecution(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::DeleteExecutionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateExecution : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateExecution() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::notebooks::v1::CreateExecutionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::notebooks::v1::CreateExecutionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateExecution(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateExecution() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateExecution(::grpc::ServerContext* /*context*/, const ::google::cloud::notebooks::v1::CreateExecutionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateExecution(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::notebooks::v1::CreateExecutionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_RegisterInstance<WithStreamedUnaryMethod_SetInstanceAccelerator<WithStreamedUnaryMethod_SetInstanceMachineType<WithStreamedUnaryMethod_UpdateInstanceConfig<WithStreamedUnaryMethod_UpdateShieldedInstanceConfig<WithStreamedUnaryMethod_SetInstanceLabels<WithStreamedUnaryMethod_UpdateInstanceMetadataItems<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_StartInstance<WithStreamedUnaryMethod_StopInstance<WithStreamedUnaryMethod_ResetInstance<WithStreamedUnaryMethod_ReportInstanceInfo<WithStreamedUnaryMethod_IsInstanceUpgradeable<WithStreamedUnaryMethod_GetInstanceHealth<WithStreamedUnaryMethod_UpgradeInstance<WithStreamedUnaryMethod_RollbackInstance<WithStreamedUnaryMethod_DiagnoseInstance<WithStreamedUnaryMethod_UpgradeInstanceInternal<WithStreamedUnaryMethod_ListEnvironments<WithStreamedUnaryMethod_GetEnvironment<WithStreamedUnaryMethod_CreateEnvironment<WithStreamedUnaryMethod_DeleteEnvironment<WithStreamedUnaryMethod_ListSchedules<WithStreamedUnaryMethod_GetSchedule<WithStreamedUnaryMethod_DeleteSchedule<WithStreamedUnaryMethod_CreateSchedule<WithStreamedUnaryMethod_TriggerSchedule<WithStreamedUnaryMethod_ListExecutions<WithStreamedUnaryMethod_GetExecution<WithStreamedUnaryMethod_DeleteExecution<WithStreamedUnaryMethod_CreateExecution<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_CreateInstance<WithStreamedUnaryMethod_RegisterInstance<WithStreamedUnaryMethod_SetInstanceAccelerator<WithStreamedUnaryMethod_SetInstanceMachineType<WithStreamedUnaryMethod_UpdateInstanceConfig<WithStreamedUnaryMethod_UpdateShieldedInstanceConfig<WithStreamedUnaryMethod_SetInstanceLabels<WithStreamedUnaryMethod_UpdateInstanceMetadataItems<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_StartInstance<WithStreamedUnaryMethod_StopInstance<WithStreamedUnaryMethod_ResetInstance<WithStreamedUnaryMethod_ReportInstanceInfo<WithStreamedUnaryMethod_IsInstanceUpgradeable<WithStreamedUnaryMethod_GetInstanceHealth<WithStreamedUnaryMethod_UpgradeInstance<WithStreamedUnaryMethod_RollbackInstance<WithStreamedUnaryMethod_DiagnoseInstance<WithStreamedUnaryMethod_UpgradeInstanceInternal<WithStreamedUnaryMethod_ListEnvironments<WithStreamedUnaryMethod_GetEnvironment<WithStreamedUnaryMethod_CreateEnvironment<WithStreamedUnaryMethod_DeleteEnvironment<WithStreamedUnaryMethod_ListSchedules<WithStreamedUnaryMethod_GetSchedule<WithStreamedUnaryMethod_DeleteSchedule<WithStreamedUnaryMethod_CreateSchedule<WithStreamedUnaryMethod_TriggerSchedule<WithStreamedUnaryMethod_ListExecutions<WithStreamedUnaryMethod_GetExecution<WithStreamedUnaryMethod_DeleteExecution<WithStreamedUnaryMethod_CreateExecution<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace notebooks
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fnotebooks_2fv1_2fservice_2eproto__INCLUDED
