// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/video/stitcher/v1/video_stitcher_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvideo_2fstitcher_2fv1_2fvideo_5fstitcher_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvideo_2fstitcher_2fv1_2fvideo_5fstitcher_5fservice_2eproto__INCLUDED

#include "google/cloud/video/stitcher/v1/video_stitcher_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace video {
namespace stitcher {
namespace v1 {

// Video-On-Demand content stitching API allows you to insert ads
// into (VoD) video on demand files. You will be able to render custom
// scrubber bars with highlighted ads, enforce ad policies, allow
// seamless playback and tracking on native players and monetize
// content with any standard VMAP compliant ad server.
class VideoStitcherService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.video.stitcher.v1.VideoStitcherService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new CDN key.
    virtual ::grpc::Status CreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateCdnKeyRaw(context, request, cq));
    }
    // Lists all CDN keys in the specified project and location.
    virtual ::grpc::Status ListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>> AsyncListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>>(AsyncListCdnKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>> PrepareAsyncListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>>(PrepareAsyncListCdnKeysRaw(context, request, cq));
    }
    // Returns the specified CDN key.
    virtual ::grpc::Status GetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::google::cloud::video::stitcher::v1::CdnKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::CdnKey>> AsyncGetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::CdnKey>>(AsyncGetCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::CdnKey>> PrepareAsyncGetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::CdnKey>>(PrepareAsyncGetCdnKeyRaw(context, request, cq));
    }
    // Deletes the specified CDN key.
    virtual ::grpc::Status DeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteCdnKeyRaw(context, request, cq));
    }
    // Updates the specified CDN key. Only update fields specified
    // in the call method body.
    virtual ::grpc::Status UpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateCdnKeyRaw(context, request, cq));
    }
    // Creates a client side playback VOD session and returns the full
    // tracking and playback metadata of the session.
    virtual ::grpc::Status CreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::google::cloud::video::stitcher::v1::VodSession* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>> AsyncCreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>>(AsyncCreateVodSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>> PrepareAsyncCreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>>(PrepareAsyncCreateVodSessionRaw(context, request, cq));
    }
    // Returns the full tracking, playback metadata, and relevant ad-ops
    // logs for the specified VOD session.
    virtual ::grpc::Status GetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::google::cloud::video::stitcher::v1::VodSession* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>> AsyncGetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>>(AsyncGetVodSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>> PrepareAsyncGetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>>(PrepareAsyncGetVodSessionRaw(context, request, cq));
    }
    // Returns a list of detailed stitching information of the specified VOD
    // session.
    virtual ::grpc::Status ListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>> AsyncListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>>(AsyncListVodStitchDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>> PrepareAsyncListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>>(PrepareAsyncListVodStitchDetailsRaw(context, request, cq));
    }
    // Returns the specified stitching information for the specified VOD session.
    virtual ::grpc::Status GetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodStitchDetail>> AsyncGetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodStitchDetail>>(AsyncGetVodStitchDetailRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodStitchDetail>> PrepareAsyncGetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodStitchDetail>>(PrepareAsyncGetVodStitchDetailRaw(context, request, cq));
    }
    // Return the list of ad tag details for the specified VOD session.
    virtual ::grpc::Status ListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>> AsyncListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>>(AsyncListVodAdTagDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>> PrepareAsyncListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>>(PrepareAsyncListVodAdTagDetailsRaw(context, request, cq));
    }
    // Returns the specified ad tag detail for the specified VOD session.
    virtual ::grpc::Status GetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodAdTagDetail>> AsyncGetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodAdTagDetail>>(AsyncGetVodAdTagDetailRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodAdTagDetail>> PrepareAsyncGetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodAdTagDetail>>(PrepareAsyncGetVodAdTagDetailRaw(context, request, cq));
    }
    // Return the list of ad tag details for the specified live session.
    virtual ::grpc::Status ListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>> AsyncListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>>(AsyncListLiveAdTagDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>> PrepareAsyncListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>>(PrepareAsyncListLiveAdTagDetailsRaw(context, request, cq));
    }
    // Returns the specified ad tag detail for the specified live session.
    virtual ::grpc::Status GetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>> AsyncGetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>>(AsyncGetLiveAdTagDetailRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>> PrepareAsyncGetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>>(PrepareAsyncGetLiveAdTagDetailRaw(context, request, cq));
    }
    // Creates a slate.
    virtual ::grpc::Status CreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateSlateRaw(context, request, cq));
    }
    // Lists all slates in the specified project and location.
    virtual ::grpc::Status ListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListSlatesResponse>> AsyncListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListSlatesResponse>>(AsyncListSlatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListSlatesResponse>> PrepareAsyncListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListSlatesResponse>>(PrepareAsyncListSlatesRaw(context, request, cq));
    }
    // Returns the specified slate.
    virtual ::grpc::Status GetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::google::cloud::video::stitcher::v1::Slate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::Slate>> AsyncGetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::Slate>>(AsyncGetSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::Slate>> PrepareAsyncGetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::Slate>>(PrepareAsyncGetSlateRaw(context, request, cq));
    }
    // Updates the specified slate.
    virtual ::grpc::Status UpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSlateRaw(context, request, cq));
    }
    // Deletes the specified slate.
    virtual ::grpc::Status DeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteSlateRaw(context, request, cq));
    }
    // Creates a new live session.
    virtual ::grpc::Status CreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::google::cloud::video::stitcher::v1::LiveSession* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>> AsyncCreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>>(AsyncCreateLiveSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>> PrepareAsyncCreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>>(PrepareAsyncCreateLiveSessionRaw(context, request, cq));
    }
    // Returns the details for the specified live session.
    virtual ::grpc::Status GetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::google::cloud::video::stitcher::v1::LiveSession* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>> AsyncGetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>>(AsyncGetLiveSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>> PrepareAsyncGetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>>(PrepareAsyncGetLiveSessionRaw(context, request, cq));
    }
    // Registers the live config with the provided unique ID in
    // the specified region.
    virtual ::grpc::Status CreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateLiveConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateLiveConfigRaw(context, request, cq));
    }
    // Lists all live configs managed by the Video Stitcher that
    // belong to the specified project and region.
    virtual ::grpc::Status ListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>> AsyncListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>>(AsyncListLiveConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>> PrepareAsyncListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>>(PrepareAsyncListLiveConfigsRaw(context, request, cq));
    }
    // Returns the specified live config managed by the Video
    // Stitcher service.
    virtual ::grpc::Status GetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::google::cloud::video::stitcher::v1::LiveConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveConfig>> AsyncGetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveConfig>>(AsyncGetLiveConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveConfig>> PrepareAsyncGetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveConfig>>(PrepareAsyncGetLiveConfigRaw(context, request, cq));
    }
    // Deletes the specified live config.
    virtual ::grpc::Status DeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteLiveConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteLiveConfigRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new CDN key.
      virtual void CreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all CDN keys in the specified project and location.
      virtual void ListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified CDN key.
      virtual void GetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* request, ::google::cloud::video::stitcher::v1::CdnKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* request, ::google::cloud::video::stitcher::v1::CdnKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified CDN key.
      virtual void DeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified CDN key. Only update fields specified
      // in the call method body.
      virtual void UpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a client side playback VOD session and returns the full
      // tracking and playback metadata of the session.
      virtual void CreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the full tracking, playback metadata, and relevant ad-ops
      // logs for the specified VOD session.
      virtual void GetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of detailed stitching information of the specified VOD
      // session.
      virtual void ListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified stitching information for the specified VOD session.
      virtual void GetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Return the list of ad tag details for the specified VOD session.
      virtual void ListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified ad tag detail for the specified VOD session.
      virtual void GetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Return the list of ad tag details for the specified live session.
      virtual void ListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified ad tag detail for the specified live session.
      virtual void GetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a slate.
      virtual void CreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all slates in the specified project and location.
      virtual void ListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified slate.
      virtual void GetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest* request, ::google::cloud::video::stitcher::v1::Slate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest* request, ::google::cloud::video::stitcher::v1::Slate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified slate.
      virtual void UpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified slate.
      virtual void DeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new live session.
      virtual void CreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the details for the specified live session.
      virtual void GetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Registers the live config with the provided unique ID in
      // the specified region.
      virtual void CreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all live configs managed by the Video Stitcher that
      // belong to the specified project and region.
      virtual void ListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified live config managed by the Video
      // Stitcher service.
      virtual void GetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* request, ::google::cloud::video::stitcher::v1::LiveConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* request, ::google::cloud::video::stitcher::v1::LiveConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified live config.
      virtual void DeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* AsyncListCdnKeysRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* PrepareAsyncListCdnKeysRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::CdnKey>* AsyncGetCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::CdnKey>* PrepareAsyncGetCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>* AsyncCreateVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>* PrepareAsyncCreateVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>* AsyncGetVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodSession>* PrepareAsyncGetVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* AsyncListVodStitchDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* PrepareAsyncListVodStitchDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodStitchDetail>* AsyncGetVodStitchDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodStitchDetail>* PrepareAsyncGetVodStitchDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* AsyncListVodAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* PrepareAsyncListVodAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodAdTagDetail>* AsyncGetVodAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::VodAdTagDetail>* PrepareAsyncGetVodAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* AsyncListLiveAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* PrepareAsyncListLiveAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>* AsyncGetLiveAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>* PrepareAsyncGetLiveAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListSlatesResponse>* AsyncListSlatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListSlatesResponse>* PrepareAsyncListSlatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::Slate>* AsyncGetSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::Slate>* PrepareAsyncGetSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>* AsyncCreateLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>* PrepareAsyncCreateLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>* AsyncGetLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveSession>* PrepareAsyncGetLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* AsyncListLiveConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* PrepareAsyncListLiveConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveConfig>* AsyncGetLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::stitcher::v1::LiveConfig>* PrepareAsyncGetLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateCdnKeyRaw(context, request, cq));
    }
    ::grpc::Status ListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>> AsyncListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>>(AsyncListCdnKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>> PrepareAsyncListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>>(PrepareAsyncListCdnKeysRaw(context, request, cq));
    }
    ::grpc::Status GetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::google::cloud::video::stitcher::v1::CdnKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::CdnKey>> AsyncGetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::CdnKey>>(AsyncGetCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::CdnKey>> PrepareAsyncGetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::CdnKey>>(PrepareAsyncGetCdnKeyRaw(context, request, cq));
    }
    ::grpc::Status DeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteCdnKeyRaw(context, request, cq));
    }
    ::grpc::Status UpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateCdnKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateCdnKeyRaw(context, request, cq));
    }
    ::grpc::Status CreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::google::cloud::video::stitcher::v1::VodSession* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>> AsyncCreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>>(AsyncCreateVodSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>> PrepareAsyncCreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>>(PrepareAsyncCreateVodSessionRaw(context, request, cq));
    }
    ::grpc::Status GetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::google::cloud::video::stitcher::v1::VodSession* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>> AsyncGetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>>(AsyncGetVodSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>> PrepareAsyncGetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>>(PrepareAsyncGetVodSessionRaw(context, request, cq));
    }
    ::grpc::Status ListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>> AsyncListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>>(AsyncListVodStitchDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>> PrepareAsyncListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>>(PrepareAsyncListVodStitchDetailsRaw(context, request, cq));
    }
    ::grpc::Status GetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodStitchDetail>> AsyncGetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodStitchDetail>>(AsyncGetVodStitchDetailRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodStitchDetail>> PrepareAsyncGetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodStitchDetail>>(PrepareAsyncGetVodStitchDetailRaw(context, request, cq));
    }
    ::grpc::Status ListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>> AsyncListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>>(AsyncListVodAdTagDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>> PrepareAsyncListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>>(PrepareAsyncListVodAdTagDetailsRaw(context, request, cq));
    }
    ::grpc::Status GetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodAdTagDetail>> AsyncGetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodAdTagDetail>>(AsyncGetVodAdTagDetailRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodAdTagDetail>> PrepareAsyncGetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodAdTagDetail>>(PrepareAsyncGetVodAdTagDetailRaw(context, request, cq));
    }
    ::grpc::Status ListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>> AsyncListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>>(AsyncListLiveAdTagDetailsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>> PrepareAsyncListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>>(PrepareAsyncListLiveAdTagDetailsRaw(context, request, cq));
    }
    ::grpc::Status GetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>> AsyncGetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>>(AsyncGetLiveAdTagDetailRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>> PrepareAsyncGetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>>(PrepareAsyncGetLiveAdTagDetailRaw(context, request, cq));
    }
    ::grpc::Status CreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateSlateRaw(context, request, cq));
    }
    ::grpc::Status ListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListSlatesResponse>> AsyncListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListSlatesResponse>>(AsyncListSlatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListSlatesResponse>> PrepareAsyncListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListSlatesResponse>>(PrepareAsyncListSlatesRaw(context, request, cq));
    }
    ::grpc::Status GetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::google::cloud::video::stitcher::v1::Slate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::Slate>> AsyncGetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::Slate>>(AsyncGetSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::Slate>> PrepareAsyncGetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::Slate>>(PrepareAsyncGetSlateRaw(context, request, cq));
    }
    ::grpc::Status UpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSlateRaw(context, request, cq));
    }
    ::grpc::Status DeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteSlateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteSlateRaw(context, request, cq));
    }
    ::grpc::Status CreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::google::cloud::video::stitcher::v1::LiveSession* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>> AsyncCreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>>(AsyncCreateLiveSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>> PrepareAsyncCreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>>(PrepareAsyncCreateLiveSessionRaw(context, request, cq));
    }
    ::grpc::Status GetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::google::cloud::video::stitcher::v1::LiveSession* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>> AsyncGetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>>(AsyncGetLiveSessionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>> PrepareAsyncGetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>>(PrepareAsyncGetLiveSessionRaw(context, request, cq));
    }
    ::grpc::Status CreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateLiveConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateLiveConfigRaw(context, request, cq));
    }
    ::grpc::Status ListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>> AsyncListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>>(AsyncListLiveConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>> PrepareAsyncListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>>(PrepareAsyncListLiveConfigsRaw(context, request, cq));
    }
    ::grpc::Status GetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::google::cloud::video::stitcher::v1::LiveConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveConfig>> AsyncGetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveConfig>>(AsyncGetLiveConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveConfig>> PrepareAsyncGetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveConfig>>(PrepareAsyncGetLiveConfigRaw(context, request, cq));
    }
    ::grpc::Status DeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteLiveConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteLiveConfigRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCdnKeys(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* request, ::google::cloud::video::stitcher::v1::CdnKey* response, std::function<void(::grpc::Status)>) override;
      void GetCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* request, ::google::cloud::video::stitcher::v1::CdnKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCdnKey(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, std::function<void(::grpc::Status)>) override;
      void CreateVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, std::function<void(::grpc::Status)>) override;
      void GetVodSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVodStitchDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response, std::function<void(::grpc::Status)>) override;
      void GetVodStitchDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVodAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response, std::function<void(::grpc::Status)>) override;
      void GetVodAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListLiveAdTagDetails(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response, std::function<void(::grpc::Status)>) override;
      void GetLiveAdTagDetail(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSlates(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest* request, ::google::cloud::video::stitcher::v1::Slate* response, std::function<void(::grpc::Status)>) override;
      void GetSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest* request, ::google::cloud::video::stitcher::v1::Slate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteSlate(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, std::function<void(::grpc::Status)>) override;
      void CreateLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, std::function<void(::grpc::Status)>) override;
      void GetLiveSession(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListLiveConfigs(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* request, ::google::cloud::video::stitcher::v1::LiveConfig* response, std::function<void(::grpc::Status)>) override;
      void GetLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* request, ::google::cloud::video::stitcher::v1::LiveConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteLiveConfig(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* AsyncListCdnKeysRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* PrepareAsyncListCdnKeysRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::CdnKey>* AsyncGetCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::CdnKey>* PrepareAsyncGetCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateCdnKeyRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>* AsyncCreateVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>* PrepareAsyncCreateVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>* AsyncGetVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodSession>* PrepareAsyncGetVodSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* AsyncListVodStitchDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* PrepareAsyncListVodStitchDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodStitchDetail>* AsyncGetVodStitchDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodStitchDetail>* PrepareAsyncGetVodStitchDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* AsyncListVodAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* PrepareAsyncListVodAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodAdTagDetail>* AsyncGetVodAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::VodAdTagDetail>* PrepareAsyncGetVodAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* AsyncListLiveAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* PrepareAsyncListLiveAdTagDetailsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>* AsyncGetLiveAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>* PrepareAsyncGetLiveAdTagDetailRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListSlatesResponse>* AsyncListSlatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListSlatesResponse>* PrepareAsyncListSlatesRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::Slate>* AsyncGetSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::Slate>* PrepareAsyncGetSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteSlateRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>* AsyncCreateLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>* PrepareAsyncCreateLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>* AsyncGetLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveSession>* PrepareAsyncGetLiveSessionRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* AsyncListLiveConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* PrepareAsyncListLiveConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveConfig>* AsyncGetLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::stitcher::v1::LiveConfig>* PrepareAsyncGetLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteLiveConfigRaw(::grpc::ClientContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCdnKey_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCdnKeys_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCdnKey_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCdnKey_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCdnKey_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateVodSession_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVodSession_;
    const ::grpc::internal::RpcMethod rpcmethod_ListVodStitchDetails_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVodStitchDetail_;
    const ::grpc::internal::RpcMethod rpcmethod_ListVodAdTagDetails_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVodAdTagDetail_;
    const ::grpc::internal::RpcMethod rpcmethod_ListLiveAdTagDetails_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLiveAdTagDetail_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSlate_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSlates_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSlate_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSlate_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSlate_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateLiveSession_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLiveSession_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateLiveConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ListLiveConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLiveConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteLiveConfig_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new CDN key.
    virtual ::grpc::Status CreateCdnKey(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* request, ::google::longrunning::Operation* response);
    // Lists all CDN keys in the specified project and location.
    virtual ::grpc::Status ListCdnKeys(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response);
    // Returns the specified CDN key.
    virtual ::grpc::Status GetCdnKey(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* request, ::google::cloud::video::stitcher::v1::CdnKey* response);
    // Deletes the specified CDN key.
    virtual ::grpc::Status DeleteCdnKey(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* request, ::google::longrunning::Operation* response);
    // Updates the specified CDN key. Only update fields specified
    // in the call method body.
    virtual ::grpc::Status UpdateCdnKey(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* request, ::google::longrunning::Operation* response);
    // Creates a client side playback VOD session and returns the full
    // tracking and playback metadata of the session.
    virtual ::grpc::Status CreateVodSession(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response);
    // Returns the full tracking, playback metadata, and relevant ad-ops
    // logs for the specified VOD session.
    virtual ::grpc::Status GetVodSession(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response);
    // Returns a list of detailed stitching information of the specified VOD
    // session.
    virtual ::grpc::Status ListVodStitchDetails(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response);
    // Returns the specified stitching information for the specified VOD session.
    virtual ::grpc::Status GetVodStitchDetail(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response);
    // Return the list of ad tag details for the specified VOD session.
    virtual ::grpc::Status ListVodAdTagDetails(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response);
    // Returns the specified ad tag detail for the specified VOD session.
    virtual ::grpc::Status GetVodAdTagDetail(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response);
    // Return the list of ad tag details for the specified live session.
    virtual ::grpc::Status ListLiveAdTagDetails(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response);
    // Returns the specified ad tag detail for the specified live session.
    virtual ::grpc::Status GetLiveAdTagDetail(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response);
    // Creates a slate.
    virtual ::grpc::Status CreateSlate(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* request, ::google::longrunning::Operation* response);
    // Lists all slates in the specified project and location.
    virtual ::grpc::Status ListSlates(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response);
    // Returns the specified slate.
    virtual ::grpc::Status GetSlate(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest* request, ::google::cloud::video::stitcher::v1::Slate* response);
    // Updates the specified slate.
    virtual ::grpc::Status UpdateSlate(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* request, ::google::longrunning::Operation* response);
    // Deletes the specified slate.
    virtual ::grpc::Status DeleteSlate(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* request, ::google::longrunning::Operation* response);
    // Creates a new live session.
    virtual ::grpc::Status CreateLiveSession(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response);
    // Returns the details for the specified live session.
    virtual ::grpc::Status GetLiveSession(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response);
    // Registers the live config with the provided unique ID in
    // the specified region.
    virtual ::grpc::Status CreateLiveConfig(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* request, ::google::longrunning::Operation* response);
    // Lists all live configs managed by the Video Stitcher that
    // belong to the specified project and region.
    virtual ::grpc::Status ListLiveConfigs(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response);
    // Returns the specified live config managed by the Video
    // Stitcher service.
    virtual ::grpc::Status GetLiveConfig(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* request, ::google::cloud::video::stitcher::v1::LiveConfig* response);
    // Deletes the specified live config.
    virtual ::grpc::Status DeleteLiveConfig(::grpc::ServerContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCdnKey() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCdnKey(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCdnKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCdnKeys() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListCdnKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCdnKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCdnKeys(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCdnKey() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* /*request*/, ::google::cloud::video::stitcher::v1::CdnKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCdnKey(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::CdnKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCdnKey() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCdnKey(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCdnKey() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCdnKey(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateVodSession() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CreateVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVodSession(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::VodSession>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVodSession() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVodSession(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetVodSessionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::VodSession>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVodStitchDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVodStitchDetails() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListVodStitchDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodStitchDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVodStitchDetails(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVodStitchDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVodStitchDetail() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetVodStitchDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodStitchDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodStitchDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVodStitchDetail(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::VodStitchDetail>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVodAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVodAdTagDetails() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_ListVodAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVodAdTagDetails(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVodAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVodAdTagDetail() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GetVodAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVodAdTagDetail(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::VodAdTagDetail>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListLiveAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListLiveAdTagDetails() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListLiveAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLiveAdTagDetails(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLiveAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLiveAdTagDetail() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetLiveAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLiveAdTagDetail(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::LiveAdTagDetail>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSlate() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_CreateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSlate(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::CreateSlateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSlates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSlates() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ListSlates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSlates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListSlatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSlates(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::ListSlatesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::ListSlatesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSlate() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_GetSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetSlateRequest* /*request*/, ::google::cloud::video::stitcher::v1::Slate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSlate(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetSlateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::Slate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSlate() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_UpdateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSlate(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::UpdateSlateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSlate() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_DeleteSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSlate(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::DeleteSlateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateLiveSession() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_CreateLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLiveSession(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::LiveSession>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLiveSession() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_GetLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLiveSession(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::LiveSession>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateLiveConfig() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_CreateLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLiveConfig(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListLiveConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListLiveConfigs() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_ListLiveConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLiveConfigs(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLiveConfig() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_GetLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLiveConfig(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::stitcher::v1::LiveConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteLiveConfig() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_DeleteLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLiveConfig(::grpc::ServerContext* context, ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateCdnKey<WithAsyncMethod_ListCdnKeys<WithAsyncMethod_GetCdnKey<WithAsyncMethod_DeleteCdnKey<WithAsyncMethod_UpdateCdnKey<WithAsyncMethod_CreateVodSession<WithAsyncMethod_GetVodSession<WithAsyncMethod_ListVodStitchDetails<WithAsyncMethod_GetVodStitchDetail<WithAsyncMethod_ListVodAdTagDetails<WithAsyncMethod_GetVodAdTagDetail<WithAsyncMethod_ListLiveAdTagDetails<WithAsyncMethod_GetLiveAdTagDetail<WithAsyncMethod_CreateSlate<WithAsyncMethod_ListSlates<WithAsyncMethod_GetSlate<WithAsyncMethod_UpdateSlate<WithAsyncMethod_DeleteSlate<WithAsyncMethod_CreateLiveSession<WithAsyncMethod_GetLiveSession<WithAsyncMethod_CreateLiveConfig<WithAsyncMethod_ListLiveConfigs<WithAsyncMethod_GetLiveConfig<WithAsyncMethod_DeleteLiveConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCdnKey() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* request, ::google::longrunning::Operation* response) { return this->CreateCdnKey(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCdnKey(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCdnKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCdnKeys() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListCdnKeysRequest, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* request, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* response) { return this->ListCdnKeys(context, request, response); }));}
    void SetMessageAllocatorFor_ListCdnKeys(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::ListCdnKeysRequest, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListCdnKeysRequest, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCdnKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCdnKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCdnKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCdnKey() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetCdnKeyRequest, ::google::cloud::video::stitcher::v1::CdnKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* request, ::google::cloud::video::stitcher::v1::CdnKey* response) { return this->GetCdnKey(context, request, response); }));}
    void SetMessageAllocatorFor_GetCdnKey(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetCdnKeyRequest, ::google::cloud::video::stitcher::v1::CdnKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetCdnKeyRequest, ::google::cloud::video::stitcher::v1::CdnKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* /*request*/, ::google::cloud::video::stitcher::v1::CdnKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* /*request*/, ::google::cloud::video::stitcher::v1::CdnKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCdnKey() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCdnKey(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCdnKey(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCdnKey() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCdnKey(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCdnKey(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateVodSession() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response) { return this->CreateVodSession(context, request, response); }));}
    void SetMessageAllocatorFor_CreateVodSession(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::CreateVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVodSession(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVodSession() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* request, ::google::cloud::video::stitcher::v1::VodSession* response) { return this->GetVodSession(context, request, response); }));}
    void SetMessageAllocatorFor_GetVodSession(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVodSession(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListVodStitchDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVodStitchDetails() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* response) { return this->ListVodStitchDetails(context, request, response); }));}
    void SetMessageAllocatorFor_ListVodStitchDetails(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVodStitchDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodStitchDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVodStitchDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVodStitchDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVodStitchDetail() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest, ::google::cloud::video::stitcher::v1::VodStitchDetail>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* request, ::google::cloud::video::stitcher::v1::VodStitchDetail* response) { return this->GetVodStitchDetail(context, request, response); }));}
    void SetMessageAllocatorFor_GetVodStitchDetail(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest, ::google::cloud::video::stitcher::v1::VodStitchDetail>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest, ::google::cloud::video::stitcher::v1::VodStitchDetail>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVodStitchDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodStitchDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodStitchDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVodStitchDetail(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodStitchDetail* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListVodAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVodAdTagDetails() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* response) { return this->ListVodAdTagDetails(context, request, response); }));}
    void SetMessageAllocatorFor_ListVodAdTagDetails(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVodAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVodAdTagDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVodAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVodAdTagDetail() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest, ::google::cloud::video::stitcher::v1::VodAdTagDetail>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::VodAdTagDetail* response) { return this->GetVodAdTagDetail(context, request, response); }));}
    void SetMessageAllocatorFor_GetVodAdTagDetail(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest, ::google::cloud::video::stitcher::v1::VodAdTagDetail>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest, ::google::cloud::video::stitcher::v1::VodAdTagDetail>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVodAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVodAdTagDetail(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodAdTagDetail* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListLiveAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListLiveAdTagDetails() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* response) { return this->ListLiveAdTagDetails(context, request, response); }));}
    void SetMessageAllocatorFor_ListLiveAdTagDetails(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListLiveAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLiveAdTagDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLiveAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLiveAdTagDetail() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest, ::google::cloud::video::stitcher::v1::LiveAdTagDetail>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* request, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* response) { return this->GetLiveAdTagDetail(context, request, response); }));}
    void SetMessageAllocatorFor_GetLiveAdTagDetail(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest, ::google::cloud::video::stitcher::v1::LiveAdTagDetail>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest, ::google::cloud::video::stitcher::v1::LiveAdTagDetail>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLiveAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLiveAdTagDetail(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSlate() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateSlateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* request, ::google::longrunning::Operation* response) { return this->CreateSlate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSlate(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::CreateSlateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateSlateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSlates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSlates() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListSlatesRequest, ::google::cloud::video::stitcher::v1::ListSlatesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* request, ::google::cloud::video::stitcher::v1::ListSlatesResponse* response) { return this->ListSlates(context, request, response); }));}
    void SetMessageAllocatorFor_ListSlates(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::ListSlatesRequest, ::google::cloud::video::stitcher::v1::ListSlatesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListSlatesRequest, ::google::cloud::video::stitcher::v1::ListSlatesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSlates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSlates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListSlatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSlates(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListSlatesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSlate() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetSlateRequest, ::google::cloud::video::stitcher::v1::Slate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetSlateRequest* request, ::google::cloud::video::stitcher::v1::Slate* response) { return this->GetSlate(context, request, response); }));}
    void SetMessageAllocatorFor_GetSlate(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetSlateRequest, ::google::cloud::video::stitcher::v1::Slate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetSlateRequest, ::google::cloud::video::stitcher::v1::Slate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetSlateRequest* /*request*/, ::google::cloud::video::stitcher::v1::Slate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetSlateRequest* /*request*/, ::google::cloud::video::stitcher::v1::Slate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSlate() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::UpdateSlateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSlate(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSlate(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::UpdateSlateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::UpdateSlateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSlate() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::DeleteSlateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* request, ::google::longrunning::Operation* response) { return this->DeleteSlate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSlate(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::DeleteSlateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::DeleteSlateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateLiveSession() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response) { return this->CreateLiveSession(context, request, response); }));}
    void SetMessageAllocatorFor_CreateLiveSession(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLiveSession(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLiveSession() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* request, ::google::cloud::video::stitcher::v1::LiveSession* response) { return this->GetLiveSession(context, request, response); }));}
    void SetMessageAllocatorFor_GetLiveSession(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLiveSession(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateLiveConfig() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* request, ::google::longrunning::Operation* response) { return this->CreateLiveConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateLiveConfig(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLiveConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListLiveConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListLiveConfigs() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* request, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* response) { return this->ListLiveConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListLiveConfigs(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListLiveConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLiveConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLiveConfig() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetLiveConfigRequest, ::google::cloud::video::stitcher::v1::LiveConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* request, ::google::cloud::video::stitcher::v1::LiveConfig* response) { return this->GetLiveConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetLiveConfig(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::GetLiveConfigRequest, ::google::cloud::video::stitcher::v1::LiveConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::GetLiveConfigRequest, ::google::cloud::video::stitcher::v1::LiveConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLiveConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteLiveConfig() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* request, ::google::longrunning::Operation* response) { return this->DeleteLiveConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteLiveConfig(
        ::grpc::MessageAllocator< ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLiveConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateCdnKey<WithCallbackMethod_ListCdnKeys<WithCallbackMethod_GetCdnKey<WithCallbackMethod_DeleteCdnKey<WithCallbackMethod_UpdateCdnKey<WithCallbackMethod_CreateVodSession<WithCallbackMethod_GetVodSession<WithCallbackMethod_ListVodStitchDetails<WithCallbackMethod_GetVodStitchDetail<WithCallbackMethod_ListVodAdTagDetails<WithCallbackMethod_GetVodAdTagDetail<WithCallbackMethod_ListLiveAdTagDetails<WithCallbackMethod_GetLiveAdTagDetail<WithCallbackMethod_CreateSlate<WithCallbackMethod_ListSlates<WithCallbackMethod_GetSlate<WithCallbackMethod_UpdateSlate<WithCallbackMethod_DeleteSlate<WithCallbackMethod_CreateLiveSession<WithCallbackMethod_GetLiveSession<WithCallbackMethod_CreateLiveConfig<WithCallbackMethod_ListLiveConfigs<WithCallbackMethod_GetLiveConfig<WithCallbackMethod_DeleteLiveConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCdnKey() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCdnKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCdnKeys() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListCdnKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCdnKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCdnKey() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* /*request*/, ::google::cloud::video::stitcher::v1::CdnKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCdnKey() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCdnKey() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateVodSession() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CreateVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVodSession() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListVodStitchDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVodStitchDetails() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListVodStitchDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodStitchDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVodStitchDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVodStitchDetail() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetVodStitchDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodStitchDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodStitchDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListVodAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVodAdTagDetails() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_ListVodAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVodAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVodAdTagDetail() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GetVodAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListLiveAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListLiveAdTagDetails() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListLiveAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLiveAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLiveAdTagDetail() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetLiveAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSlate() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_CreateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSlates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSlates() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ListSlates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSlates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListSlatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSlate() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_GetSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetSlateRequest* /*request*/, ::google::cloud::video::stitcher::v1::Slate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSlate() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_UpdateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSlate() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_DeleteSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateLiveSession() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_CreateLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLiveSession() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_GetLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateLiveConfig() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_CreateLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListLiveConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListLiveConfigs() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_ListLiveConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLiveConfig() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_GetLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteLiveConfig() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_DeleteLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCdnKey() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCdnKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCdnKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCdnKeys() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListCdnKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCdnKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCdnKeys(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCdnKey() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* /*request*/, ::google::cloud::video::stitcher::v1::CdnKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCdnKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCdnKey() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCdnKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCdnKey() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCdnKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateVodSession() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CreateVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVodSession(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVodSession() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVodSession(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVodStitchDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVodStitchDetails() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListVodStitchDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodStitchDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVodStitchDetails(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVodStitchDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVodStitchDetail() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetVodStitchDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodStitchDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodStitchDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVodStitchDetail(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVodAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVodAdTagDetails() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_ListVodAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVodAdTagDetails(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVodAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVodAdTagDetail() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GetVodAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVodAdTagDetail(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListLiveAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListLiveAdTagDetails() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListLiveAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLiveAdTagDetails(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLiveAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLiveAdTagDetail() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetLiveAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLiveAdTagDetail(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSlate() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_CreateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSlate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSlates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSlates() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ListSlates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSlates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListSlatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSlates(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSlate() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_GetSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetSlateRequest* /*request*/, ::google::cloud::video::stitcher::v1::Slate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSlate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSlate() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_UpdateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSlate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSlate() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_DeleteSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSlate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateLiveSession() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_CreateLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLiveSession(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLiveSession() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_GetLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLiveSession(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateLiveConfig() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_CreateLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateLiveConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListLiveConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListLiveConfigs() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_ListLiveConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListLiveConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLiveConfig() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_GetLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLiveConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteLiveConfig() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_DeleteLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteLiveConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCdnKey() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCdnKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCdnKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCdnKeys() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCdnKeys(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCdnKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCdnKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCdnKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCdnKey() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCdnKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* /*request*/, ::google::cloud::video::stitcher::v1::CdnKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCdnKey() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCdnKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCdnKey() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCdnKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCdnKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateVodSession() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateVodSession(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVodSession(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVodSession() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVodSession(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVodSession(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVodStitchDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVodStitchDetails() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVodStitchDetails(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVodStitchDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodStitchDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVodStitchDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVodStitchDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVodStitchDetail() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVodStitchDetail(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVodStitchDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodStitchDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodStitchDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVodStitchDetail(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVodAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVodAdTagDetails() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVodAdTagDetails(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVodAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVodAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVodAdTagDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVodAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVodAdTagDetail() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVodAdTagDetail(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVodAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVodAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVodAdTagDetail(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListLiveAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListLiveAdTagDetails() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListLiveAdTagDetails(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListLiveAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLiveAdTagDetails(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLiveAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLiveAdTagDetail() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLiveAdTagDetail(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLiveAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLiveAdTagDetail(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSlate() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSlate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSlates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSlates() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSlates(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSlates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSlates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListSlatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSlates(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSlate() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSlate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetSlateRequest* /*request*/, ::google::cloud::video::stitcher::v1::Slate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSlate() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSlate(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSlate() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSlate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSlate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateLiveSession() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateLiveSession(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLiveSession(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLiveSession() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLiveSession(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLiveSession(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateLiveConfig() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateLiveConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateLiveConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListLiveConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListLiveConfigs() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListLiveConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListLiveConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListLiveConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListLiveConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLiveConfig() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLiveConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLiveConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteLiveConfig() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteLiveConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteLiveConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCdnKey() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCdnKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCdnKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::CreateCdnKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCdnKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCdnKeys() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::ListCdnKeysRequest, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::ListCdnKeysRequest, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* streamer) {
                       return this->StreamedListCdnKeys(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCdnKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCdnKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListCdnKeysRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListCdnKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCdnKeys(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::ListCdnKeysRequest,::google::cloud::video::stitcher::v1::ListCdnKeysResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCdnKey() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetCdnKeyRequest, ::google::cloud::video::stitcher::v1::CdnKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetCdnKeyRequest, ::google::cloud::video::stitcher::v1::CdnKey>* streamer) {
                       return this->StreamedGetCdnKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetCdnKeyRequest* /*request*/, ::google::cloud::video::stitcher::v1::CdnKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCdnKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetCdnKeyRequest,::google::cloud::video::stitcher::v1::CdnKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCdnKey() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCdnKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCdnKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::DeleteCdnKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCdnKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCdnKey() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCdnKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCdnKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCdnKey(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCdnKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::UpdateCdnKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateVodSession() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::CreateVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::CreateVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>* streamer) {
                       return this->StreamedCreateVodSession(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateVodSession(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::CreateVodSessionRequest,::google::cloud::video::stitcher::v1::VodSession>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVodSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVodSession() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetVodSessionRequest, ::google::cloud::video::stitcher::v1::VodSession>* streamer) {
                       return this->StreamedGetVodSession(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVodSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVodSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVodSession(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetVodSessionRequest,::google::cloud::video::stitcher::v1::VodSession>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVodStitchDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVodStitchDetails() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* streamer) {
                       return this->StreamedListVodStitchDetails(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVodStitchDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVodStitchDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVodStitchDetails(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::ListVodStitchDetailsRequest,::google::cloud::video::stitcher::v1::ListVodStitchDetailsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVodStitchDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVodStitchDetail() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest, ::google::cloud::video::stitcher::v1::VodStitchDetail>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest, ::google::cloud::video::stitcher::v1::VodStitchDetail>* streamer) {
                       return this->StreamedGetVodStitchDetail(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVodStitchDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVodStitchDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodStitchDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVodStitchDetail(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetVodStitchDetailRequest,::google::cloud::video::stitcher::v1::VodStitchDetail>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVodAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVodAdTagDetails() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* streamer) {
                       return this->StreamedListVodAdTagDetails(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVodAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVodAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVodAdTagDetails(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::ListVodAdTagDetailsRequest,::google::cloud::video::stitcher::v1::ListVodAdTagDetailsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVodAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVodAdTagDetail() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest, ::google::cloud::video::stitcher::v1::VodAdTagDetail>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest, ::google::cloud::video::stitcher::v1::VodAdTagDetail>* streamer) {
                       return this->StreamedGetVodAdTagDetail(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVodAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVodAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::VodAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVodAdTagDetail(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetVodAdTagDetailRequest,::google::cloud::video::stitcher::v1::VodAdTagDetail>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListLiveAdTagDetails : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListLiveAdTagDetails() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* streamer) {
                       return this->StreamedListLiveAdTagDetails(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListLiveAdTagDetails() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListLiveAdTagDetails(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListLiveAdTagDetails(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsRequest,::google::cloud::video::stitcher::v1::ListLiveAdTagDetailsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLiveAdTagDetail : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLiveAdTagDetail() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest, ::google::cloud::video::stitcher::v1::LiveAdTagDetail>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest, ::google::cloud::video::stitcher::v1::LiveAdTagDetail>* streamer) {
                       return this->StreamedGetLiveAdTagDetail(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLiveAdTagDetail() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLiveAdTagDetail(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveAdTagDetail* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLiveAdTagDetail(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetLiveAdTagDetailRequest,::google::cloud::video::stitcher::v1::LiveAdTagDetail>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSlate() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::CreateSlateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::CreateSlateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateSlate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSlate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::CreateSlateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSlates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSlates() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::ListSlatesRequest, ::google::cloud::video::stitcher::v1::ListSlatesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::ListSlatesRequest, ::google::cloud::video::stitcher::v1::ListSlatesResponse>* streamer) {
                       return this->StreamedListSlates(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSlates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSlates(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListSlatesRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListSlatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSlates(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::ListSlatesRequest,::google::cloud::video::stitcher::v1::ListSlatesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSlate() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetSlateRequest, ::google::cloud::video::stitcher::v1::Slate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetSlateRequest, ::google::cloud::video::stitcher::v1::Slate>* streamer) {
                       return this->StreamedGetSlate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetSlateRequest* /*request*/, ::google::cloud::video::stitcher::v1::Slate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSlate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetSlateRequest,::google::cloud::video::stitcher::v1::Slate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSlate() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::UpdateSlateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::UpdateSlateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSlate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::UpdateSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSlate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::UpdateSlateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSlate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSlate() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::DeleteSlateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::DeleteSlateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteSlate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSlate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSlate(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteSlateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSlate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::DeleteSlateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateLiveSession() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>* streamer) {
                       return this->StreamedCreateLiveSession(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateLiveSession(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::CreateLiveSessionRequest,::google::cloud::video::stitcher::v1::LiveSession>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLiveSession : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLiveSession() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetLiveSessionRequest, ::google::cloud::video::stitcher::v1::LiveSession>* streamer) {
                       return this->StreamedGetLiveSession(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLiveSession() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLiveSession(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveSessionRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveSession* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLiveSession(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetLiveSessionRequest,::google::cloud::video::stitcher::v1::LiveSession>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateLiveConfig() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateLiveConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateLiveConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::CreateLiveConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListLiveConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListLiveConfigs() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* streamer) {
                       return this->StreamedListLiveConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListLiveConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListLiveConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest* /*request*/, ::google::cloud::video::stitcher::v1::ListLiveConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListLiveConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::ListLiveConfigsRequest,::google::cloud::video::stitcher::v1::ListLiveConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLiveConfig() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::GetLiveConfigRequest, ::google::cloud::video::stitcher::v1::LiveConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::GetLiveConfigRequest, ::google::cloud::video::stitcher::v1::LiveConfig>* streamer) {
                       return this->StreamedGetLiveConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::GetLiveConfigRequest* /*request*/, ::google::cloud::video::stitcher::v1::LiveConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLiveConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::GetLiveConfigRequest,::google::cloud::video::stitcher::v1::LiveConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteLiveConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteLiveConfig() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteLiveConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteLiveConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteLiveConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteLiveConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::stitcher::v1::DeleteLiveConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateCdnKey<WithStreamedUnaryMethod_ListCdnKeys<WithStreamedUnaryMethod_GetCdnKey<WithStreamedUnaryMethod_DeleteCdnKey<WithStreamedUnaryMethod_UpdateCdnKey<WithStreamedUnaryMethod_CreateVodSession<WithStreamedUnaryMethod_GetVodSession<WithStreamedUnaryMethod_ListVodStitchDetails<WithStreamedUnaryMethod_GetVodStitchDetail<WithStreamedUnaryMethod_ListVodAdTagDetails<WithStreamedUnaryMethod_GetVodAdTagDetail<WithStreamedUnaryMethod_ListLiveAdTagDetails<WithStreamedUnaryMethod_GetLiveAdTagDetail<WithStreamedUnaryMethod_CreateSlate<WithStreamedUnaryMethod_ListSlates<WithStreamedUnaryMethod_GetSlate<WithStreamedUnaryMethod_UpdateSlate<WithStreamedUnaryMethod_DeleteSlate<WithStreamedUnaryMethod_CreateLiveSession<WithStreamedUnaryMethod_GetLiveSession<WithStreamedUnaryMethod_CreateLiveConfig<WithStreamedUnaryMethod_ListLiveConfigs<WithStreamedUnaryMethod_GetLiveConfig<WithStreamedUnaryMethod_DeleteLiveConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateCdnKey<WithStreamedUnaryMethod_ListCdnKeys<WithStreamedUnaryMethod_GetCdnKey<WithStreamedUnaryMethod_DeleteCdnKey<WithStreamedUnaryMethod_UpdateCdnKey<WithStreamedUnaryMethod_CreateVodSession<WithStreamedUnaryMethod_GetVodSession<WithStreamedUnaryMethod_ListVodStitchDetails<WithStreamedUnaryMethod_GetVodStitchDetail<WithStreamedUnaryMethod_ListVodAdTagDetails<WithStreamedUnaryMethod_GetVodAdTagDetail<WithStreamedUnaryMethod_ListLiveAdTagDetails<WithStreamedUnaryMethod_GetLiveAdTagDetail<WithStreamedUnaryMethod_CreateSlate<WithStreamedUnaryMethod_ListSlates<WithStreamedUnaryMethod_GetSlate<WithStreamedUnaryMethod_UpdateSlate<WithStreamedUnaryMethod_DeleteSlate<WithStreamedUnaryMethod_CreateLiveSession<WithStreamedUnaryMethod_GetLiveSession<WithStreamedUnaryMethod_CreateLiveConfig<WithStreamedUnaryMethod_ListLiveConfigs<WithStreamedUnaryMethod_GetLiveConfig<WithStreamedUnaryMethod_DeleteLiveConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace stitcher
}  // namespace video
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fvideo_2fstitcher_2fv1_2fvideo_5fstitcher_5fservice_2eproto__INCLUDED
